/* Job.c generated by valac 0.56.13, the Vala compiler
 * generated from Job.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2015 - 2022 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <glib.h>
#include "cups/ipp.h"
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include "cups/cups.h"
#include <time.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

enum  {
	PRINTERS_JOB_0_PROPERTY,
	PRINTERS_JOB_PRINTER_PROPERTY,
	PRINTERS_JOB_UID_PROPERTY,
	PRINTERS_JOB_STATE_PROPERTY,
	PRINTERS_JOB_TITLE_PROPERTY,
	PRINTERS_JOB_FORMAT_PROPERTY,
	PRINTERS_JOB_REASONS_PROPERTY,
	PRINTERS_JOB_CREATION_TIME_PROPERTY,
	PRINTERS_JOB_COMPLETED_TIME_PROPERTY,
	PRINTERS_JOB_IS_ONGOING_PROPERTY,
	PRINTERS_JOB_NUM_PROPERTIES
};
static GParamSpec* printers_job_properties[PRINTERS_JOB_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	PRINTERS_JOB_STATE_CHANGED_SIGNAL,
	PRINTERS_JOB_NUM_SIGNALS
};
static guint printers_job_signals[PRINTERS_JOB_NUM_SIGNALS] = {0};

struct _PrintersJobPrivate {
	PrintersPrinter* _printer;
	gint _uid;
	ipp_jstate_t _state;
	gchar* _title;
	gchar* _format;
	gchar* _reasons;
	GDateTime* _creation_time;
	GDateTime* _completed_time;
};

static gint PrintersJob_private_offset;
static gpointer printers_job_parent_class = NULL;

static void printers_job_on_job_state_changed (PrintersJob* self,
                                        const gchar* text,
                                        const gchar* printer_uri,
                                        const gchar* name,
                                        guint32 printer_state,
                                        const gchar* state_reasons,
                                        gboolean is_accepting_jobs,
                                        guint32 job_id,
                                        guint32 job_state,
                                        const gchar* job_state_reason,
                                        const gchar* job_name,
                                        guint32 job_impressions_completed);
static void _printers_job_on_job_state_changed_cups_notifier_job_progress (CupsNotifier* _sender,
                                                                    const gchar* text,
                                                                    const gchar* printer_uri,
                                                                    const gchar* name,
                                                                    guint32 state,
                                                                    const gchar* state_reasons,
                                                                    gboolean is_accepting_jobs,
                                                                    guint32 job_id,
                                                                    guint32 job_state,
                                                                    const gchar* job_state_reason,
                                                                    const gchar* job_name,
                                                                    guint32 job_impressions_completed,
                                                                    gpointer self);
static void _printers_job_on_job_state_changed_cups_notifier_job_completed (CupsNotifier* _sender,
                                                                     const gchar* text,
                                                                     const gchar* printer_uri,
                                                                     const gchar* name,
                                                                     guint32 state,
                                                                     const gchar* state_reasons,
                                                                     gboolean is_accepting_jobs,
                                                                     guint32 job_id,
                                                                     guint32 job_state,
                                                                     const gchar* job_state_reason,
                                                                     const gchar* job_name,
                                                                     guint32 job_impressions_completed,
                                                                     gpointer self);
static void _printers_job_on_job_state_changed_cups_notifier_job_state_changed (CupsNotifier* _sender,
                                                                         const gchar* text,
                                                                         const gchar* printer_uri,
                                                                         const gchar* name,
                                                                         guint32 state,
                                                                         const gchar* state_reasons,
                                                                         gboolean is_accepting_jobs,
                                                                         guint32 job_id,
                                                                         guint32 job_state,
                                                                         const gchar* job_state_reason,
                                                                         const gchar* job_name,
                                                                         guint32 job_impressions_completed,
                                                                         gpointer self);
static void printers_job_finalize (GObject * obj);
static GType printers_job_get_type_once (void);
static void _vala_printers_job_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_printers_job_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
printers_job_get_instance_private (PrintersJob* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersJob_private_offset);
}

static void
_printers_job_on_job_state_changed_cups_notifier_job_progress (CupsNotifier* _sender,
                                                               const gchar* text,
                                                               const gchar* printer_uri,
                                                               const gchar* name,
                                                               guint32 state,
                                                               const gchar* state_reasons,
                                                               gboolean is_accepting_jobs,
                                                               guint32 job_id,
                                                               guint32 job_state,
                                                               const gchar* job_state_reason,
                                                               const gchar* job_name,
                                                               guint32 job_impressions_completed,
                                                               gpointer self)
{
#line 51 "../src/Objects/Job.vala"
	printers_job_on_job_state_changed ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
#line 161 "Job.c"
}

static void
_printers_job_on_job_state_changed_cups_notifier_job_completed (CupsNotifier* _sender,
                                                                const gchar* text,
                                                                const gchar* printer_uri,
                                                                const gchar* name,
                                                                guint32 state,
                                                                const gchar* state_reasons,
                                                                gboolean is_accepting_jobs,
                                                                guint32 job_id,
                                                                guint32 job_state,
                                                                const gchar* job_state_reason,
                                                                const gchar* job_name,
                                                                guint32 job_impressions_completed,
                                                                gpointer self)
{
#line 52 "../src/Objects/Job.vala"
	printers_job_on_job_state_changed ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
#line 181 "Job.c"
}

static void
_printers_job_on_job_state_changed_cups_notifier_job_state_changed (CupsNotifier* _sender,
                                                                    const gchar* text,
                                                                    const gchar* printer_uri,
                                                                    const gchar* name,
                                                                    guint32 state,
                                                                    const gchar* state_reasons,
                                                                    gboolean is_accepting_jobs,
                                                                    guint32 job_id,
                                                                    guint32 job_state,
                                                                    const gchar* job_state_reason,
                                                                    const gchar* job_name,
                                                                    guint32 job_impressions_completed,
                                                                    gpointer self)
{
#line 53 "../src/Objects/Job.vala"
	printers_job_on_job_state_changed ((PrintersJob*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
#line 201 "Job.c"
}

PrintersJob*
printers_job_construct (GType object_type,
                        cups_job_t* cjob,
                        PrintersPrinter* printer)
{
	PrintersJob * self = NULL;
	GDateTime* _tmp0_ = NULL;
	cups_job_t _tmp1_;
	GDateTime* _tmp7_ = NULL;
	cups_job_t _tmp8_;
	cups_job_t _tmp11_;
	cups_job_t _tmp12_;
	const gchar* _tmp13_;
	cups_job_t _tmp14_;
	const gchar* _tmp15_;
	cups_job_t _tmp16_;
	CupsNotifier* notifier = NULL;
	CupsNotifier* _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	ipp_jstate_t _tmp20_;
#line 35 "../src/Objects/Job.vala"
	g_return_val_if_fail (cjob != NULL, NULL);
#line 35 "../src/Objects/Job.vala"
	g_return_val_if_fail (printer != NULL, NULL);
#line 37 "../src/Objects/Job.vala"
	_tmp1_ = *cjob;
#line 37 "../src/Objects/Job.vala"
	if (_tmp1_.creation_time > ((time_t) 0)) {
#line 233 "Job.c"
		cups_job_t _tmp2_;
		GDateTime* _tmp3_;
#line 37 "../src/Objects/Job.vala"
		_tmp2_ = *cjob;
#line 37 "../src/Objects/Job.vala"
		_tmp3_ = g_date_time_new_from_unix_local ((gint64) _tmp2_.creation_time);
#line 37 "../src/Objects/Job.vala"
		_g_date_time_unref0 (_tmp0_);
#line 37 "../src/Objects/Job.vala"
		_tmp0_ = _tmp3_;
#line 244 "Job.c"
	} else {
		GTimeZone* _tmp4_;
		GTimeZone* _tmp5_;
		GDateTime* _tmp6_;
#line 37 "../src/Objects/Job.vala"
		_tmp4_ = g_time_zone_new_local ();
#line 37 "../src/Objects/Job.vala"
		_tmp5_ = _tmp4_;
#line 37 "../src/Objects/Job.vala"
		_tmp6_ = g_date_time_new_now (_tmp5_);
#line 37 "../src/Objects/Job.vala"
		_g_date_time_unref0 (_tmp0_);
#line 37 "../src/Objects/Job.vala"
		_tmp0_ = _tmp6_;
#line 37 "../src/Objects/Job.vala"
		_g_time_zone_unref0 (_tmp5_);
#line 261 "Job.c"
	}
#line 38 "../src/Objects/Job.vala"
	_tmp8_ = *cjob;
#line 38 "../src/Objects/Job.vala"
	if (_tmp8_.completed_time > ((time_t) 0)) {
#line 267 "Job.c"
		cups_job_t _tmp9_;
		GDateTime* _tmp10_;
#line 38 "../src/Objects/Job.vala"
		_tmp9_ = *cjob;
#line 38 "../src/Objects/Job.vala"
		_tmp10_ = g_date_time_new_from_unix_local ((gint64) _tmp9_.completed_time);
#line 38 "../src/Objects/Job.vala"
		_g_date_time_unref0 (_tmp7_);
#line 38 "../src/Objects/Job.vala"
		_tmp7_ = _tmp10_;
#line 278 "Job.c"
	} else {
#line 38 "../src/Objects/Job.vala"
		_g_date_time_unref0 (_tmp7_);
#line 38 "../src/Objects/Job.vala"
		_tmp7_ = NULL;
#line 284 "Job.c"
	}
#line 36 "../src/Objects/Job.vala"
	_tmp11_ = *cjob;
#line 36 "../src/Objects/Job.vala"
	_tmp12_ = *cjob;
#line 36 "../src/Objects/Job.vala"
	_tmp13_ = _tmp12_.title;
#line 36 "../src/Objects/Job.vala"
	_tmp14_ = *cjob;
#line 36 "../src/Objects/Job.vala"
	_tmp15_ = _tmp14_.format;
#line 36 "../src/Objects/Job.vala"
	_tmp16_ = *cjob;
#line 36 "../src/Objects/Job.vala"
	self = (PrintersJob*) g_object_new (object_type, "creation-time", _tmp0_, "completed-time", _tmp7_, "state", _tmp11_.state, "title", _tmp13_, "printer", printer, "format", _tmp15_, "uid", _tmp16_.id, NULL);
#line 46 "../src/Objects/Job.vala"
	_tmp17_ = cups_notifier_get_default ();
#line 46 "../src/Objects/Job.vala"
	notifier = _tmp17_;
#line 47 "../src/Objects/Job.vala"
	_tmp20_ = self->priv->_state;
#line 47 "../src/Objects/Job.vala"
	if (_tmp20_ != IPP_JOB_CANCELED) {
#line 308 "Job.c"
		ipp_jstate_t _tmp21_;
#line 48 "../src/Objects/Job.vala"
		_tmp21_ = self->priv->_state;
#line 48 "../src/Objects/Job.vala"
		_tmp19_ = _tmp21_ != IPP_JOB_ABORTED;
#line 314 "Job.c"
	} else {
#line 47 "../src/Objects/Job.vala"
		_tmp19_ = FALSE;
#line 318 "Job.c"
	}
#line 47 "../src/Objects/Job.vala"
	if (_tmp19_) {
#line 322 "Job.c"
		ipp_jstate_t _tmp22_;
#line 49 "../src/Objects/Job.vala"
		_tmp22_ = self->priv->_state;
#line 49 "../src/Objects/Job.vala"
		_tmp18_ = _tmp22_ != IPP_JOB_COMPLETED;
#line 328 "Job.c"
	} else {
#line 47 "../src/Objects/Job.vala"
		_tmp18_ = FALSE;
#line 332 "Job.c"
	}
#line 47 "../src/Objects/Job.vala"
	if (_tmp18_) {
#line 336 "Job.c"
		CupsNotifier* _tmp23_;
		CupsNotifier* _tmp24_;
		CupsNotifier* _tmp25_;
#line 51 "../src/Objects/Job.vala"
		_tmp23_ = notifier;
#line 51 "../src/Objects/Job.vala"
		g_signal_connect_object (_tmp23_, "job-progress", (GCallback) _printers_job_on_job_state_changed_cups_notifier_job_progress, self, 0);
#line 52 "../src/Objects/Job.vala"
		_tmp24_ = notifier;
#line 52 "../src/Objects/Job.vala"
		g_signal_connect_object (_tmp24_, "job-completed", (GCallback) _printers_job_on_job_state_changed_cups_notifier_job_completed, self, 0);
#line 53 "../src/Objects/Job.vala"
		_tmp25_ = notifier;
#line 53 "../src/Objects/Job.vala"
		g_signal_connect_object (_tmp25_, "job-state-changed", (GCallback) _printers_job_on_job_state_changed_cups_notifier_job_state_changed, self, 0);
#line 352 "Job.c"
	}
#line 35 "../src/Objects/Job.vala"
	_g_date_time_unref0 (_tmp7_);
#line 35 "../src/Objects/Job.vala"
	_g_date_time_unref0 (_tmp0_);
#line 35 "../src/Objects/Job.vala"
	return self;
#line 360 "Job.c"
}

PrintersJob*
printers_job_new (cups_job_t* cjob,
                  PrintersPrinter* printer)
{
#line 35 "../src/Objects/Job.vala"
	return printers_job_construct (PRINTERS_TYPE_JOB, cjob, printer);
#line 369 "Job.c"
}

static void
printers_job_on_job_state_changed (PrintersJob* self,
                                   const gchar* text,
                                   const gchar* printer_uri,
                                   const gchar* name,
                                   guint32 printer_state,
                                   const gchar* state_reasons,
                                   gboolean is_accepting_jobs,
                                   guint32 job_id,
                                   guint32 job_state,
                                   const gchar* job_state_reason,
                                   const gchar* job_name,
                                   guint32 job_impressions_completed)
{
	gint _tmp0_;
#line 57 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/Objects/Job.vala"
	g_return_if_fail (text != NULL);
#line 57 "../src/Objects/Job.vala"
	g_return_if_fail (printer_uri != NULL);
#line 57 "../src/Objects/Job.vala"
	g_return_if_fail (name != NULL);
#line 57 "../src/Objects/Job.vala"
	g_return_if_fail (state_reasons != NULL);
#line 57 "../src/Objects/Job.vala"
	g_return_if_fail (job_state_reason != NULL);
#line 57 "../src/Objects/Job.vala"
	g_return_if_fail (job_name != NULL);
#line 60 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_uid;
#line 60 "../src/Objects/Job.vala"
	if (job_id == ((guint32) _tmp0_)) {
#line 405 "Job.c"
		gboolean _tmp1_ = FALSE;
		ipp_jstate_t _tmp2_;
#line 61 "../src/Objects/Job.vala"
		printers_job_set_state (self, (ipp_jstate_t) job_state);
#line 62 "../src/Objects/Job.vala"
		_tmp2_ = self->priv->_state;
#line 62 "../src/Objects/Job.vala"
		if (_tmp2_ == IPP_JOB_COMPLETED) {
#line 414 "Job.c"
			GDateTime* _tmp3_;
#line 63 "../src/Objects/Job.vala"
			_tmp3_ = self->priv->_completed_time;
#line 63 "../src/Objects/Job.vala"
			_tmp1_ = _tmp3_ == NULL;
#line 420 "Job.c"
		} else {
#line 62 "../src/Objects/Job.vala"
			_tmp1_ = FALSE;
#line 424 "Job.c"
		}
#line 62 "../src/Objects/Job.vala"
		if (_tmp1_) {
#line 428 "Job.c"
			GTimeZone* _tmp4_;
			GTimeZone* _tmp5_;
			GDateTime* _tmp6_;
			GDateTime* _tmp7_;
#line 65 "../src/Objects/Job.vala"
			_tmp4_ = g_time_zone_new_local ();
#line 65 "../src/Objects/Job.vala"
			_tmp5_ = _tmp4_;
#line 65 "../src/Objects/Job.vala"
			_tmp6_ = g_date_time_new_now (_tmp5_);
#line 65 "../src/Objects/Job.vala"
			_tmp7_ = _tmp6_;
#line 65 "../src/Objects/Job.vala"
			printers_job_set_completed_time (self, _tmp7_);
#line 65 "../src/Objects/Job.vala"
			_g_date_time_unref0 (_tmp7_);
#line 65 "../src/Objects/Job.vala"
			_g_time_zone_unref0 (_tmp5_);
#line 447 "Job.c"
		}
#line 68 "../src/Objects/Job.vala"
		g_signal_emit (self, printers_job_signals[PRINTERS_JOB_STATE_CHANGED_SIGNAL], 0);
#line 451 "Job.c"
	}
}

void
printers_job_pause (PrintersJob* self)
{
	GError* _inner_error0_ = NULL;
#line 72 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 461 "Job.c"
	{
		CupsPkHelper* _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 74 "../src/Objects/Job.vala"
		_tmp0_ = cups_get_pk_helper ();
#line 74 "../src/Objects/Job.vala"
		_tmp1_ = self->priv->_uid;
#line 74 "../src/Objects/Job.vala"
		_tmp2_ = cups_pk_helper_job_set_hold_until (_tmp0_, _tmp1_, "indefinite", &_inner_error0_);
#line 74 "../src/Objects/Job.vala"
		_tmp3_ = _tmp2_;
#line 74 "../src/Objects/Job.vala"
		_g_free0 (_tmp3_);
#line 74 "../src/Objects/Job.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 479 "Job.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 73 "../src/Objects/Job.vala"
		e = _inner_error0_;
#line 73 "../src/Objects/Job.vala"
		_inner_error0_ = NULL;
#line 76 "../src/Objects/Job.vala"
		_tmp4_ = e;
#line 76 "../src/Objects/Job.vala"
		_tmp5_ = _tmp4_->message;
#line 76 "../src/Objects/Job.vala"
		g_critical ("Job.vala:76: %s", _tmp5_);
#line 73 "../src/Objects/Job.vala"
		_g_error_free0 (e);
#line 501 "Job.c"
	}
	__finally0:
#line 73 "../src/Objects/Job.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/Objects/Job.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 73 "../src/Objects/Job.vala"
		g_clear_error (&_inner_error0_);
#line 73 "../src/Objects/Job.vala"
		return;
#line 512 "Job.c"
	}
}

void
printers_job_stop (PrintersJob* self)
{
	GError* _inner_error0_ = NULL;
#line 80 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 522 "Job.c"
	{
		CupsPkHelper* _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 82 "../src/Objects/Job.vala"
		_tmp0_ = cups_get_pk_helper ();
#line 82 "../src/Objects/Job.vala"
		_tmp1_ = self->priv->_uid;
#line 82 "../src/Objects/Job.vala"
		_tmp2_ = cups_pk_helper_job_cancel_purge (_tmp0_, _tmp1_, FALSE, &_inner_error0_);
#line 82 "../src/Objects/Job.vala"
		_tmp3_ = _tmp2_;
#line 82 "../src/Objects/Job.vala"
		_g_free0 (_tmp3_);
#line 82 "../src/Objects/Job.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 540 "Job.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 81 "../src/Objects/Job.vala"
		e = _inner_error0_;
#line 81 "../src/Objects/Job.vala"
		_inner_error0_ = NULL;
#line 84 "../src/Objects/Job.vala"
		_tmp4_ = e;
#line 84 "../src/Objects/Job.vala"
		_tmp5_ = _tmp4_->message;
#line 84 "../src/Objects/Job.vala"
		g_critical ("Job.vala:84: %s", _tmp5_);
#line 81 "../src/Objects/Job.vala"
		_g_error_free0 (e);
#line 562 "Job.c"
	}
	__finally0:
#line 81 "../src/Objects/Job.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../src/Objects/Job.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../src/Objects/Job.vala"
		g_clear_error (&_inner_error0_);
#line 81 "../src/Objects/Job.vala"
		return;
#line 573 "Job.c"
	}
}

void
printers_job_purge (PrintersJob* self)
{
	GError* _inner_error0_ = NULL;
#line 88 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 583 "Job.c"
	{
		CupsPkHelper* _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 90 "../src/Objects/Job.vala"
		_tmp0_ = cups_get_pk_helper ();
#line 90 "../src/Objects/Job.vala"
		_tmp1_ = self->priv->_uid;
#line 90 "../src/Objects/Job.vala"
		_tmp2_ = cups_pk_helper_job_cancel_purge (_tmp0_, _tmp1_, TRUE, &_inner_error0_);
#line 90 "../src/Objects/Job.vala"
		_tmp3_ = _tmp2_;
#line 90 "../src/Objects/Job.vala"
		_g_free0 (_tmp3_);
#line 90 "../src/Objects/Job.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 601 "Job.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 89 "../src/Objects/Job.vala"
		e = _inner_error0_;
#line 89 "../src/Objects/Job.vala"
		_inner_error0_ = NULL;
#line 92 "../src/Objects/Job.vala"
		_tmp4_ = e;
#line 92 "../src/Objects/Job.vala"
		_tmp5_ = _tmp4_->message;
#line 92 "../src/Objects/Job.vala"
		g_critical ("Job.vala:92: %s", _tmp5_);
#line 89 "../src/Objects/Job.vala"
		_g_error_free0 (e);
#line 623 "Job.c"
	}
	__finally0:
#line 89 "../src/Objects/Job.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 89 "../src/Objects/Job.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 89 "../src/Objects/Job.vala"
		g_clear_error (&_inner_error0_);
#line 89 "../src/Objects/Job.vala"
		return;
#line 634 "Job.c"
	}
}

void
printers_job_resume (PrintersJob* self)
{
	GError* _inner_error0_ = NULL;
#line 96 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 644 "Job.c"
	{
		CupsPkHelper* _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 98 "../src/Objects/Job.vala"
		_tmp0_ = cups_get_pk_helper ();
#line 98 "../src/Objects/Job.vala"
		_tmp1_ = self->priv->_uid;
#line 98 "../src/Objects/Job.vala"
		_tmp2_ = cups_pk_helper_job_set_hold_until (_tmp0_, _tmp1_, "no-hold", &_inner_error0_);
#line 98 "../src/Objects/Job.vala"
		_tmp3_ = _tmp2_;
#line 98 "../src/Objects/Job.vala"
		_g_free0 (_tmp3_);
#line 98 "../src/Objects/Job.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 662 "Job.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 97 "../src/Objects/Job.vala"
		e = _inner_error0_;
#line 97 "../src/Objects/Job.vala"
		_inner_error0_ = NULL;
#line 100 "../src/Objects/Job.vala"
		_tmp4_ = e;
#line 100 "../src/Objects/Job.vala"
		_tmp5_ = _tmp4_->message;
#line 100 "../src/Objects/Job.vala"
		g_critical ("Job.vala:100: %s", _tmp5_);
#line 97 "../src/Objects/Job.vala"
		_g_error_free0 (e);
#line 684 "Job.c"
	}
	__finally0:
#line 97 "../src/Objects/Job.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "../src/Objects/Job.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 97 "../src/Objects/Job.vala"
		g_clear_error (&_inner_error0_);
#line 97 "../src/Objects/Job.vala"
		return;
#line 695 "Job.c"
	}
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 110 "../src/Objects/Job.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 704 "Job.c"
}

GDateTime*
printers_job_get_display_time (PrintersJob* self)
{
	ipp_jstate_t _tmp0_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* result;
#line 104 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_state;
#line 105 "../src/Objects/Job.vala"
	switch (_tmp0_) {
#line 105 "../src/Objects/Job.vala"
		case IPP_JOB_CANCELED:
#line 105 "../src/Objects/Job.vala"
		case IPP_JOB_ABORTED:
#line 724 "Job.c"
		{
#line 108 "../src/Objects/Job.vala"
			result = NULL;
#line 108 "../src/Objects/Job.vala"
			return result;
#line 730 "Job.c"
		}
#line 105 "../src/Objects/Job.vala"
		case IPP_JOB_COMPLETED:
#line 734 "Job.c"
		{
			GDateTime* _tmp1_;
			GDateTime* _tmp2_;
#line 110 "../src/Objects/Job.vala"
			_tmp1_ = self->priv->_completed_time;
#line 110 "../src/Objects/Job.vala"
			_tmp2_ = _g_date_time_ref0 (_tmp1_);
#line 110 "../src/Objects/Job.vala"
			result = _tmp2_;
#line 110 "../src/Objects/Job.vala"
			return result;
#line 746 "Job.c"
		}
#line 105 "../src/Objects/Job.vala"
		case IPP_JOB_STOPPED:
#line 105 "../src/Objects/Job.vala"
		case IPP_JOB_PENDING:
#line 105 "../src/Objects/Job.vala"
		case IPP_JOB_PROCESSING:
#line 105 "../src/Objects/Job.vala"
		case IPP_JOB_HELD:
#line 756 "Job.c"
		{
#line 115 "../src/Objects/Job.vala"
			break;
#line 760 "Job.c"
		}
		default:
#line 105 "../src/Objects/Job.vala"
		break;
#line 765 "Job.c"
	}
#line 118 "../src/Objects/Job.vala"
	_tmp3_ = self->priv->_creation_time;
#line 118 "../src/Objects/Job.vala"
	_tmp4_ = _g_date_time_ref0 (_tmp3_);
#line 118 "../src/Objects/Job.vala"
	result = _tmp4_;
#line 118 "../src/Objects/Job.vala"
	return result;
#line 775 "Job.c"
}

gchar*
printers_job_translated_job_state (PrintersJob* self)
{
	ipp_jstate_t _tmp0_;
	gchar* result;
#line 139 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 140 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_state;
#line 140 "../src/Objects/Job.vala"
	switch (_tmp0_) {
#line 140 "../src/Objects/Job.vala"
		case IPP_JOB_PENDING:
#line 791 "Job.c"
		{
			gchar* _tmp1_;
#line 142 "../src/Objects/Job.vala"
			_tmp1_ = g_strdup (C_ ("Print Job", "Pending"));
#line 142 "../src/Objects/Job.vala"
			result = _tmp1_;
#line 142 "../src/Objects/Job.vala"
			return result;
#line 800 "Job.c"
		}
#line 140 "../src/Objects/Job.vala"
		case IPP_JOB_HELD:
#line 804 "Job.c"
		{
			gchar* _tmp2_;
#line 144 "../src/Objects/Job.vala"
			_tmp2_ = g_strdup (C_ ("Print Job", "On Hold"));
#line 144 "../src/Objects/Job.vala"
			result = _tmp2_;
#line 144 "../src/Objects/Job.vala"
			return result;
#line 813 "Job.c"
		}
#line 140 "../src/Objects/Job.vala"
		case IPP_JOB_PROCESSING:
#line 817 "Job.c"
		{
			gchar* _tmp3_;
#line 146 "../src/Objects/Job.vala"
			_tmp3_ = g_strdup (C_ ("Print Job", "In Progress"));
#line 146 "../src/Objects/Job.vala"
			result = _tmp3_;
#line 146 "../src/Objects/Job.vala"
			return result;
#line 826 "Job.c"
		}
#line 140 "../src/Objects/Job.vala"
		case IPP_JOB_STOPPED:
#line 830 "Job.c"
		{
			gchar* _tmp4_;
#line 148 "../src/Objects/Job.vala"
			_tmp4_ = g_strdup (C_ ("Print Job", "Stopped"));
#line 148 "../src/Objects/Job.vala"
			result = _tmp4_;
#line 148 "../src/Objects/Job.vala"
			return result;
#line 839 "Job.c"
		}
#line 140 "../src/Objects/Job.vala"
		case IPP_JOB_CANCELED:
#line 843 "Job.c"
		{
			gchar* _tmp5_;
#line 150 "../src/Objects/Job.vala"
			_tmp5_ = g_strdup (C_ ("Print Job", "Canceled"));
#line 150 "../src/Objects/Job.vala"
			result = _tmp5_;
#line 150 "../src/Objects/Job.vala"
			return result;
#line 852 "Job.c"
		}
#line 140 "../src/Objects/Job.vala"
		case IPP_JOB_ABORTED:
#line 856 "Job.c"
		{
			gchar* _tmp6_;
#line 152 "../src/Objects/Job.vala"
			_tmp6_ = g_strdup (C_ ("Print Job", "Aborted"));
#line 152 "../src/Objects/Job.vala"
			result = _tmp6_;
#line 152 "../src/Objects/Job.vala"
			return result;
#line 865 "Job.c"
		}
		default:
#line 140 "../src/Objects/Job.vala"
		case IPP_JOB_COMPLETED:
#line 870 "Job.c"
		{
			gchar* _tmp7_;
#line 155 "../src/Objects/Job.vala"
			_tmp7_ = g_strdup (C_ ("Print Job", "Completed"));
#line 155 "../src/Objects/Job.vala"
			result = _tmp7_;
#line 155 "../src/Objects/Job.vala"
			return result;
#line 879 "Job.c"
		}
	}
}

GIcon*
printers_job_state_icon (PrintersJob* self)
{
	ipp_jstate_t _tmp0_;
	GIcon* result;
#line 159 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 160 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_state;
#line 160 "../src/Objects/Job.vala"
	switch (_tmp0_) {
#line 160 "../src/Objects/Job.vala"
		case IPP_JOB_PENDING:
#line 160 "../src/Objects/Job.vala"
		case IPP_JOB_PROCESSING:
#line 899 "Job.c"
		{
#line 163 "../src/Objects/Job.vala"
			result = NULL;
#line 163 "../src/Objects/Job.vala"
			return result;
#line 905 "Job.c"
		}
#line 160 "../src/Objects/Job.vala"
		case IPP_JOB_HELD:
#line 909 "Job.c"
		{
			GThemedIcon* _tmp1_;
#line 165 "../src/Objects/Job.vala"
			_tmp1_ = (GThemedIcon*) g_themed_icon_new ("process-paused");
#line 165 "../src/Objects/Job.vala"
			result = (GIcon*) _tmp1_;
#line 165 "../src/Objects/Job.vala"
			return result;
#line 918 "Job.c"
		}
#line 160 "../src/Objects/Job.vala"
		case IPP_JOB_STOPPED:
#line 160 "../src/Objects/Job.vala"
		case IPP_JOB_CANCELED:
#line 924 "Job.c"
		{
			GThemedIcon* _tmp2_;
#line 168 "../src/Objects/Job.vala"
			_tmp2_ = (GThemedIcon*) g_themed_icon_new ("process-stop");
#line 168 "../src/Objects/Job.vala"
			result = (GIcon*) _tmp2_;
#line 168 "../src/Objects/Job.vala"
			return result;
#line 933 "Job.c"
		}
#line 160 "../src/Objects/Job.vala"
		case IPP_JOB_ABORTED:
#line 937 "Job.c"
		{
			GThemedIcon* _tmp3_;
#line 170 "../src/Objects/Job.vala"
			_tmp3_ = (GThemedIcon*) g_themed_icon_new ("process-error");
#line 170 "../src/Objects/Job.vala"
			result = (GIcon*) _tmp3_;
#line 170 "../src/Objects/Job.vala"
			return result;
#line 946 "Job.c"
		}
#line 160 "../src/Objects/Job.vala"
		case IPP_JOB_COMPLETED:
#line 950 "Job.c"
		{
			GThemedIcon* _tmp4_;
#line 172 "../src/Objects/Job.vala"
			_tmp4_ = (GThemedIcon*) g_themed_icon_new ("process-completed");
#line 172 "../src/Objects/Job.vala"
			result = (GIcon*) _tmp4_;
#line 172 "../src/Objects/Job.vala"
			return result;
#line 959 "Job.c"
		}
		default:
#line 160 "../src/Objects/Job.vala"
		break;
#line 964 "Job.c"
	}
#line 175 "../src/Objects/Job.vala"
	result = NULL;
#line 175 "../src/Objects/Job.vala"
	return result;
#line 970 "Job.c"
}

GIcon*
printers_job_get_file_icon (PrintersJob* self)
{
	gchar* content_type = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result_uncertain = FALSE;
	const gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp7_;
	GThemedIcon* _tmp10_;
	GIcon* result;
#line 178 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 179 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_format;
#line 179 "../src/Objects/Job.vala"
	_tmp1_ = g_content_type_from_mime_type (_tmp0_);
#line 179 "../src/Objects/Job.vala"
	content_type = _tmp1_;
#line 180 "../src/Objects/Job.vala"
	_tmp2_ = content_type;
#line 180 "../src/Objects/Job.vala"
	if (_tmp2_ != NULL) {
#line 998 "Job.c"
		const gchar* _tmp3_;
		GIcon* _tmp4_;
#line 181 "../src/Objects/Job.vala"
		_tmp3_ = content_type;
#line 181 "../src/Objects/Job.vala"
		_tmp4_ = g_content_type_get_icon (_tmp3_);
#line 181 "../src/Objects/Job.vala"
		result = _tmp4_;
#line 181 "../src/Objects/Job.vala"
		_g_free0 (content_type);
#line 181 "../src/Objects/Job.vala"
		return result;
#line 1011 "Job.c"
	}
#line 185 "../src/Objects/Job.vala"
	_tmp5_ = self->priv->_title;
#line 185 "../src/Objects/Job.vala"
	_tmp7_ = g_content_type_guess (_tmp5_, NULL, (gsize) 0, &_tmp6_);
#line 185 "../src/Objects/Job.vala"
	result_uncertain = _tmp6_;
#line 185 "../src/Objects/Job.vala"
	_g_free0 (content_type);
#line 185 "../src/Objects/Job.vala"
	content_type = _tmp7_;
#line 186 "../src/Objects/Job.vala"
	if (!result_uncertain) {
#line 1025 "Job.c"
		const gchar* _tmp8_;
		GIcon* _tmp9_;
#line 187 "../src/Objects/Job.vala"
		_tmp8_ = content_type;
#line 187 "../src/Objects/Job.vala"
		_tmp9_ = g_content_type_get_icon (_tmp8_);
#line 187 "../src/Objects/Job.vala"
		result = _tmp9_;
#line 187 "../src/Objects/Job.vala"
		_g_free0 (content_type);
#line 187 "../src/Objects/Job.vala"
		return result;
#line 1038 "Job.c"
	}
#line 190 "../src/Objects/Job.vala"
	_tmp10_ = (GThemedIcon*) g_themed_icon_new ("unknown");
#line 190 "../src/Objects/Job.vala"
	result = (GIcon*) _tmp10_;
#line 190 "../src/Objects/Job.vala"
	_g_free0 (content_type);
#line 190 "../src/Objects/Job.vala"
	return result;
#line 1048 "Job.c"
}

PrintersPrinter*
printers_job_get_printer (PrintersJob* self)
{
	PrintersPrinter* result;
	PrintersPrinter* _tmp0_;
#line 26 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_printer;
#line 26 "../src/Objects/Job.vala"
	result = _tmp0_;
#line 26 "../src/Objects/Job.vala"
	return result;
#line 1064 "Job.c"
}

static void
printers_job_set_printer (PrintersJob* self,
                          PrintersPrinter* value)
{
	PrintersPrinter* old_value;
#line 26 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Objects/Job.vala"
	old_value = printers_job_get_printer (self);
#line 26 "../src/Objects/Job.vala"
	if (old_value != value) {
#line 26 "../src/Objects/Job.vala"
		self->priv->_printer = value;
#line 26 "../src/Objects/Job.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_job_properties[PRINTERS_JOB_PRINTER_PROPERTY]);
#line 1082 "Job.c"
	}
}

gint
printers_job_get_uid (PrintersJob* self)
{
	gint result;
#line 27 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/Objects/Job.vala"
	result = self->priv->_uid;
#line 27 "../src/Objects/Job.vala"
	return result;
#line 1096 "Job.c"
}

static void
printers_job_set_uid (PrintersJob* self,
                      gint value)
{
	gint old_value;
#line 27 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Objects/Job.vala"
	old_value = printers_job_get_uid (self);
#line 27 "../src/Objects/Job.vala"
	if (old_value != value) {
#line 27 "../src/Objects/Job.vala"
		self->priv->_uid = value;
#line 27 "../src/Objects/Job.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_job_properties[PRINTERS_JOB_UID_PROPERTY]);
#line 1114 "Job.c"
	}
}

ipp_jstate_t
printers_job_get_state (PrintersJob* self)
{
	ipp_jstate_t result;
#line 28 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "../src/Objects/Job.vala"
	result = self->priv->_state;
#line 28 "../src/Objects/Job.vala"
	return result;
#line 1128 "Job.c"
}

void
printers_job_set_state (PrintersJob* self,
                        ipp_jstate_t value)
{
	ipp_jstate_t old_value;
#line 28 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Objects/Job.vala"
	old_value = printers_job_get_state (self);
#line 28 "../src/Objects/Job.vala"
	if (old_value != value) {
#line 28 "../src/Objects/Job.vala"
		self->priv->_state = value;
#line 28 "../src/Objects/Job.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_job_properties[PRINTERS_JOB_STATE_PROPERTY]);
#line 1146 "Job.c"
	}
}

const gchar*
printers_job_get_title (PrintersJob* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_title;
#line 29 "../src/Objects/Job.vala"
	result = _tmp0_;
#line 29 "../src/Objects/Job.vala"
	return result;
#line 1163 "Job.c"
}

static void
printers_job_set_title (PrintersJob* self,
                        const gchar* value)
{
	gchar* old_value;
#line 29 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Objects/Job.vala"
	old_value = printers_job_get_title (self);
#line 29 "../src/Objects/Job.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1177 "Job.c"
		gchar* _tmp0_;
#line 29 "../src/Objects/Job.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../src/Objects/Job.vala"
		_g_free0 (self->priv->_title);
#line 29 "../src/Objects/Job.vala"
		self->priv->_title = _tmp0_;
#line 29 "../src/Objects/Job.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_job_properties[PRINTERS_JOB_TITLE_PROPERTY]);
#line 1187 "Job.c"
	}
}

const gchar*
printers_job_get_format (PrintersJob* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_format;
#line 30 "../src/Objects/Job.vala"
	result = _tmp0_;
#line 30 "../src/Objects/Job.vala"
	return result;
#line 1204 "Job.c"
}

static void
printers_job_set_format (PrintersJob* self,
                         const gchar* value)
{
	gchar* old_value;
#line 30 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Objects/Job.vala"
	old_value = printers_job_get_format (self);
#line 30 "../src/Objects/Job.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1218 "Job.c"
		gchar* _tmp0_;
#line 30 "../src/Objects/Job.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/Objects/Job.vala"
		_g_free0 (self->priv->_format);
#line 30 "../src/Objects/Job.vala"
		self->priv->_format = _tmp0_;
#line 30 "../src/Objects/Job.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_job_properties[PRINTERS_JOB_FORMAT_PROPERTY]);
#line 1228 "Job.c"
	}
}

const gchar*
printers_job_get_reasons (PrintersJob* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_reasons;
#line 31 "../src/Objects/Job.vala"
	result = _tmp0_;
#line 31 "../src/Objects/Job.vala"
	return result;
#line 1245 "Job.c"
}

void
printers_job_set_reasons (PrintersJob* self,
                          const gchar* value)
{
	gchar* old_value;
#line 31 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Objects/Job.vala"
	old_value = printers_job_get_reasons (self);
#line 31 "../src/Objects/Job.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1259 "Job.c"
		gchar* _tmp0_;
#line 31 "../src/Objects/Job.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../src/Objects/Job.vala"
		_g_free0 (self->priv->_reasons);
#line 31 "../src/Objects/Job.vala"
		self->priv->_reasons = _tmp0_;
#line 31 "../src/Objects/Job.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_job_properties[PRINTERS_JOB_REASONS_PROPERTY]);
#line 1269 "Job.c"
	}
}

GDateTime*
printers_job_get_creation_time (PrintersJob* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 32 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_creation_time;
#line 32 "../src/Objects/Job.vala"
	result = _tmp0_;
#line 32 "../src/Objects/Job.vala"
	return result;
#line 1286 "Job.c"
}

static void
printers_job_set_creation_time (PrintersJob* self,
                                GDateTime* value)
{
	GDateTime* old_value;
#line 32 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Objects/Job.vala"
	old_value = printers_job_get_creation_time (self);
#line 32 "../src/Objects/Job.vala"
	if (old_value != value) {
#line 1300 "Job.c"
		GDateTime* _tmp0_;
#line 32 "../src/Objects/Job.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 32 "../src/Objects/Job.vala"
		_g_date_time_unref0 (self->priv->_creation_time);
#line 32 "../src/Objects/Job.vala"
		self->priv->_creation_time = _tmp0_;
#line 32 "../src/Objects/Job.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_job_properties[PRINTERS_JOB_CREATION_TIME_PROPERTY]);
#line 1310 "Job.c"
	}
}

GDateTime*
printers_job_get_completed_time (PrintersJob* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 33 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_completed_time;
#line 33 "../src/Objects/Job.vala"
	result = _tmp0_;
#line 33 "../src/Objects/Job.vala"
	return result;
#line 1327 "Job.c"
}

void
printers_job_set_completed_time (PrintersJob* self,
                                 GDateTime* value)
{
	GDateTime* old_value;
#line 33 "../src/Objects/Job.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Objects/Job.vala"
	old_value = printers_job_get_completed_time (self);
#line 33 "../src/Objects/Job.vala"
	if (old_value != value) {
#line 1341 "Job.c"
		GDateTime* _tmp0_;
#line 33 "../src/Objects/Job.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 33 "../src/Objects/Job.vala"
		_g_date_time_unref0 (self->priv->_completed_time);
#line 33 "../src/Objects/Job.vala"
		self->priv->_completed_time = _tmp0_;
#line 33 "../src/Objects/Job.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_job_properties[PRINTERS_JOB_COMPLETED_TIME_PROPERTY]);
#line 1351 "Job.c"
	}
}

gboolean
printers_job_get_is_ongoing (PrintersJob* self)
{
	gboolean result;
	ipp_jstate_t _tmp0_;
#line 122 "../src/Objects/Job.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 123 "../src/Objects/Job.vala"
	_tmp0_ = self->priv->_state;
#line 123 "../src/Objects/Job.vala"
	switch (_tmp0_) {
#line 123 "../src/Objects/Job.vala"
		case IPP_JOB_PENDING:
#line 123 "../src/Objects/Job.vala"
		case IPP_JOB_HELD:
#line 123 "../src/Objects/Job.vala"
		case IPP_JOB_PROCESSING:
#line 123 "../src/Objects/Job.vala"
		case IPP_JOB_STOPPED:
#line 1374 "Job.c"
		{
#line 128 "../src/Objects/Job.vala"
			result = TRUE;
#line 128 "../src/Objects/Job.vala"
			return result;
#line 1380 "Job.c"
		}
#line 123 "../src/Objects/Job.vala"
		case IPP_JOB_CANCELED:
#line 123 "../src/Objects/Job.vala"
		case IPP_JOB_ABORTED:
#line 123 "../src/Objects/Job.vala"
		case IPP_JOB_COMPLETED:
#line 1388 "Job.c"
		{
#line 132 "../src/Objects/Job.vala"
			result = FALSE;
#line 132 "../src/Objects/Job.vala"
			return result;
#line 1394 "Job.c"
		}
		default:
#line 123 "../src/Objects/Job.vala"
		break;
#line 1399 "Job.c"
	}
#line 135 "../src/Objects/Job.vala"
	g_assert_not_reached ();
#line 1403 "Job.c"
}

static void
printers_job_class_init (PrintersJobClass * klass,
                         gpointer klass_data)
{
#line 23 "../src/Objects/Job.vala"
	printers_job_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Objects/Job.vala"
	g_type_class_adjust_private_offset (klass, &PrintersJob_private_offset);
#line 23 "../src/Objects/Job.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_printers_job_get_property;
#line 23 "../src/Objects/Job.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_printers_job_set_property;
#line 23 "../src/Objects/Job.vala"
	G_OBJECT_CLASS (klass)->finalize = printers_job_finalize;
#line 23 "../src/Objects/Job.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_PRINTER_PROPERTY, printers_job_properties[PRINTERS_JOB_PRINTER_PROPERTY] = g_param_spec_object ("printer", "printer", "printer", PRINTERS_TYPE_PRINTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Objects/Job.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_UID_PROPERTY, printers_job_properties[PRINTERS_JOB_UID_PROPERTY] = g_param_spec_int ("uid", "uid", "uid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Objects/Job.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_STATE_PROPERTY, printers_job_properties[PRINTERS_JOB_STATE_PROPERTY] = g_param_spec_int ("state", "state", "state", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/Objects/Job.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_TITLE_PROPERTY, printers_job_properties[PRINTERS_JOB_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Objects/Job.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_FORMAT_PROPERTY, printers_job_properties[PRINTERS_JOB_FORMAT_PROPERTY] = g_param_spec_string ("format", "format", "format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Objects/Job.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_REASONS_PROPERTY, printers_job_properties[PRINTERS_JOB_REASONS_PROPERTY] = g_param_spec_string ("reasons", "reasons", "reasons", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Objects/Job.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_CREATION_TIME_PROPERTY, printers_job_properties[PRINTERS_JOB_CREATION_TIME_PROPERTY] = g_param_spec_boxed ("creation-time", "creation-time", "creation-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Objects/Job.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_COMPLETED_TIME_PROPERTY, printers_job_properties[PRINTERS_JOB_COMPLETED_TIME_PROPERTY] = g_param_spec_boxed ("completed-time", "completed-time", "completed-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Objects/Job.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_IS_ONGOING_PROPERTY, printers_job_properties[PRINTERS_JOB_IS_ONGOING_PROPERTY] = g_param_spec_boolean ("is-ongoing", "is-ongoing", "is-ongoing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Objects/Job.vala"
	printers_job_signals[PRINTERS_JOB_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", PRINTERS_TYPE_JOB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1440 "Job.c"
}

static void
printers_job_instance_init (PrintersJob * self,
                            gpointer klass)
{
	gchar* _tmp0_;
#line 23 "../src/Objects/Job.vala"
	self->priv = printers_job_get_instance_private (self);
#line 31 "../src/Objects/Job.vala"
	_tmp0_ = g_strdup ("None");
#line 31 "../src/Objects/Job.vala"
	self->priv->_reasons = _tmp0_;
#line 33 "../src/Objects/Job.vala"
	self->priv->_completed_time = NULL;
#line 1456 "Job.c"
}

static void
printers_job_finalize (GObject * obj)
{
	PrintersJob * self;
#line 23 "../src/Objects/Job.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_JOB, PrintersJob);
#line 29 "../src/Objects/Job.vala"
	_g_free0 (self->priv->_title);
#line 30 "../src/Objects/Job.vala"
	_g_free0 (self->priv->_format);
#line 31 "../src/Objects/Job.vala"
	_g_free0 (self->priv->_reasons);
#line 32 "../src/Objects/Job.vala"
	_g_date_time_unref0 (self->priv->_creation_time);
#line 33 "../src/Objects/Job.vala"
	_g_date_time_unref0 (self->priv->_completed_time);
#line 23 "../src/Objects/Job.vala"
	G_OBJECT_CLASS (printers_job_parent_class)->finalize (obj);
#line 1477 "Job.c"
}

static GType
printers_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersJob), 0, (GInstanceInitFunc) printers_job_instance_init, NULL };
	GType printers_job_type_id;
	printers_job_type_id = g_type_register_static (G_TYPE_OBJECT, "PrintersJob", &g_define_type_info, 0);
	PrintersJob_private_offset = g_type_add_instance_private (printers_job_type_id, sizeof (PrintersJobPrivate));
	return printers_job_type_id;
}

GType
printers_job_get_type (void)
{
	static volatile gsize printers_job_type_id__once = 0;
	if (g_once_init_enter (&printers_job_type_id__once)) {
		GType printers_job_type_id;
		printers_job_type_id = printers_job_get_type_once ();
		g_once_init_leave (&printers_job_type_id__once, printers_job_type_id);
	}
	return printers_job_type_id__once;
}

static void
_vala_printers_job_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	PrintersJob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_JOB, PrintersJob);
#line 23 "../src/Objects/Job.vala"
	switch (property_id) {
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_PRINTER_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		g_value_set_object (value, printers_job_get_printer (self));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_UID_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		g_value_set_int (value, printers_job_get_uid (self));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_STATE_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		g_value_set_int (value, printers_job_get_state (self));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_TITLE_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		g_value_set_string (value, printers_job_get_title (self));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_FORMAT_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		g_value_set_string (value, printers_job_get_format (self));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_REASONS_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		g_value_set_string (value, printers_job_get_reasons (self));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_CREATION_TIME_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		g_value_set_boxed (value, printers_job_get_creation_time (self));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_COMPLETED_TIME_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		g_value_set_boxed (value, printers_job_get_completed_time (self));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_IS_ONGOING_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		g_value_set_boolean (value, printers_job_get_is_ongoing (self));
#line 23 "../src/Objects/Job.vala"
		break;
#line 1566 "Job.c"
		default:
#line 23 "../src/Objects/Job.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Objects/Job.vala"
		break;
#line 1572 "Job.c"
	}
}

static void
_vala_printers_job_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	PrintersJob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_JOB, PrintersJob);
#line 23 "../src/Objects/Job.vala"
	switch (property_id) {
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_PRINTER_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		printers_job_set_printer (self, g_value_get_object (value));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_UID_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		printers_job_set_uid (self, g_value_get_int (value));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_STATE_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		printers_job_set_state (self, g_value_get_int (value));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_TITLE_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		printers_job_set_title (self, g_value_get_string (value));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_FORMAT_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		printers_job_set_format (self, g_value_get_string (value));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_REASONS_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		printers_job_set_reasons (self, g_value_get_string (value));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_CREATION_TIME_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		printers_job_set_creation_time (self, g_value_get_boxed (value));
#line 23 "../src/Objects/Job.vala"
		break;
#line 23 "../src/Objects/Job.vala"
		case PRINTERS_JOB_COMPLETED_TIME_PROPERTY:
#line 23 "../src/Objects/Job.vala"
		printers_job_set_completed_time (self, g_value_get_boxed (value));
#line 23 "../src/Objects/Job.vala"
		break;
#line 1634 "Job.c"
		default:
#line 23 "../src/Objects/Job.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Objects/Job.vala"
		break;
#line 1640 "Job.c"
	}
}

