/* Plug.c generated by valac 0.56.13, the Vala compiler
 * generated from Plug.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Pantheon Developers (https://launchpad.net/switchboard-plug-printers)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gmodule.h>

enum  {
	PRINTERS_PLUG_0_PROPERTY,
	PRINTERS_PLUG_NUM_PROPERTIES
};
static GParamSpec* printers_plug_properties[PRINTERS_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PrintersPlugSearchData PrintersPlugSearchData;

struct _PrintersPlugPrivate {
	GtkPaned* main_paned;
	GtkStack* main_stack;
	PrintersPrinterList* list;
};

struct _PrintersPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PrintersPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* _tmp0_;
};

static gint PrintersPlug_private_offset;
static gpointer printers_plug_parent_class = NULL;

static GtkWidget* printers_plug_real_get_widget (SwitchboardPlug* base);
static void printers_plug_update_alert_visible (PrintersPlug* self);
static void ___lambda49_ (PrintersPlug* self);
static void ____lambda49__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void printers_plug_real_shown (SwitchboardPlug* base);
static void printers_plug_real_hidden (SwitchboardPlug* base);
static void printers_plug_real_search_callback (SwitchboardPlug* base,
                                         const gchar* location);
static void printers_plug_real_search_data_free (gpointer _data);
static void printers_plug_real_search (SwitchboardPlug* base,
                                const gchar* search,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
static gboolean printers_plug_real_search_co (PrintersPlugSearchData* _data_);
static void printers_plug_finalize (GObject * obj);
static GType printers_plug_get_type_once (void);

static inline gpointer
printers_plug_get_instance_private (PrintersPlug* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersPlug_private_offset);
}

PrintersPlug*
printers_plug_construct (GType object_type)
{
	PrintersPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 31 "../src/Plug.vala"
	bindtextdomain (BUILD_GETTEXT_PACKAGE, BUILD_LOCALEDIR);
#line 32 "../src/Plug.vala"
	bind_textdomain_codeset (BUILD_GETTEXT_PACKAGE, "UTF-8");
#line 34 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 34 "../src/Plug.vala"
	settings = _tmp0_;
#line 35 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "printer", NULL);
#line 36 "../src/Plug.vala"
	self = (PrintersPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_HARDWARE, "code-name", "io.elementary.switchboard.printers", "display-name", _ ("Printers"), "description", _ ("Configure printers, manage print queues, and view ink levels"), "icon", "printer", "supported-settings", settings, NULL);
#line 30 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 30 "../src/Plug.vala"
	return self;
#line 116 "Plug.c"
}

PrintersPlug*
printers_plug_new (void)
{
#line 30 "../src/Plug.vala"
	return printers_plug_construct (PRINTERS_TYPE_PLUG);
#line 124 "Plug.c"
}

static void
___lambda49_ (PrintersPlug* self)
{
#line 72 "../src/Plug.vala"
	printers_plug_update_alert_visible (self);
#line 132 "Plug.c"
}

static void
____lambda49__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 71 "../src/Plug.vala"
	___lambda49_ ((PrintersPlug*) self);
#line 142 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 76 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 150 "Plug.c"
}

static GtkWidget*
printers_plug_real_get_widget (SwitchboardPlug* base)
{
	PrintersPlug * self;
	GtkPaned* _tmp0_;
	GtkPaned* _tmp22_;
	GtkWidget* _tmp23_;
	GtkWidget* result;
#line 44 "../src/Plug.vala"
	self = (PrintersPlug*) base;
#line 45 "../src/Plug.vala"
	_tmp0_ = self->priv->main_paned;
#line 45 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 167 "Plug.c"
		GtkStack* stack = NULL;
		GtkStack* _tmp1_;
		GtkStack* _tmp2_;
		GtkStack* _tmp3_;
		PrintersPrinterList* _tmp4_;
		GraniteWidgetsAlertView* empty_alert = NULL;
		GraniteWidgetsAlertView* _tmp5_;
		GraniteWidgetsAlertView* _tmp6_;
		GraniteWidgetsAlertView* _tmp7_;
		GtkStyleContext* _tmp8_;
		GtkStack* _tmp9_;
		GtkStack* _tmp10_;
		GtkStack* _tmp11_;
		GraniteWidgetsAlertView* _tmp12_;
		GtkStack* _tmp13_;
		GtkStack* _tmp14_;
		GtkPaned* _tmp15_;
		GtkPaned* _tmp16_;
		PrintersPrinterList* _tmp17_;
		GtkPaned* _tmp18_;
		GtkStack* _tmp19_;
		GtkPaned* _tmp20_;
		PrintersPrinterList* _tmp21_;
#line 46 "../src/Plug.vala"
		_tmp1_ = (GtkStack*) gtk_stack_new ();
#line 46 "../src/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 46 "../src/Plug.vala"
		stack = _tmp1_;
#line 47 "../src/Plug.vala"
		_tmp2_ = stack;
#line 47 "../src/Plug.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 49 "../src/Plug.vala"
		_tmp3_ = stack;
#line 49 "../src/Plug.vala"
		_tmp4_ = printers_printer_list_new (_tmp3_);
#line 49 "../src/Plug.vala"
		g_object_ref_sink (_tmp4_);
#line 49 "../src/Plug.vala"
		_g_object_unref0 (self->priv->list);
#line 49 "../src/Plug.vala"
		self->priv->list = _tmp4_;
#line 51 "../src/Plug.vala"
		_tmp5_ = granite_widgets_alert_view_new (_ ("No Printers Available"), _ ("Connect to a printer by clicking the icon in the toolbar below."), "printer-error");
#line 51 "../src/Plug.vala"
		g_object_ref_sink (_tmp5_);
#line 51 "../src/Plug.vala"
		empty_alert = _tmp5_;
#line 56 "../src/Plug.vala"
		_tmp6_ = empty_alert;
#line 56 "../src/Plug.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
#line 57 "../src/Plug.vala"
		_tmp7_ = empty_alert;
#line 57 "../src/Plug.vala"
		_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 57 "../src/Plug.vala"
		gtk_style_context_remove_class (_tmp8_, GTK_STYLE_CLASS_VIEW);
#line 59 "../src/Plug.vala"
		_tmp9_ = (GtkStack*) gtk_stack_new ();
#line 59 "../src/Plug.vala"
		g_object_ref_sink (_tmp9_);
#line 59 "../src/Plug.vala"
		_g_object_unref0 (self->priv->main_stack);
#line 59 "../src/Plug.vala"
		self->priv->main_stack = _tmp9_;
#line 60 "../src/Plug.vala"
		_tmp10_ = self->priv->main_stack;
#line 60 "../src/Plug.vala"
		gtk_stack_set_transition_type (_tmp10_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 61 "../src/Plug.vala"
		_tmp11_ = self->priv->main_stack;
#line 61 "../src/Plug.vala"
		_tmp12_ = empty_alert;
#line 61 "../src/Plug.vala"
		gtk_stack_add_named (_tmp11_, (GtkWidget*) _tmp12_, "empty-alert");
#line 62 "../src/Plug.vala"
		_tmp13_ = self->priv->main_stack;
#line 62 "../src/Plug.vala"
		_tmp14_ = stack;
#line 62 "../src/Plug.vala"
		gtk_stack_add_named (_tmp13_, (GtkWidget*) _tmp14_, "main-paned");
#line 64 "../src/Plug.vala"
		_tmp15_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
#line 64 "../src/Plug.vala"
		g_object_ref_sink (_tmp15_);
#line 64 "../src/Plug.vala"
		_g_object_unref0 (self->priv->main_paned);
#line 64 "../src/Plug.vala"
		self->priv->main_paned = _tmp15_;
#line 65 "../src/Plug.vala"
		_tmp16_ = self->priv->main_paned;
#line 65 "../src/Plug.vala"
		_tmp17_ = self->priv->list;
#line 65 "../src/Plug.vala"
		gtk_paned_pack1 (_tmp16_, (GtkWidget*) _tmp17_, FALSE, FALSE);
#line 66 "../src/Plug.vala"
		_tmp18_ = self->priv->main_paned;
#line 66 "../src/Plug.vala"
		_tmp19_ = self->priv->main_stack;
#line 66 "../src/Plug.vala"
		gtk_paned_pack2 (_tmp18_, (GtkWidget*) _tmp19_, TRUE, FALSE);
#line 67 "../src/Plug.vala"
		_tmp20_ = self->priv->main_paned;
#line 67 "../src/Plug.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp20_);
#line 69 "../src/Plug.vala"
		printers_plug_update_alert_visible (self);
#line 71 "../src/Plug.vala"
		_tmp21_ = self->priv->list;
#line 71 "../src/Plug.vala"
		g_signal_connect_object ((GObject*) _tmp21_, "notify::has-child", (GCallback) ____lambda49__g_object_notify, self, 0);
#line 45 "../src/Plug.vala"
		_g_object_unref0 (empty_alert);
#line 45 "../src/Plug.vala"
		_g_object_unref0 (stack);
#line 285 "Plug.c"
	}
#line 76 "../src/Plug.vala"
	_tmp22_ = self->priv->main_paned;
#line 76 "../src/Plug.vala"
	_tmp23_ = _g_object_ref0 ((GtkWidget*) _tmp22_);
#line 76 "../src/Plug.vala"
	result = _tmp23_;
#line 76 "../src/Plug.vala"
	return result;
#line 295 "Plug.c"
}

static void
printers_plug_update_alert_visible (PrintersPlug* self)
{
	PrintersPrinterList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 79 "../src/Plug.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/Plug.vala"
	_tmp0_ = self->priv->list;
#line 80 "../src/Plug.vala"
	_tmp1_ = printers_printer_list_get_has_child (_tmp0_);
#line 80 "../src/Plug.vala"
	_tmp2_ = _tmp1_;
#line 80 "../src/Plug.vala"
	if (_tmp2_) {
#line 314 "Plug.c"
		GtkStack* _tmp3_;
#line 81 "../src/Plug.vala"
		_tmp3_ = self->priv->main_stack;
#line 81 "../src/Plug.vala"
		gtk_stack_set_visible_child_name (_tmp3_, "main-paned");
#line 320 "Plug.c"
	} else {
		GtkStack* _tmp4_;
#line 83 "../src/Plug.vala"
		_tmp4_ = self->priv->main_stack;
#line 83 "../src/Plug.vala"
		gtk_stack_set_visible_child_name (_tmp4_, "empty-alert");
#line 327 "Plug.c"
	}
}

static void
printers_plug_real_shown (SwitchboardPlug* base)
{
	PrintersPlug * self;
#line 87 "../src/Plug.vala"
	self = (PrintersPlug*) base;
#line 337 "Plug.c"
}

static void
printers_plug_real_hidden (SwitchboardPlug* base)
{
	PrintersPlug * self;
#line 91 "../src/Plug.vala"
	self = (PrintersPlug*) base;
#line 346 "Plug.c"
}

static void
printers_plug_real_search_callback (SwitchboardPlug* base,
                                    const gchar* location)
{
	PrintersPlug * self;
#line 95 "../src/Plug.vala"
	self = (PrintersPlug*) base;
#line 95 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 358 "Plug.c"
}

static void
printers_plug_real_search_data_free (gpointer _data)
{
	PrintersPlugSearchData* _data_;
	_data_ = _data;
#line 25 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 25 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 25 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/Plug.vala"
	g_slice_free (PrintersPlugSearchData, _data_);
#line 374 "Plug.c"
}

static void
printers_plug_real_search (SwitchboardPlug* base,
                           const gchar* search,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	PrintersPlug * self;
	PrintersPlugSearchData* _data_;
	PrintersPlug* _tmp0_;
	gchar* _tmp1_;
#line 25 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 25 "../src/Plug.vala"
	self = (PrintersPlug*) base;
#line 25 "../src/Plug.vala"
	_data_ = g_slice_new0 (PrintersPlugSearchData);
#line 25 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, printers_plug_real_search_data_free);
#line 25 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 25 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 25 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 25 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 25 "../src/Plug.vala"
	printers_plug_real_search_co (_data_);
#line 409 "Plug.c"
}

static GeeTreeMap*
printers_plug_search_finish (SwitchboardPlug* base,
                             GAsyncResult* _res_)
{
	GeeTreeMap* result;
	PrintersPlugSearchData* _data_;
#line 25 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 25 "../src/Plug.vala"
	result = _data_->result;
#line 25 "../src/Plug.vala"
	_data_->result = NULL;
#line 25 "../src/Plug.vala"
	return result;
#line 426 "Plug.c"
}

static gboolean
printers_plug_real_search_co (PrintersPlugSearchData* _data_)
{
#line 100 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 100 "../src/Plug.vala"
		case 0:
#line 436 "Plug.c"
		goto _state_0;
		default:
#line 100 "../src/Plug.vala"
		g_assert_not_reached ();
#line 441 "Plug.c"
	}
	_state_0:
#line 101 "../src/Plug.vala"
	_data_->_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 101 "../src/Plug.vala"
	_data_->result = _data_->_tmp0_;
#line 101 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 101 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 101 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 101 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 456 "Plug.c"
		}
	}
#line 101 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 101 "../src/Plug.vala"
	return FALSE;
#line 463 "Plug.c"
}

static void
printers_plug_class_init (PrintersPlugClass * klass,
                          gpointer klass_data)
{
#line 25 "../src/Plug.vala"
	printers_plug_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &PrintersPlug_private_offset);
#line 25 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) printers_plug_real_get_widget;
#line 25 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) printers_plug_real_shown;
#line 25 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) printers_plug_real_hidden;
#line 25 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) printers_plug_real_search_callback;
#line 25 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) printers_plug_real_search;
#line 25 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) printers_plug_search_finish;
#line 25 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = printers_plug_finalize;
#line 488 "Plug.c"
}

static void
printers_plug_instance_init (PrintersPlug * self,
                             gpointer klass)
{
#line 25 "../src/Plug.vala"
	self->priv = printers_plug_get_instance_private (self);
#line 497 "Plug.c"
}

static void
printers_plug_finalize (GObject * obj)
{
	PrintersPlug * self;
#line 25 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_PLUG, PrintersPlug);
#line 26 "../src/Plug.vala"
	_g_object_unref0 (self->priv->main_paned);
#line 27 "../src/Plug.vala"
	_g_object_unref0 (self->priv->main_stack);
#line 28 "../src/Plug.vala"
	_g_object_unref0 (self->priv->list);
#line 25 "../src/Plug.vala"
	G_OBJECT_CLASS (printers_plug_parent_class)->finalize (obj);
#line 514 "Plug.c"
}

static GType
printers_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersPlug), 0, (GInstanceInitFunc) printers_plug_instance_init, NULL };
	GType printers_plug_type_id;
	printers_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "PrintersPlug", &g_define_type_info, 0);
	PrintersPlug_private_offset = g_type_add_instance_private (printers_plug_type_id, sizeof (PrintersPlugPrivate));
	return printers_plug_type_id;
}

GType
printers_plug_get_type (void)
{
	static volatile gsize printers_plug_type_id__once = 0;
	if (g_once_init_enter (&printers_plug_type_id__once)) {
		GType printers_plug_type_id;
		printers_plug_type_id = printers_plug_get_type_once ();
		g_once_init_leave (&printers_plug_type_id__once, printers_plug_type_id);
	}
	return printers_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	PrintersPlug* plug = NULL;
	PrintersPlug* _tmp0_;
	SwitchboardPlug* result;
#line 106 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 107 "../src/Plug.vala"
	g_debug ("Plug.vala:107: Activating Printers plug");
#line 108 "../src/Plug.vala"
	_tmp0_ = printers_plug_new ();
#line 108 "../src/Plug.vala"
	plug = _tmp0_;
#line 109 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 109 "../src/Plug.vala"
	return result;
#line 557 "Plug.c"
}

