/* PrinterPage.c generated by valac 0.56.13, the Vala compiler
 * generated from PrinterPage.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "cups/cups.h"
#include "cups/ipp.h"
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <granite.h>

enum  {
	PRINTERS_PRINTER_PAGE_0_PROPERTY,
	PRINTERS_PRINTER_PAGE_PRINTER_PROPERTY,
	PRINTERS_PRINTER_PAGE_NUM_PROPERTIES
};
static GParamSpec* printers_printer_page_properties[PRINTERS_PRINTER_PAGE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _ippDelete0(var) ((var == NULL) ? NULL : (var = (ippDelete (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _PrintersPrinterPagePrivate {
	PrintersPrinter* _printer;
};

static gint PrintersPrinterPage_private_offset;
static gpointer printers_printer_page_parent_class = NULL;

static gchar* printers_printer_page_get_testprint_filename (PrintersPrinterPage* self,
                                                     const gchar* datadir);
static void printers_printer_page_print_test_page (PrintersPrinterPage* self);
static GObject * printers_printer_page_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _printers_printer_page___lambda22_ (PrintersPrinterPage* self);
static void __printers_printer_page___lambda22__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void printers_printer_page_finalize (GObject * obj);
static GType printers_printer_page_get_type_once (void);
static void _vala_printers_printer_page_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_printers_printer_page_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
printers_printer_page_get_instance_private (PrintersPrinterPage* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersPrinterPage_private_offset);
}

PrintersPrinterPage*
printers_printer_page_construct (GType object_type,
                                 PrintersPrinter* printer)
{
	PrintersPrinterPage * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 26 "../src/PrinterPage.vala"
	g_return_val_if_fail (printer != NULL, NULL);
#line 27 "../src/PrinterPage.vala"
	_tmp0_ = printers_printer_get_info (printer);
#line 27 "../src/PrinterPage.vala"
	_tmp1_ = _tmp0_;
#line 27 "../src/PrinterPage.vala"
	_tmp2_ = printers_printer_get_location (printer);
#line 27 "../src/PrinterPage.vala"
	_tmp3_ = _tmp2_;
#line 27 "../src/PrinterPage.vala"
	self = (PrintersPrinterPage*) g_object_new (object_type, "activatable", TRUE, "icon-name", "printer", "title", _tmp1_, "description", _tmp3_, "printer", printer, NULL);
#line 26 "../src/PrinterPage.vala"
	return self;
#line 111 "PrinterPage.c"
}

PrintersPrinterPage*
printers_printer_page_new (PrintersPrinter* printer)
{
#line 26 "../src/PrinterPage.vala"
	return printers_printer_page_construct (PRINTERS_TYPE_PRINTER_PAGE, printer);
#line 119 "PrinterPage.c"
}

static gchar*
printers_printer_page_get_testprint_filename (PrintersPrinterPage* self,
                                              const gchar* datadir)
{
	gchar** testprints = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint testprints_length1;
	gint _testprints_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* result;
#line 69 "../src/PrinterPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../src/PrinterPage.vala"
	g_return_val_if_fail (datadir != NULL, NULL);
#line 70 "../src/PrinterPage.vala"
	_tmp0_ = g_strdup ("/data/testprint");
#line 70 "../src/PrinterPage.vala"
	_tmp1_ = g_strdup ("/data/testprint.ps");
#line 70 "../src/PrinterPage.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 70 "../src/PrinterPage.vala"
	_tmp2_[0] = _tmp0_;
#line 70 "../src/PrinterPage.vala"
	_tmp2_[1] = _tmp1_;
#line 70 "../src/PrinterPage.vala"
	testprints = _tmp2_;
#line 70 "../src/PrinterPage.vala"
	testprints_length1 = 2;
#line 70 "../src/PrinterPage.vala"
	_testprints_size_ = testprints_length1;
#line 71 "../src/PrinterPage.vala"
	_tmp3_ = testprints;
#line 71 "../src/PrinterPage.vala"
	_tmp3__length1 = testprints_length1;
#line 159 "PrinterPage.c"
	{
		gchar** testprint_collection = NULL;
		gint testprint_collection_length1 = 0;
		gint _testprint_collection_size_ = 0;
		gint testprint_it = 0;
#line 71 "../src/PrinterPage.vala"
		testprint_collection = _tmp3_;
#line 71 "../src/PrinterPage.vala"
		testprint_collection_length1 = _tmp3__length1;
#line 71 "../src/PrinterPage.vala"
		for (testprint_it = 0; testprint_it < testprint_collection_length1; testprint_it = testprint_it + 1) {
#line 171 "PrinterPage.c"
			gchar* _tmp4_;
			gchar* testprint = NULL;
#line 71 "../src/PrinterPage.vala"
			_tmp4_ = g_strdup (testprint_collection[testprint_it]);
#line 71 "../src/PrinterPage.vala"
			testprint = _tmp4_;
#line 178 "PrinterPage.c"
			{
				gchar* filename = NULL;
				const gchar* _tmp5_;
				gchar* _tmp6_;
				const gchar* _tmp7_;
#line 72 "../src/PrinterPage.vala"
				_tmp5_ = testprint;
#line 72 "../src/PrinterPage.vala"
				_tmp6_ = g_strconcat (datadir, _tmp5_, NULL);
#line 72 "../src/PrinterPage.vala"
				filename = _tmp6_;
#line 73 "../src/PrinterPage.vala"
				_tmp7_ = filename;
#line 73 "../src/PrinterPage.vala"
				if (access (_tmp7_, R_OK) == 0) {
#line 74 "../src/PrinterPage.vala"
					result = filename;
#line 74 "../src/PrinterPage.vala"
					_g_free0 (testprint);
#line 74 "../src/PrinterPage.vala"
					testprints = (_vala_array_free (testprints, testprints_length1, (GDestroyNotify) g_free), NULL);
#line 74 "../src/PrinterPage.vala"
					return result;
#line 202 "PrinterPage.c"
				}
#line 71 "../src/PrinterPage.vala"
				_g_free0 (filename);
#line 71 "../src/PrinterPage.vala"
				_g_free0 (testprint);
#line 208 "PrinterPage.c"
			}
		}
	}
#line 78 "../src/PrinterPage.vala"
	result = NULL;
#line 78 "../src/PrinterPage.vala"
	testprints = (_vala_array_free (testprints, testprints_length1, (GDestroyNotify) g_free), NULL);
#line 78 "../src/PrinterPage.vala"
	return result;
#line 218 "PrinterPage.c"
}

static void
printers_printer_page_print_test_page (PrintersPrinterPage* self)
{
	gchar* filename = NULL;
	gchar* datadir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp13_;
#line 81 "../src/PrinterPage.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/PrinterPage.vala"
	filename = NULL;
#line 83 "../src/PrinterPage.vala"
	_tmp0_ = g_getenv ("CUPS_DATADIR");
#line 83 "../src/PrinterPage.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 83 "../src/PrinterPage.vala"
	datadir = _tmp1_;
#line 84 "../src/PrinterPage.vala"
	_tmp2_ = datadir;
#line 84 "../src/PrinterPage.vala"
	if (_tmp2_ != NULL) {
#line 244 "PrinterPage.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 85 "../src/PrinterPage.vala"
		_tmp3_ = datadir;
#line 85 "../src/PrinterPage.vala"
		_tmp4_ = printers_printer_page_get_testprint_filename (self, _tmp3_);
#line 85 "../src/PrinterPage.vala"
		_g_free0 (filename);
#line 85 "../src/PrinterPage.vala"
		filename = _tmp4_;
#line 255 "PrinterPage.c"
	} else {
		gchar** dirs = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar** _tmp7_;
		gint dirs_length1;
		gint _dirs_size_;
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 87 "../src/PrinterPage.vala"
		_tmp5_ = g_strdup ("/usr/share/cups");
#line 87 "../src/PrinterPage.vala"
		_tmp6_ = g_strdup ("/usr/local/share/cups");
#line 87 "../src/PrinterPage.vala"
		_tmp7_ = g_new0 (gchar*, 2 + 1);
#line 87 "../src/PrinterPage.vala"
		_tmp7_[0] = _tmp5_;
#line 87 "../src/PrinterPage.vala"
		_tmp7_[1] = _tmp6_;
#line 87 "../src/PrinterPage.vala"
		dirs = _tmp7_;
#line 87 "../src/PrinterPage.vala"
		dirs_length1 = 2;
#line 87 "../src/PrinterPage.vala"
		_dirs_size_ = dirs_length1;
#line 88 "../src/PrinterPage.vala"
		_tmp8_ = dirs;
#line 88 "../src/PrinterPage.vala"
		_tmp8__length1 = dirs_length1;
#line 285 "PrinterPage.c"
		{
			gchar** dir_collection = NULL;
			gint dir_collection_length1 = 0;
			gint _dir_collection_size_ = 0;
			gint dir_it = 0;
#line 88 "../src/PrinterPage.vala"
			dir_collection = _tmp8_;
#line 88 "../src/PrinterPage.vala"
			dir_collection_length1 = _tmp8__length1;
#line 88 "../src/PrinterPage.vala"
			for (dir_it = 0; dir_it < dir_collection_length1; dir_it = dir_it + 1) {
#line 297 "PrinterPage.c"
				gchar* _tmp9_;
				gchar* dir = NULL;
#line 88 "../src/PrinterPage.vala"
				_tmp9_ = g_strdup (dir_collection[dir_it]);
#line 88 "../src/PrinterPage.vala"
				dir = _tmp9_;
#line 304 "PrinterPage.c"
				{
					const gchar* _tmp10_;
					gchar* _tmp11_;
					const gchar* _tmp12_;
#line 89 "../src/PrinterPage.vala"
					_tmp10_ = dir;
#line 89 "../src/PrinterPage.vala"
					_tmp11_ = printers_printer_page_get_testprint_filename (self, _tmp10_);
#line 89 "../src/PrinterPage.vala"
					_g_free0 (filename);
#line 89 "../src/PrinterPage.vala"
					filename = _tmp11_;
#line 90 "../src/PrinterPage.vala"
					_tmp12_ = filename;
#line 90 "../src/PrinterPage.vala"
					if (_tmp12_ != NULL) {
#line 91 "../src/PrinterPage.vala"
						_g_free0 (dir);
#line 91 "../src/PrinterPage.vala"
						break;
#line 325 "PrinterPage.c"
					}
#line 88 "../src/PrinterPage.vala"
					_g_free0 (dir);
#line 329 "PrinterPage.c"
				}
			}
		}
#line 84 "../src/PrinterPage.vala"
		dirs = (_vala_array_free (dirs, dirs_length1, (GDestroyNotify) g_free), NULL);
#line 335 "PrinterPage.c"
	}
#line 96 "../src/PrinterPage.vala"
	_tmp13_ = filename;
#line 96 "../src/PrinterPage.vala"
	if (_tmp13_ != NULL) {
#line 341 "PrinterPage.c"
		gint type = 0;
		PrintersPrinter* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* printer_uri = NULL;
		gchar* resource = NULL;
		ipp_t* request = NULL;
		ipp_t* _tmp33_;
		ipp_t* _tmp34_;
		const gchar* _tmp35_;
		ipp_t* _tmp36_;
		const gchar* _tmp37_;
		ipp_t* _tmp38_;
		http_t* _tmp39_;
		const gchar* _tmp40_;
		const gchar* _tmp41_;
#line 97 "../src/PrinterPage.vala"
		_tmp14_ = self->priv->_printer;
#line 97 "../src/PrinterPage.vala"
		_tmp15_ = printers_printer_get_printer_type (_tmp14_);
#line 97 "../src/PrinterPage.vala"
		_tmp16_ = _tmp15_;
#line 97 "../src/PrinterPage.vala"
		type = atoi (_tmp16_);
#line 99 "../src/PrinterPage.vala"
		if ((type & CUPS_PRINTER_CLASS) == CUPS_PRINTER_CLASS) {
#line 368 "PrinterPage.c"
			PrintersPrinter* _tmp17_;
			cups_dest_t _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			PrintersPrinter* _tmp21_;
			cups_dest_t _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
#line 100 "../src/PrinterPage.vala"
			_tmp17_ = self->priv->_printer;
#line 100 "../src/PrinterPage.vala"
			_tmp18_ = _tmp17_->dest;
#line 100 "../src/PrinterPage.vala"
			_tmp19_ = _tmp18_.name;
#line 100 "../src/PrinterPage.vala"
			_tmp20_ = g_strdup_printf ("ipp://localhost/classes/%s", _tmp19_);
#line 100 "../src/PrinterPage.vala"
			_g_free0 (printer_uri);
#line 100 "../src/PrinterPage.vala"
			printer_uri = _tmp20_;
#line 101 "../src/PrinterPage.vala"
			_tmp21_ = self->priv->_printer;
#line 101 "../src/PrinterPage.vala"
			_tmp22_ = _tmp21_->dest;
#line 101 "../src/PrinterPage.vala"
			_tmp23_ = _tmp22_.name;
#line 101 "../src/PrinterPage.vala"
			_tmp24_ = g_strdup_printf ("/classes/%s", _tmp23_);
#line 101 "../src/PrinterPage.vala"
			_g_free0 (resource);
#line 101 "../src/PrinterPage.vala"
			resource = _tmp24_;
#line 401 "PrinterPage.c"
		} else {
			PrintersPrinter* _tmp25_;
			cups_dest_t _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			PrintersPrinter* _tmp29_;
			cups_dest_t _tmp30_;
			const gchar* _tmp31_;
			gchar* _tmp32_;
#line 103 "../src/PrinterPage.vala"
			_tmp25_ = self->priv->_printer;
#line 103 "../src/PrinterPage.vala"
			_tmp26_ = _tmp25_->dest;
#line 103 "../src/PrinterPage.vala"
			_tmp27_ = _tmp26_.name;
#line 103 "../src/PrinterPage.vala"
			_tmp28_ = g_strdup_printf ("ipp://localhost/printers/%s", _tmp27_);
#line 103 "../src/PrinterPage.vala"
			_g_free0 (printer_uri);
#line 103 "../src/PrinterPage.vala"
			printer_uri = _tmp28_;
#line 104 "../src/PrinterPage.vala"
			_tmp29_ = self->priv->_printer;
#line 104 "../src/PrinterPage.vala"
			_tmp30_ = _tmp29_->dest;
#line 104 "../src/PrinterPage.vala"
			_tmp31_ = _tmp30_.name;
#line 104 "../src/PrinterPage.vala"
			_tmp32_ = g_strdup_printf ("/printers/%s", _tmp31_);
#line 104 "../src/PrinterPage.vala"
			_g_free0 (resource);
#line 104 "../src/PrinterPage.vala"
			resource = _tmp32_;
#line 435 "PrinterPage.c"
		}
#line 107 "../src/PrinterPage.vala"
		_tmp33_ = ippNewRequest (IPP_PRINT_JOB);
#line 107 "../src/PrinterPage.vala"
		request = _tmp33_;
#line 108 "../src/PrinterPage.vala"
		_tmp34_ = request;
#line 108 "../src/PrinterPage.vala"
		_tmp35_ = printer_uri;
#line 108 "../src/PrinterPage.vala"
		ippAddString (_tmp34_, IPP_TAG_OPERATION, IPP_TAG_URI, "printer-uri", NULL, _tmp35_);
#line 109 "../src/PrinterPage.vala"
		_tmp36_ = request;
#line 109 "../src/PrinterPage.vala"
		_tmp37_ = cupsUser ();
#line 109 "../src/PrinterPage.vala"
		ippAddString (_tmp36_, IPP_TAG_OPERATION, IPP_TAG_NAME, "requesting-user-name", NULL, _tmp37_);
#line 111 "../src/PrinterPage.vala"
		_tmp38_ = request;
#line 111 "../src/PrinterPage.vala"
		ippAddString (_tmp38_, IPP_TAG_OPERATION, IPP_TAG_NAME, "job-name", NULL, _ ("Test page"));
#line 112 "../src/PrinterPage.vala"
		_tmp39_ = CUPS_HTTP_DEFAULT;
#line 112 "../src/PrinterPage.vala"
		_tmp40_ = resource;
#line 112 "../src/PrinterPage.vala"
		_tmp41_ = filename;
#line 112 "../src/PrinterPage.vala"
		request = cupsDoFileRequest (_tmp39_, request, _tmp40_, _tmp41_);
#line 96 "../src/PrinterPage.vala"
		_ippDelete0 (request);
#line 96 "../src/PrinterPage.vala"
		_g_free0 (resource);
#line 96 "../src/PrinterPage.vala"
		_g_free0 (printer_uri);
#line 471 "PrinterPage.c"
	}
#line 81 "../src/PrinterPage.vala"
	_g_free0 (datadir);
#line 81 "../src/PrinterPage.vala"
	_g_free0 (filename);
#line 477 "PrinterPage.c"
}

PrintersPrinter*
printers_printer_page_get_printer (PrintersPrinterPage* self)
{
	PrintersPrinter* result;
	PrintersPrinter* _tmp0_;
#line 24 "../src/PrinterPage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/PrinterPage.vala"
	_tmp0_ = self->priv->_printer;
#line 24 "../src/PrinterPage.vala"
	result = _tmp0_;
#line 24 "../src/PrinterPage.vala"
	return result;
#line 493 "PrinterPage.c"
}

static void
printers_printer_page_set_printer (PrintersPrinterPage* self,
                                   PrintersPrinter* value)
{
	PrintersPrinter* old_value;
#line 24 "../src/PrinterPage.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/PrinterPage.vala"
	old_value = printers_printer_page_get_printer (self);
#line 24 "../src/PrinterPage.vala"
	if (old_value != value) {
#line 24 "../src/PrinterPage.vala"
		self->priv->_printer = value;
#line 24 "../src/PrinterPage.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_printer_page_properties[PRINTERS_PRINTER_PAGE_PRINTER_PROPERTY]);
#line 511 "PrinterPage.c"
	}
}

static void
_printers_printer_page___lambda22_ (PrintersPrinterPage* self)
{
#line 53 "../src/PrinterPage.vala"
	printers_printer_page_print_test_page (self);
#line 520 "PrinterPage.c"
}

static void
__printers_printer_page___lambda22__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 53 "../src/PrinterPage.vala"
	_printers_printer_page___lambda22_ ((PrintersPrinterPage*) self);
#line 529 "PrinterPage.c"
}

static GObject *
printers_printer_page_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PrintersPrinterPage * self;
	GtkStack* stack = NULL;
	GtkStack* _tmp0_;
	PrintersJobsView* jobs_view = NULL;
	PrintersPrinter* _tmp1_;
	PrintersJobsView* _tmp2_;
	GtkStack* _tmp3_;
	PrintersJobsView* _tmp4_;
	GtkStack* _tmp5_;
	PrintersPrinter* _tmp6_;
	PrintersOptionsPage* _tmp7_;
	PrintersOptionsPage* _tmp8_;
	GtkStack* _tmp9_;
	PrintersPrinter* _tmp10_;
	PrintersSuppliesView* _tmp11_;
	PrintersSuppliesView* _tmp12_;
	GtkStackSwitcher* stack_switcher = NULL;
	GtkStackSwitcher* _tmp13_;
	GtkStackSwitcher* _tmp14_;
	GtkStackSwitcher* _tmp15_;
	GtkStackSwitcher* _tmp16_;
	GtkStack* _tmp17_;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GtkGrid* _tmp20_;
	GtkGrid* _tmp21_;
	GtkStackSwitcher* _tmp22_;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkStack* _tmp25_;
	GtkButton* print_test = NULL;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkButtonBox* _tmp28_;
	GtkButtonBox* _tmp29_;
	GtkButton* _tmp30_;
	PrintersPrinter* _tmp31_;
	PrintersPrinter* _tmp32_;
	GtkSwitch* _tmp33_;
	GtkSwitch* _tmp34_;
	PrintersPrinter* _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	GtkButton* _tmp38_;
	GtkSwitch* _tmp39_;
	GtkSwitch* _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	GtkSwitch* _tmp43_;
	GtkSwitch* _tmp44_;
	PrintersPrinter* _tmp45_;
	GtkSwitch* _tmp46_;
	GtkSwitch* _tmp47_;
	GtkButton* _tmp48_;
#line 36 "../src/PrinterPage.vala"
	parent_class = G_OBJECT_CLASS (printers_printer_page_parent_class);
#line 36 "../src/PrinterPage.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../src/PrinterPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_PRINTER_PAGE, PrintersPrinterPage);
#line 37 "../src/PrinterPage.vala"
	_tmp0_ = (GtkStack*) gtk_stack_new ();
#line 37 "../src/PrinterPage.vala"
	g_object_ref_sink (_tmp0_);
#line 37 "../src/PrinterPage.vala"
	stack = _tmp0_;
#line 38 "../src/PrinterPage.vala"
	_tmp1_ = self->priv->_printer;
#line 38 "../src/PrinterPage.vala"
	_tmp2_ = printers_jobs_view_new (_tmp1_);
#line 38 "../src/PrinterPage.vala"
	g_object_ref_sink (_tmp2_);
#line 38 "../src/PrinterPage.vala"
	jobs_view = _tmp2_;
#line 39 "../src/PrinterPage.vala"
	_tmp3_ = stack;
#line 39 "../src/PrinterPage.vala"
	_tmp4_ = jobs_view;
#line 39 "../src/PrinterPage.vala"
	gtk_stack_add_titled (_tmp3_, (GtkWidget*) _tmp4_, "general", _ ("Print Queue"));
#line 40 "../src/PrinterPage.vala"
	_tmp5_ = stack;
#line 40 "../src/PrinterPage.vala"
	_tmp6_ = self->priv->_printer;
#line 40 "../src/PrinterPage.vala"
	_tmp7_ = printers_options_page_new (_tmp6_);
#line 40 "../src/PrinterPage.vala"
	g_object_ref_sink (_tmp7_);
#line 40 "../src/PrinterPage.vala"
	_tmp8_ = _tmp7_;
#line 40 "../src/PrinterPage.vala"
	gtk_stack_add_titled (_tmp5_, (GtkWidget*) _tmp8_, "options", _ ("Page Setup"));
#line 40 "../src/PrinterPage.vala"
	_g_object_unref0 (_tmp8_);
#line 41 "../src/PrinterPage.vala"
	_tmp9_ = stack;
#line 41 "../src/PrinterPage.vala"
	_tmp10_ = self->priv->_printer;
#line 41 "../src/PrinterPage.vala"
	_tmp11_ = printers_supplies_view_new (_tmp10_);
#line 41 "../src/PrinterPage.vala"
	g_object_ref_sink (_tmp11_);
#line 41 "../src/PrinterPage.vala"
	_tmp12_ = _tmp11_;
#line 41 "../src/PrinterPage.vala"
	gtk_stack_add_titled (_tmp9_, (GtkWidget*) _tmp12_, "supplies", _ ("Settings & Supplies"));
#line 41 "../src/PrinterPage.vala"
	_g_object_unref0 (_tmp12_);
#line 43 "../src/PrinterPage.vala"
	_tmp13_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 43 "../src/PrinterPage.vala"
	g_object_ref_sink (_tmp13_);
#line 43 "../src/PrinterPage.vala"
	stack_switcher = _tmp13_;
#line 44 "../src/PrinterPage.vala"
	_tmp14_ = stack_switcher;
#line 44 "../src/PrinterPage.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
#line 45 "../src/PrinterPage.vala"
	_tmp15_ = stack_switcher;
#line 45 "../src/PrinterPage.vala"
	gtk_box_set_homogeneous ((GtkBox*) _tmp15_, TRUE);
#line 46 "../src/PrinterPage.vala"
	_tmp16_ = stack_switcher;
#line 46 "../src/PrinterPage.vala"
	_tmp17_ = stack;
#line 46 "../src/PrinterPage.vala"
	gtk_stack_switcher_set_stack (_tmp16_, _tmp17_);
#line 48 "../src/PrinterPage.vala"
	_tmp18_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 48 "../src/PrinterPage.vala"
	_tmp19_ = _tmp18_;
#line 48 "../src/PrinterPage.vala"
	gtk_grid_set_row_spacing (_tmp19_, 24);
#line 49 "../src/PrinterPage.vala"
	_tmp20_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 49 "../src/PrinterPage.vala"
	_tmp21_ = _tmp20_;
#line 49 "../src/PrinterPage.vala"
	_tmp22_ = stack_switcher;
#line 49 "../src/PrinterPage.vala"
	gtk_grid_attach (_tmp21_, (GtkWidget*) _tmp22_, 0, 1, 1, 1);
#line 50 "../src/PrinterPage.vala"
	_tmp23_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 50 "../src/PrinterPage.vala"
	_tmp24_ = _tmp23_;
#line 50 "../src/PrinterPage.vala"
	_tmp25_ = stack;
#line 50 "../src/PrinterPage.vala"
	gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 0, 2, 1, 1);
#line 52 "../src/PrinterPage.vala"
	_tmp26_ = (GtkButton*) gtk_button_new_with_label (_ ("Print Test Page"));
#line 52 "../src/PrinterPage.vala"
	g_object_ref_sink (_tmp26_);
#line 52 "../src/PrinterPage.vala"
	print_test = _tmp26_;
#line 53 "../src/PrinterPage.vala"
	_tmp27_ = print_test;
#line 53 "../src/PrinterPage.vala"
	g_signal_connect_object (_tmp27_, "clicked", (GCallback) __printers_printer_page___lambda22__gtk_button_clicked, self, 0);
#line 55 "../src/PrinterPage.vala"
	_tmp28_ = granite_simple_settings_page_get_action_area ((GraniteSimpleSettingsPage*) self);
#line 55 "../src/PrinterPage.vala"
	_tmp29_ = _tmp28_;
#line 55 "../src/PrinterPage.vala"
	_tmp30_ = print_test;
#line 55 "../src/PrinterPage.vala"
	gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp30_);
#line 57 "../src/PrinterPage.vala"
	_tmp31_ = self->priv->_printer;
#line 57 "../src/PrinterPage.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp31_, "info", (GObject*) self, "title", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 58 "../src/PrinterPage.vala"
	_tmp32_ = self->priv->_printer;
#line 58 "../src/PrinterPage.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp32_, "location", (GObject*) self, "description", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 60 "../src/PrinterPage.vala"
	_tmp33_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 60 "../src/PrinterPage.vala"
	_tmp34_ = _tmp33_;
#line 60 "../src/PrinterPage.vala"
	_tmp35_ = self->priv->_printer;
#line 60 "../src/PrinterPage.vala"
	_tmp36_ = printers_printer_get_is_enabled (_tmp35_);
#line 60 "../src/PrinterPage.vala"
	_tmp37_ = _tmp36_;
#line 60 "../src/PrinterPage.vala"
	gtk_switch_set_active (_tmp34_, _tmp37_);
#line 61 "../src/PrinterPage.vala"
	_tmp38_ = print_test;
#line 61 "../src/PrinterPage.vala"
	_tmp39_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 61 "../src/PrinterPage.vala"
	_tmp40_ = _tmp39_;
#line 61 "../src/PrinterPage.vala"
	_tmp41_ = gtk_switch_get_active (_tmp40_);
#line 61 "../src/PrinterPage.vala"
	_tmp42_ = _tmp41_;
#line 61 "../src/PrinterPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp38_, _tmp42_);
#line 63 "../src/PrinterPage.vala"
	_tmp43_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 63 "../src/PrinterPage.vala"
	_tmp44_ = _tmp43_;
#line 63 "../src/PrinterPage.vala"
	_tmp45_ = self->priv->_printer;
#line 63 "../src/PrinterPage.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp44_, "active", (GObject*) _tmp45_, "is-enabled", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 64 "../src/PrinterPage.vala"
	_tmp46_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 64 "../src/PrinterPage.vala"
	_tmp47_ = _tmp46_;
#line 64 "../src/PrinterPage.vala"
	_tmp48_ = print_test;
#line 64 "../src/PrinterPage.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp47_, "active", (GObject*) _tmp48_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 66 "../src/PrinterPage.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 36 "../src/PrinterPage.vala"
	_g_object_unref0 (print_test);
#line 36 "../src/PrinterPage.vala"
	_g_object_unref0 (stack_switcher);
#line 36 "../src/PrinterPage.vala"
	_g_object_unref0 (jobs_view);
#line 36 "../src/PrinterPage.vala"
	_g_object_unref0 (stack);
#line 36 "../src/PrinterPage.vala"
	return obj;
#line 767 "PrinterPage.c"
}

static void
printers_printer_page_class_init (PrintersPrinterPageClass * klass,
                                  gpointer klass_data)
{
#line 23 "../src/PrinterPage.vala"
	printers_printer_page_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/PrinterPage.vala"
	g_type_class_adjust_private_offset (klass, &PrintersPrinterPage_private_offset);
#line 23 "../src/PrinterPage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_printers_printer_page_get_property;
#line 23 "../src/PrinterPage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_printers_printer_page_set_property;
#line 23 "../src/PrinterPage.vala"
	G_OBJECT_CLASS (klass)->constructor = printers_printer_page_constructor;
#line 23 "../src/PrinterPage.vala"
	G_OBJECT_CLASS (klass)->finalize = printers_printer_page_finalize;
#line 23 "../src/PrinterPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_PAGE_PRINTER_PROPERTY, printers_printer_page_properties[PRINTERS_PRINTER_PAGE_PRINTER_PROPERTY] = g_param_spec_object ("printer", "printer", "printer", PRINTERS_TYPE_PRINTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 788 "PrinterPage.c"
}

static void
printers_printer_page_instance_init (PrintersPrinterPage * self,
                                     gpointer klass)
{
#line 23 "../src/PrinterPage.vala"
	self->priv = printers_printer_page_get_instance_private (self);
#line 797 "PrinterPage.c"
}

static void
printers_printer_page_finalize (GObject * obj)
{
	PrintersPrinterPage * self;
#line 23 "../src/PrinterPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_PRINTER_PAGE, PrintersPrinterPage);
#line 23 "../src/PrinterPage.vala"
	G_OBJECT_CLASS (printers_printer_page_parent_class)->finalize (obj);
#line 808 "PrinterPage.c"
}

static GType
printers_printer_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersPrinterPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_printer_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersPrinterPage), 0, (GInstanceInitFunc) printers_printer_page_instance_init, NULL };
	GType printers_printer_page_type_id;
	printers_printer_page_type_id = g_type_register_static (GRANITE_TYPE_SIMPLE_SETTINGS_PAGE, "PrintersPrinterPage", &g_define_type_info, 0);
	PrintersPrinterPage_private_offset = g_type_add_instance_private (printers_printer_page_type_id, sizeof (PrintersPrinterPagePrivate));
	return printers_printer_page_type_id;
}

GType
printers_printer_page_get_type (void)
{
	static volatile gsize printers_printer_page_type_id__once = 0;
	if (g_once_init_enter (&printers_printer_page_type_id__once)) {
		GType printers_printer_page_type_id;
		printers_printer_page_type_id = printers_printer_page_get_type_once ();
		g_once_init_leave (&printers_printer_page_type_id__once, printers_printer_page_type_id);
	}
	return printers_printer_page_type_id__once;
}

static void
_vala_printers_printer_page_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	PrintersPrinterPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_PRINTER_PAGE, PrintersPrinterPage);
#line 23 "../src/PrinterPage.vala"
	switch (property_id) {
#line 23 "../src/PrinterPage.vala"
		case PRINTERS_PRINTER_PAGE_PRINTER_PROPERTY:
#line 23 "../src/PrinterPage.vala"
		g_value_set_object (value, printers_printer_page_get_printer (self));
#line 23 "../src/PrinterPage.vala"
		break;
#line 849 "PrinterPage.c"
		default:
#line 23 "../src/PrinterPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/PrinterPage.vala"
		break;
#line 855 "PrinterPage.c"
	}
}

static void
_vala_printers_printer_page_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	PrintersPrinterPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_PRINTER_PAGE, PrintersPrinterPage);
#line 23 "../src/PrinterPage.vala"
	switch (property_id) {
#line 23 "../src/PrinterPage.vala"
		case PRINTERS_PRINTER_PAGE_PRINTER_PROPERTY:
#line 23 "../src/PrinterPage.vala"
		printers_printer_page_set_printer (self, g_value_get_object (value));
#line 23 "../src/PrinterPage.vala"
		break;
#line 875 "PrinterPage.c"
		default:
#line 23 "../src/PrinterPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/PrinterPage.vala"
		break;
#line 881 "PrinterPage.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

