/* JobRow.c generated by valac 0.56.13, the Vala compiler
 * generated from JobRow.vala, do not modify */

/*-
 * Copyright 2015 - 2022 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include "cups/ipp.h"
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <pango/pango.h>

enum  {
	PRINTERS_JOB_ROW_0_PROPERTY,
	PRINTERS_JOB_ROW_JOB_PROPERTY,
	PRINTERS_JOB_ROW_PRINTER_PROPERTY,
	PRINTERS_JOB_ROW_NUM_PROPERTIES
};
static GParamSpec* printers_job_row_properties[PRINTERS_JOB_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block16Data Block16Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PrintersJobRowPrivate {
	PrintersJob* _job;
	PrintersPrinter* _printer;
	GtkButton* start_pause_button;
	GtkImage* job_state_icon;
	GtkRevealer* action_revealer;
	GtkLabel* date_label;
	GtkLabel* state_label;
};

struct _Block16Data {
	int _ref_count_;
	PrintersJobRow* self;
	GtkButton* cancel_button;
};

static gint PrintersJobRow_private_offset;
static gpointer printers_job_row_parent_class = NULL;
static GtkSizeGroup* printers_job_row_size_group;
static GtkSizeGroup* printers_job_row_size_group = NULL;

static void printers_job_row_update_state (PrintersJobRow* self);
static GObject * printers_job_row_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static void _printers_job_row_update_state_printers_job_state_changed (PrintersJob* _sender,
                                                                gpointer self);
static void _printers_job_row___lambda6_ (PrintersJobRow* self);
static void __printers_job_row___lambda6__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _printers_job_row___lambda7_ (Block16Data* _data16_);
static void __printers_job_row___lambda7__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void printers_job_row_finalize (GObject * obj);
static GType printers_job_row_get_type_once (void);
static void _vala_printers_job_row_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_printers_job_row_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
printers_job_row_get_instance_private (PrintersJobRow* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersJobRow_private_offset);
}

PrintersJobRow*
printers_job_row_construct (GType object_type,
                            PrintersPrinter* printer,
                            PrintersJob* job)
{
	PrintersJobRow * self = NULL;
#line 34 "../src/Widgets/JobRow.vala"
	g_return_val_if_fail (printer != NULL, NULL);
#line 34 "../src/Widgets/JobRow.vala"
	g_return_val_if_fail (job != NULL, NULL);
#line 35 "../src/Widgets/JobRow.vala"
	self = (PrintersJobRow*) g_object_new (object_type, "job", job, "printer", printer, NULL);
#line 34 "../src/Widgets/JobRow.vala"
	return self;
#line 117 "JobRow.c"
}

PrintersJobRow*
printers_job_row_new (PrintersPrinter* printer,
                      PrintersJob* job)
{
#line 34 "../src/Widgets/JobRow.vala"
	return printers_job_row_construct (PRINTERS_TYPE_JOB_ROW, printer, job);
#line 126 "JobRow.c"
}

static void
printers_job_row_update_state (PrintersJobRow* self)
{
	GtkImage* _tmp0_;
	PrintersJob* _tmp1_;
	GIcon* _tmp2_;
	GIcon* _tmp3_;
	PrintersJob* _tmp4_;
	ipp_jstate_t _tmp5_;
	ipp_jstate_t _tmp6_;
	GtkLabel* _tmp19_;
	PrintersJob* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GDateTime* time = NULL;
	PrintersJob* _tmp23_;
	GDateTime* _tmp24_;
	GDateTime* _tmp25_;
#line 156 "../src/Widgets/JobRow.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/Widgets/JobRow.vala"
	_tmp0_ = self->priv->job_state_icon;
#line 157 "../src/Widgets/JobRow.vala"
	_tmp1_ = self->priv->_job;
#line 157 "../src/Widgets/JobRow.vala"
	_tmp2_ = printers_job_state_icon (_tmp1_);
#line 157 "../src/Widgets/JobRow.vala"
	_tmp3_ = _tmp2_;
#line 157 "../src/Widgets/JobRow.vala"
	g_object_set (_tmp0_, "gicon", _tmp3_, NULL);
#line 157 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (_tmp3_);
#line 159 "../src/Widgets/JobRow.vala"
	_tmp4_ = self->priv->_job;
#line 159 "../src/Widgets/JobRow.vala"
	_tmp5_ = printers_job_get_state (_tmp4_);
#line 159 "../src/Widgets/JobRow.vala"
	_tmp6_ = _tmp5_;
#line 159 "../src/Widgets/JobRow.vala"
	if (_tmp6_ == IPP_JOB_HELD) {
#line 169 "JobRow.c"
		GtkButton* _tmp7_;
		GtkRevealer* _tmp8_;
#line 160 "../src/Widgets/JobRow.vala"
		_tmp7_ = self->priv->start_pause_button;
#line 160 "../src/Widgets/JobRow.vala"
		gtk_button_set_label (_tmp7_, _ ("Resume"));
#line 161 "../src/Widgets/JobRow.vala"
		_tmp8_ = self->priv->action_revealer;
#line 161 "../src/Widgets/JobRow.vala"
		gtk_revealer_set_reveal_child (_tmp8_, TRUE);
#line 180 "JobRow.c"
	} else {
		gboolean _tmp9_ = FALSE;
		PrintersJob* _tmp10_;
		ipp_jstate_t _tmp11_;
		ipp_jstate_t _tmp12_;
#line 162 "../src/Widgets/JobRow.vala"
		_tmp10_ = self->priv->_job;
#line 162 "../src/Widgets/JobRow.vala"
		_tmp11_ = printers_job_get_state (_tmp10_);
#line 162 "../src/Widgets/JobRow.vala"
		_tmp12_ = _tmp11_;
#line 162 "../src/Widgets/JobRow.vala"
		if (_tmp12_ == IPP_JOB_PROCESSING) {
#line 162 "../src/Widgets/JobRow.vala"
			_tmp9_ = TRUE;
#line 196 "JobRow.c"
		} else {
			PrintersJob* _tmp13_;
			ipp_jstate_t _tmp14_;
			ipp_jstate_t _tmp15_;
#line 163 "../src/Widgets/JobRow.vala"
			_tmp13_ = self->priv->_job;
#line 163 "../src/Widgets/JobRow.vala"
			_tmp14_ = printers_job_get_state (_tmp13_);
#line 163 "../src/Widgets/JobRow.vala"
			_tmp15_ = _tmp14_;
#line 163 "../src/Widgets/JobRow.vala"
			_tmp9_ = _tmp15_ == IPP_JOB_PENDING;
#line 209 "JobRow.c"
		}
#line 162 "../src/Widgets/JobRow.vala"
		if (_tmp9_) {
#line 213 "JobRow.c"
			GtkButton* _tmp16_;
			GtkRevealer* _tmp17_;
#line 165 "../src/Widgets/JobRow.vala"
			_tmp16_ = self->priv->start_pause_button;
#line 165 "../src/Widgets/JobRow.vala"
			gtk_button_set_label (_tmp16_, _ ("Pause"));
#line 166 "../src/Widgets/JobRow.vala"
			_tmp17_ = self->priv->action_revealer;
#line 166 "../src/Widgets/JobRow.vala"
			gtk_revealer_set_reveal_child (_tmp17_, TRUE);
#line 224 "JobRow.c"
		} else {
			GtkRevealer* _tmp18_;
#line 168 "../src/Widgets/JobRow.vala"
			_tmp18_ = self->priv->action_revealer;
#line 168 "../src/Widgets/JobRow.vala"
			gtk_revealer_set_reveal_child (_tmp18_, FALSE);
#line 231 "JobRow.c"
		}
	}
#line 171 "../src/Widgets/JobRow.vala"
	_tmp19_ = self->priv->state_label;
#line 171 "../src/Widgets/JobRow.vala"
	_tmp20_ = self->priv->_job;
#line 171 "../src/Widgets/JobRow.vala"
	_tmp21_ = printers_job_translated_job_state (_tmp20_);
#line 171 "../src/Widgets/JobRow.vala"
	_tmp22_ = _tmp21_;
#line 171 "../src/Widgets/JobRow.vala"
	gtk_label_set_label (_tmp19_, _tmp22_);
#line 171 "../src/Widgets/JobRow.vala"
	_g_free0 (_tmp22_);
#line 172 "../src/Widgets/JobRow.vala"
	_tmp23_ = self->priv->_job;
#line 172 "../src/Widgets/JobRow.vala"
	_tmp24_ = printers_job_get_display_time (_tmp23_);
#line 172 "../src/Widgets/JobRow.vala"
	time = _tmp24_;
#line 173 "../src/Widgets/JobRow.vala"
	_tmp25_ = time;
#line 173 "../src/Widgets/JobRow.vala"
	if (_tmp25_ != NULL) {
#line 256 "JobRow.c"
		GtkLabel* _tmp26_;
		GDateTime* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 174 "../src/Widgets/JobRow.vala"
		_tmp26_ = self->priv->date_label;
#line 174 "../src/Widgets/JobRow.vala"
		_tmp27_ = time;
#line 174 "../src/Widgets/JobRow.vala"
		_tmp28_ = granite_date_time_get_relative_datetime (_tmp27_);
#line 174 "../src/Widgets/JobRow.vala"
		_tmp29_ = _tmp28_;
#line 174 "../src/Widgets/JobRow.vala"
		gtk_label_set_label (_tmp26_, _tmp29_);
#line 174 "../src/Widgets/JobRow.vala"
		_g_free0 (_tmp29_);
#line 273 "JobRow.c"
	} else {
		GtkLabel* _tmp30_;
#line 176 "../src/Widgets/JobRow.vala"
		_tmp30_ = self->priv->date_label;
#line 176 "../src/Widgets/JobRow.vala"
		gtk_label_set_label (_tmp30_, NULL);
#line 280 "JobRow.c"
	}
#line 179 "../src/Widgets/JobRow.vala"
	gtk_list_box_row_changed ((GtkListBoxRow*) self);
#line 156 "../src/Widgets/JobRow.vala"
	_g_date_time_unref0 (time);
#line 286 "JobRow.c"
}

PrintersJob*
printers_job_row_get_job (PrintersJobRow* self)
{
	PrintersJob* result;
	PrintersJob* _tmp0_;
#line 23 "../src/Widgets/JobRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/JobRow.vala"
	_tmp0_ = self->priv->_job;
#line 23 "../src/Widgets/JobRow.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/JobRow.vala"
	return result;
#line 302 "JobRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 23 "../src/Widgets/JobRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 310 "JobRow.c"
}

void
printers_job_row_set_job (PrintersJobRow* self,
                          PrintersJob* value)
{
	PrintersJob* old_value;
#line 23 "../src/Widgets/JobRow.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/JobRow.vala"
	old_value = printers_job_row_get_job (self);
#line 23 "../src/Widgets/JobRow.vala"
	if (old_value != value) {
#line 324 "JobRow.c"
		PrintersJob* _tmp0_;
#line 23 "../src/Widgets/JobRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Widgets/JobRow.vala"
		_g_object_unref0 (self->priv->_job);
#line 23 "../src/Widgets/JobRow.vala"
		self->priv->_job = _tmp0_;
#line 23 "../src/Widgets/JobRow.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_job_row_properties[PRINTERS_JOB_ROW_JOB_PROPERTY]);
#line 334 "JobRow.c"
	}
}

PrintersPrinter*
printers_job_row_get_printer (PrintersJobRow* self)
{
	PrintersPrinter* result;
	PrintersPrinter* _tmp0_;
#line 24 "../src/Widgets/JobRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/JobRow.vala"
	_tmp0_ = self->priv->_printer;
#line 24 "../src/Widgets/JobRow.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/JobRow.vala"
	return result;
#line 351 "JobRow.c"
}

void
printers_job_row_set_printer (PrintersJobRow* self,
                              PrintersPrinter* value)
{
	PrintersPrinter* old_value;
#line 24 "../src/Widgets/JobRow.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/JobRow.vala"
	old_value = printers_job_row_get_printer (self);
#line 24 "../src/Widgets/JobRow.vala"
	if (old_value != value) {
#line 365 "JobRow.c"
		PrintersPrinter* _tmp0_;
#line 24 "../src/Widgets/JobRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/Widgets/JobRow.vala"
		_g_object_unref0 (self->priv->_printer);
#line 24 "../src/Widgets/JobRow.vala"
		self->priv->_printer = _tmp0_;
#line 24 "../src/Widgets/JobRow.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_job_row_properties[PRINTERS_JOB_ROW_PRINTER_PROPERTY]);
#line 375 "JobRow.c"
	}
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 45 "../src/Widgets/JobRow.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 45 "../src/Widgets/JobRow.vala"
	return _data16_;
#line 386 "JobRow.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 45 "../src/Widgets/JobRow.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 396 "JobRow.c"
		PrintersJobRow* self;
#line 45 "../src/Widgets/JobRow.vala"
		self = _data16_->self;
#line 45 "../src/Widgets/JobRow.vala"
		_g_object_unref0 (_data16_->cancel_button);
#line 45 "../src/Widgets/JobRow.vala"
		_g_object_unref0 (self);
#line 45 "../src/Widgets/JobRow.vala"
		g_slice_free (Block16Data, _data16_);
#line 406 "JobRow.c"
	}
}

static void
_printers_job_row_update_state_printers_job_state_changed (PrintersJob* _sender,
                                                           gpointer self)
{
#line 121 "../src/Widgets/JobRow.vala"
	printers_job_row_update_state ((PrintersJobRow*) self);
#line 416 "JobRow.c"
}

static void
_printers_job_row___lambda6_ (PrintersJobRow* self)
{
	CupsPkHelper* pk_helper = NULL;
	CupsPkHelper* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PrintersJob* _tmp2_;
	ipp_jstate_t _tmp3_;
	ipp_jstate_t _tmp4_;
	GError* _inner_error0_ = NULL;
#line 124 "../src/Widgets/JobRow.vala"
	_tmp0_ = cups_get_pk_helper ();
#line 124 "../src/Widgets/JobRow.vala"
	pk_helper = _tmp0_;
#line 125 "../src/Widgets/JobRow.vala"
	_tmp2_ = self->priv->_job;
#line 125 "../src/Widgets/JobRow.vala"
	_tmp3_ = printers_job_get_state (_tmp2_);
#line 125 "../src/Widgets/JobRow.vala"
	_tmp4_ = _tmp3_;
#line 125 "../src/Widgets/JobRow.vala"
	if (_tmp4_ == IPP_JOB_PROCESSING) {
#line 125 "../src/Widgets/JobRow.vala"
		_tmp1_ = TRUE;
#line 443 "JobRow.c"
	} else {
		PrintersJob* _tmp5_;
		ipp_jstate_t _tmp6_;
		ipp_jstate_t _tmp7_;
#line 126 "../src/Widgets/JobRow.vala"
		_tmp5_ = self->priv->_job;
#line 126 "../src/Widgets/JobRow.vala"
		_tmp6_ = printers_job_get_state (_tmp5_);
#line 126 "../src/Widgets/JobRow.vala"
		_tmp7_ = _tmp6_;
#line 126 "../src/Widgets/JobRow.vala"
		_tmp1_ = _tmp7_ == IPP_JOB_PENDING;
#line 456 "JobRow.c"
	}
#line 125 "../src/Widgets/JobRow.vala"
	if (_tmp1_) {
#line 460 "JobRow.c"
		{
			CupsPkHelper* _tmp8_;
			PrintersJob* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 129 "../src/Widgets/JobRow.vala"
			_tmp8_ = pk_helper;
#line 129 "../src/Widgets/JobRow.vala"
			_tmp9_ = self->priv->_job;
#line 129 "../src/Widgets/JobRow.vala"
			_tmp10_ = printers_job_get_uid (_tmp9_);
#line 129 "../src/Widgets/JobRow.vala"
			_tmp11_ = _tmp10_;
#line 129 "../src/Widgets/JobRow.vala"
			_tmp12_ = cups_pk_helper_job_set_hold_until (_tmp8_, _tmp11_, "indefinite", &_inner_error0_);
#line 129 "../src/Widgets/JobRow.vala"
			_tmp13_ = _tmp12_;
#line 129 "../src/Widgets/JobRow.vala"
			_g_free0 (_tmp13_);
#line 129 "../src/Widgets/JobRow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 484 "JobRow.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 128 "../src/Widgets/JobRow.vala"
			e = _inner_error0_;
#line 128 "../src/Widgets/JobRow.vala"
			_inner_error0_ = NULL;
#line 131 "../src/Widgets/JobRow.vala"
			_tmp14_ = e;
#line 131 "../src/Widgets/JobRow.vala"
			_tmp15_ = _tmp14_->message;
#line 131 "../src/Widgets/JobRow.vala"
			g_critical ("JobRow.vala:131: %s", _tmp15_);
#line 128 "../src/Widgets/JobRow.vala"
			_g_error_free0 (e);
#line 506 "JobRow.c"
		}
		__finally0:
#line 128 "../src/Widgets/JobRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "../src/Widgets/JobRow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 128 "../src/Widgets/JobRow.vala"
			g_clear_error (&_inner_error0_);
#line 128 "../src/Widgets/JobRow.vala"
			return;
#line 517 "JobRow.c"
		}
	} else {
		PrintersJob* _tmp16_;
		ipp_jstate_t _tmp17_;
		ipp_jstate_t _tmp18_;
#line 133 "../src/Widgets/JobRow.vala"
		_tmp16_ = self->priv->_job;
#line 133 "../src/Widgets/JobRow.vala"
		_tmp17_ = printers_job_get_state (_tmp16_);
#line 133 "../src/Widgets/JobRow.vala"
		_tmp18_ = _tmp17_;
#line 133 "../src/Widgets/JobRow.vala"
		if (_tmp18_ == IPP_JOB_HELD) {
#line 531 "JobRow.c"
			{
				CupsPkHelper* _tmp19_;
				PrintersJob* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
#line 135 "../src/Widgets/JobRow.vala"
				_tmp19_ = pk_helper;
#line 135 "../src/Widgets/JobRow.vala"
				_tmp20_ = self->priv->_job;
#line 135 "../src/Widgets/JobRow.vala"
				_tmp21_ = printers_job_get_uid (_tmp20_);
#line 135 "../src/Widgets/JobRow.vala"
				_tmp22_ = _tmp21_;
#line 135 "../src/Widgets/JobRow.vala"
				_tmp23_ = cups_pk_helper_job_set_hold_until (_tmp19_, _tmp22_, "no-hold", &_inner_error0_);
#line 135 "../src/Widgets/JobRow.vala"
				_tmp24_ = _tmp23_;
#line 135 "../src/Widgets/JobRow.vala"
				_g_free0 (_tmp24_);
#line 135 "../src/Widgets/JobRow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 555 "JobRow.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				GError* _tmp25_;
				const gchar* _tmp26_;
#line 134 "../src/Widgets/JobRow.vala"
				e = _inner_error0_;
#line 134 "../src/Widgets/JobRow.vala"
				_inner_error0_ = NULL;
#line 137 "../src/Widgets/JobRow.vala"
				_tmp25_ = e;
#line 137 "../src/Widgets/JobRow.vala"
				_tmp26_ = _tmp25_->message;
#line 137 "../src/Widgets/JobRow.vala"
				g_critical ("JobRow.vala:137: %s", _tmp26_);
#line 134 "../src/Widgets/JobRow.vala"
				_g_error_free0 (e);
#line 577 "JobRow.c"
			}
			__finally1:
#line 134 "../src/Widgets/JobRow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "../src/Widgets/JobRow.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 134 "../src/Widgets/JobRow.vala"
				g_clear_error (&_inner_error0_);
#line 134 "../src/Widgets/JobRow.vala"
				return;
#line 588 "JobRow.c"
			}
		} else {
#line 140 "../src/Widgets/JobRow.vala"
			g_critical ("JobRow.vala:140: Unexpected job state when trying to pause or resume");
#line 593 "JobRow.c"
		}
	}
}

static void
__printers_job_row___lambda6__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 123 "../src/Widgets/JobRow.vala"
	_printers_job_row___lambda6_ ((PrintersJobRow*) self);
#line 604 "JobRow.c"
}

static void
_printers_job_row___lambda7_ (Block16Data* _data16_)
{
	PrintersJobRow* self;
	CupsPkHelper* pk_helper = NULL;
	CupsPkHelper* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 144 "../src/Widgets/JobRow.vala"
	self = _data16_->self;
#line 145 "../src/Widgets/JobRow.vala"
	_tmp0_ = cups_get_pk_helper ();
#line 145 "../src/Widgets/JobRow.vala"
	pk_helper = _tmp0_;
#line 620 "JobRow.c"
	{
		CupsPkHelper* _tmp1_;
		PrintersJob* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GtkButton* _tmp7_;
		GtkButton* _tmp8_;
#line 147 "../src/Widgets/JobRow.vala"
		_tmp1_ = pk_helper;
#line 147 "../src/Widgets/JobRow.vala"
		_tmp2_ = self->priv->_job;
#line 147 "../src/Widgets/JobRow.vala"
		_tmp3_ = printers_job_get_uid (_tmp2_);
#line 147 "../src/Widgets/JobRow.vala"
		_tmp4_ = _tmp3_;
#line 147 "../src/Widgets/JobRow.vala"
		_tmp5_ = cups_pk_helper_job_cancel_purge (_tmp1_, _tmp4_, FALSE, &_inner_error0_);
#line 147 "../src/Widgets/JobRow.vala"
		_tmp6_ = _tmp5_;
#line 147 "../src/Widgets/JobRow.vala"
		_g_free0 (_tmp6_);
#line 147 "../src/Widgets/JobRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 646 "JobRow.c"
			goto __catch0_g_error;
		}
#line 148 "../src/Widgets/JobRow.vala"
		_tmp7_ = self->priv->start_pause_button;
#line 148 "../src/Widgets/JobRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 149 "../src/Widgets/JobRow.vala"
		_tmp8_ = _data16_->cancel_button;
#line 149 "../src/Widgets/JobRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 657 "JobRow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 146 "../src/Widgets/JobRow.vala"
		e = _inner_error0_;
#line 146 "../src/Widgets/JobRow.vala"
		_inner_error0_ = NULL;
#line 151 "../src/Widgets/JobRow.vala"
		_tmp9_ = e;
#line 151 "../src/Widgets/JobRow.vala"
		_tmp10_ = _tmp9_->message;
#line 151 "../src/Widgets/JobRow.vala"
		g_critical ("JobRow.vala:151: %s", _tmp10_);
#line 146 "../src/Widgets/JobRow.vala"
		_g_error_free0 (e);
#line 677 "JobRow.c"
	}
	__finally0:
#line 146 "../src/Widgets/JobRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../src/Widgets/JobRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 146 "../src/Widgets/JobRow.vala"
		g_clear_error (&_inner_error0_);
#line 146 "../src/Widgets/JobRow.vala"
		return;
#line 688 "JobRow.c"
	}
}

static void
__printers_job_row___lambda7__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 144 "../src/Widgets/JobRow.vala"
	_printers_job_row___lambda7_ (self);
#line 698 "JobRow.c"
}

static GObject *
printers_job_row_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PrintersJobRow * self;
	Block16Data* _data16_;
	GtkImage* icon = NULL;
	PrintersJob* _tmp0_;
	GIcon* _tmp1_;
	GIcon* _tmp2_;
	GtkImage* _tmp3_ = NULL;
	GtkImage* _tmp4_;
	PrintersJob* _tmp5_;
	GIcon* _tmp6_;
	GtkImage* _tmp7_ = NULL;
	GtkOverlay* icon_overlay = NULL;
	GtkOverlay* _tmp8_;
	GtkOverlay* _tmp9_;
	GtkImage* _tmp10_;
	GtkOverlay* _tmp11_;
	GtkImage* _tmp12_;
	GtkLabel* title = NULL;
	PrintersJob* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GtkLabel* _tmp16_ = NULL;
	GtkLabel* _tmp17_ = NULL;
	GtkLabel* _tmp18_;
	GtkStyleContext* _tmp19_;
	PrintersJob* _tmp20_;
	GDateTime* _tmp21_;
	GDateTime* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GtkLabel* _tmp25_ = NULL;
	GtkLabel* _tmp26_;
	GtkStyleContext* _tmp27_;
	gchar* _tmp28_;
	GtkButton* _tmp29_ = NULL;
	GtkButton* _tmp30_;
	GtkStyleContext* _tmp31_;
	GtkButton* _tmp32_;
	GtkStyleContext* _tmp33_;
	GtkButton* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkButton* _tmp36_ = NULL;
	GtkSizeGroup* _tmp37_;
	GtkButton* _tmp38_;
	GtkBox* action_box = NULL;
	GtkBox* _tmp39_ = NULL;
	GtkBox* _tmp40_;
	GtkButton* _tmp41_;
	GtkBox* _tmp42_;
	GtkButton* _tmp43_;
	GtkRevealer* _tmp44_ = NULL;
	GtkRevealer* _tmp45_;
	GtkBox* _tmp46_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp47_ = NULL;
	GtkGrid* _tmp48_;
	GtkOverlay* _tmp49_;
	GtkGrid* _tmp50_;
	GtkLabel* _tmp51_;
	GtkGrid* _tmp52_;
	GtkLabel* _tmp53_;
	GtkGrid* _tmp54_;
	GtkLabel* _tmp55_;
	GtkGrid* _tmp56_;
	GtkRevealer* _tmp57_;
	GtkGrid* _tmp58_;
	PrintersJob* _tmp59_;
	GtkButton* _tmp60_;
	GtkButton* _tmp61_;
#line 45 "../src/Widgets/JobRow.vala"
	parent_class = G_OBJECT_CLASS (printers_job_row_parent_class);
#line 45 "../src/Widgets/JobRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 45 "../src/Widgets/JobRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_JOB_ROW, PrintersJobRow);
#line 45 "../src/Widgets/JobRow.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 45 "../src/Widgets/JobRow.vala"
	_data16_->_ref_count_ = 1;
#line 45 "../src/Widgets/JobRow.vala"
	_data16_->self = g_object_ref (self);
#line 46 "../src/Widgets/JobRow.vala"
	_tmp0_ = self->priv->_job;
#line 46 "../src/Widgets/JobRow.vala"
	_tmp1_ = printers_job_get_file_icon (_tmp0_);
#line 46 "../src/Widgets/JobRow.vala"
	_tmp2_ = _tmp1_;
#line 46 "../src/Widgets/JobRow.vala"
	_tmp3_ = (GtkImage*) gtk_image_new_from_gicon (_tmp2_, (GtkIconSize) GTK_ICON_SIZE_DND);
#line 46 "../src/Widgets/JobRow.vala"
	gtk_image_set_pixel_size (_tmp3_, 32);
#line 46 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp3_);
#line 46 "../src/Widgets/JobRow.vala"
	_tmp4_ = _tmp3_;
#line 46 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (_tmp2_);
#line 46 "../src/Widgets/JobRow.vala"
	icon = _tmp4_;
#line 50 "../src/Widgets/JobRow.vala"
	_tmp5_ = self->priv->_job;
#line 50 "../src/Widgets/JobRow.vala"
	_tmp6_ = printers_job_state_icon (_tmp5_);
#line 50 "../src/Widgets/JobRow.vala"
	_tmp7_ = (GtkImage*) gtk_image_new ();
#line 50 "../src/Widgets/JobRow.vala"
	g_object_set (_tmp7_, "gicon", _tmp6_, NULL);
#line 50 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (_tmp6_);
#line 50 "../src/Widgets/JobRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_END);
#line 50 "../src/Widgets/JobRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_END);
#line 50 "../src/Widgets/JobRow.vala"
	g_object_set (_tmp7_, "icon-size", (gint) GTK_ICON_SIZE_SMALL_TOOLBAR, NULL);
#line 50 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp7_);
#line 50 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->job_state_icon);
#line 50 "../src/Widgets/JobRow.vala"
	self->priv->job_state_icon = _tmp7_;
#line 57 "../src/Widgets/JobRow.vala"
	_tmp8_ = (GtkOverlay*) gtk_overlay_new ();
#line 57 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp8_);
#line 57 "../src/Widgets/JobRow.vala"
	icon_overlay = _tmp8_;
#line 58 "../src/Widgets/JobRow.vala"
	_tmp9_ = icon_overlay;
#line 58 "../src/Widgets/JobRow.vala"
	_tmp10_ = icon;
#line 58 "../src/Widgets/JobRow.vala"
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
#line 59 "../src/Widgets/JobRow.vala"
	_tmp11_ = icon_overlay;
#line 59 "../src/Widgets/JobRow.vala"
	_tmp12_ = self->priv->job_state_icon;
#line 59 "../src/Widgets/JobRow.vala"
	gtk_overlay_add_overlay (_tmp11_, (GtkWidget*) _tmp12_);
#line 61 "../src/Widgets/JobRow.vala"
	_tmp13_ = self->priv->_job;
#line 61 "../src/Widgets/JobRow.vala"
	_tmp14_ = printers_job_get_title (_tmp13_);
#line 61 "../src/Widgets/JobRow.vala"
	_tmp15_ = _tmp14_;
#line 61 "../src/Widgets/JobRow.vala"
	_tmp16_ = (GtkLabel*) gtk_label_new (_tmp15_);
#line 61 "../src/Widgets/JobRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
#line 61 "../src/Widgets/JobRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, TRUE);
#line 61 "../src/Widgets/JobRow.vala"
	gtk_label_set_ellipsize (_tmp16_, PANGO_ELLIPSIZE_END);
#line 61 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp16_);
#line 61 "../src/Widgets/JobRow.vala"
	title = _tmp16_;
#line 67 "../src/Widgets/JobRow.vala"
	_tmp17_ = (GtkLabel*) gtk_label_new ("");
#line 67 "../src/Widgets/JobRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp17_, GTK_ALIGN_START);
#line 67 "../src/Widgets/JobRow.vala"
	gtk_label_set_ellipsize (_tmp17_, PANGO_ELLIPSIZE_END);
#line 67 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp17_);
#line 67 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->state_label);
#line 67 "../src/Widgets/JobRow.vala"
	self->priv->state_label = _tmp17_;
#line 71 "../src/Widgets/JobRow.vala"
	_tmp18_ = self->priv->state_label;
#line 71 "../src/Widgets/JobRow.vala"
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
#line 71 "../src/Widgets/JobRow.vala"
	gtk_style_context_add_class (_tmp19_, GRANITE_STYLE_CLASS_SMALL_LABEL);
#line 73 "../src/Widgets/JobRow.vala"
	_tmp20_ = self->priv->_job;
#line 73 "../src/Widgets/JobRow.vala"
	_tmp21_ = printers_job_get_creation_time (_tmp20_);
#line 73 "../src/Widgets/JobRow.vala"
	_tmp22_ = _tmp21_;
#line 73 "../src/Widgets/JobRow.vala"
	_tmp23_ = granite_date_time_get_relative_datetime (_tmp22_);
#line 73 "../src/Widgets/JobRow.vala"
	_tmp24_ = _tmp23_;
#line 73 "../src/Widgets/JobRow.vala"
	_tmp25_ = (GtkLabel*) gtk_label_new (_tmp24_);
#line 73 "../src/Widgets/JobRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp25_, GTK_ALIGN_END);
#line 73 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp25_);
#line 73 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->date_label);
#line 73 "../src/Widgets/JobRow.vala"
	self->priv->date_label = _tmp25_;
#line 73 "../src/Widgets/JobRow.vala"
	_g_free0 (_tmp24_);
#line 76 "../src/Widgets/JobRow.vala"
	_tmp26_ = self->priv->date_label;
#line 76 "../src/Widgets/JobRow.vala"
	_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
#line 76 "../src/Widgets/JobRow.vala"
	gtk_style_context_add_class (_tmp27_, GTK_STYLE_CLASS_DIM_LABEL);
#line 78 "../src/Widgets/JobRow.vala"
	_tmp28_ = g_strdup (_ ("Cancel"));
#line 78 "../src/Widgets/JobRow.vala"
	_tmp29_ = (GtkButton*) gtk_button_new_from_icon_name ("process-stop-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 78 "../src/Widgets/JobRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp29_, _tmp28_);
#line 78 "../src/Widgets/JobRow.vala"
	_g_free0 (_tmp28_);
#line 78 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp29_);
#line 78 "../src/Widgets/JobRow.vala"
	_data16_->cancel_button = _tmp29_;
#line 81 "../src/Widgets/JobRow.vala"
	_tmp30_ = _data16_->cancel_button;
#line 81 "../src/Widgets/JobRow.vala"
	_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
#line 81 "../src/Widgets/JobRow.vala"
	gtk_style_context_add_class (_tmp31_, GTK_STYLE_CLASS_FLAT);
#line 82 "../src/Widgets/JobRow.vala"
	_tmp32_ = _data16_->cancel_button;
#line 82 "../src/Widgets/JobRow.vala"
	_tmp33_ = gtk_widget_get_style_context ((GtkWidget*) _tmp32_);
#line 82 "../src/Widgets/JobRow.vala"
	gtk_style_context_add_class (_tmp33_, GRANITE_STYLE_CLASS_ACCENT);
#line 83 "../src/Widgets/JobRow.vala"
	_tmp34_ = _data16_->cancel_button;
#line 83 "../src/Widgets/JobRow.vala"
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
#line 83 "../src/Widgets/JobRow.vala"
	gtk_style_context_add_class (_tmp35_, "red");
#line 85 "../src/Widgets/JobRow.vala"
	_tmp36_ = (GtkButton*) gtk_button_new ();
#line 85 "../src/Widgets/JobRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp36_, GTK_ALIGN_CENTER);
#line 85 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp36_);
#line 85 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->start_pause_button);
#line 85 "../src/Widgets/JobRow.vala"
	self->priv->start_pause_button = _tmp36_;
#line 89 "../src/Widgets/JobRow.vala"
	_tmp37_ = printers_job_row_size_group;
#line 89 "../src/Widgets/JobRow.vala"
	_tmp38_ = self->priv->start_pause_button;
#line 89 "../src/Widgets/JobRow.vala"
	gtk_size_group_add_widget (_tmp37_, (GtkWidget*) _tmp38_);
#line 91 "../src/Widgets/JobRow.vala"
	_tmp39_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 91 "../src/Widgets/JobRow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp39_, 6);
#line 91 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp39_);
#line 91 "../src/Widgets/JobRow.vala"
	action_box = _tmp39_;
#line 94 "../src/Widgets/JobRow.vala"
	_tmp40_ = action_box;
#line 94 "../src/Widgets/JobRow.vala"
	_tmp41_ = _data16_->cancel_button;
#line 94 "../src/Widgets/JobRow.vala"
	gtk_container_add ((GtkContainer*) _tmp40_, (GtkWidget*) _tmp41_);
#line 95 "../src/Widgets/JobRow.vala"
	_tmp42_ = action_box;
#line 95 "../src/Widgets/JobRow.vala"
	_tmp43_ = self->priv->start_pause_button;
#line 95 "../src/Widgets/JobRow.vala"
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp43_);
#line 97 "../src/Widgets/JobRow.vala"
	_tmp44_ = (GtkRevealer*) gtk_revealer_new ();
#line 97 "../src/Widgets/JobRow.vala"
	gtk_revealer_set_transition_type (_tmp44_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 97 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp44_);
#line 97 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->action_revealer);
#line 97 "../src/Widgets/JobRow.vala"
	self->priv->action_revealer = _tmp44_;
#line 100 "../src/Widgets/JobRow.vala"
	_tmp45_ = self->priv->action_revealer;
#line 100 "../src/Widgets/JobRow.vala"
	_tmp46_ = action_box;
#line 100 "../src/Widgets/JobRow.vala"
	gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
#line 102 "../src/Widgets/JobRow.vala"
	_tmp47_ = (GtkGrid*) gtk_grid_new ();
#line 102 "../src/Widgets/JobRow.vala"
	gtk_grid_set_column_spacing (_tmp47_, 3);
#line 102 "../src/Widgets/JobRow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp47_, 6);
#line 102 "../src/Widgets/JobRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp47_, 9);
#line 102 "../src/Widgets/JobRow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp47_, 6);
#line 102 "../src/Widgets/JobRow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp47_, 6);
#line 102 "../src/Widgets/JobRow.vala"
	g_object_ref_sink (_tmp47_);
#line 102 "../src/Widgets/JobRow.vala"
	grid = _tmp47_;
#line 110 "../src/Widgets/JobRow.vala"
	_tmp48_ = grid;
#line 110 "../src/Widgets/JobRow.vala"
	_tmp49_ = icon_overlay;
#line 110 "../src/Widgets/JobRow.vala"
	gtk_grid_attach (_tmp48_, (GtkWidget*) _tmp49_, 0, 0, 1, 2);
#line 111 "../src/Widgets/JobRow.vala"
	_tmp50_ = grid;
#line 111 "../src/Widgets/JobRow.vala"
	_tmp51_ = title;
#line 111 "../src/Widgets/JobRow.vala"
	gtk_grid_attach (_tmp50_, (GtkWidget*) _tmp51_, 1, 0, 1, 1);
#line 112 "../src/Widgets/JobRow.vala"
	_tmp52_ = grid;
#line 112 "../src/Widgets/JobRow.vala"
	_tmp53_ = self->priv->state_label;
#line 112 "../src/Widgets/JobRow.vala"
	gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp53_, 1, 1, 1, 1);
#line 113 "../src/Widgets/JobRow.vala"
	_tmp54_ = grid;
#line 113 "../src/Widgets/JobRow.vala"
	_tmp55_ = self->priv->date_label;
#line 113 "../src/Widgets/JobRow.vala"
	gtk_grid_attach (_tmp54_, (GtkWidget*) _tmp55_, 2, 0, 1, 2);
#line 114 "../src/Widgets/JobRow.vala"
	_tmp56_ = grid;
#line 114 "../src/Widgets/JobRow.vala"
	_tmp57_ = self->priv->action_revealer;
#line 114 "../src/Widgets/JobRow.vala"
	gtk_grid_attach (_tmp56_, (GtkWidget*) _tmp57_, 3, 0, 1, 2);
#line 116 "../src/Widgets/JobRow.vala"
	_tmp58_ = grid;
#line 116 "../src/Widgets/JobRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp58_);
#line 117 "../src/Widgets/JobRow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 119 "../src/Widgets/JobRow.vala"
	printers_job_row_update_state (self);
#line 121 "../src/Widgets/JobRow.vala"
	_tmp59_ = self->priv->_job;
#line 121 "../src/Widgets/JobRow.vala"
	g_signal_connect_object (_tmp59_, "state-changed", (GCallback) _printers_job_row_update_state_printers_job_state_changed, self, 0);
#line 123 "../src/Widgets/JobRow.vala"
	_tmp60_ = self->priv->start_pause_button;
#line 123 "../src/Widgets/JobRow.vala"
	g_signal_connect_object (_tmp60_, "clicked", (GCallback) __printers_job_row___lambda6__gtk_button_clicked, self, 0);
#line 144 "../src/Widgets/JobRow.vala"
	_tmp61_ = _data16_->cancel_button;
#line 144 "../src/Widgets/JobRow.vala"
	g_signal_connect_data (_tmp61_, "clicked", (GCallback) __printers_job_row___lambda7__gtk_button_clicked, block16_data_ref (_data16_), (GClosureNotify) block16_data_unref, 0);
#line 45 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (grid);
#line 45 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (action_box);
#line 45 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (title);
#line 45 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (icon_overlay);
#line 45 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (icon);
#line 45 "../src/Widgets/JobRow.vala"
	block16_data_unref (_data16_);
#line 45 "../src/Widgets/JobRow.vala"
	_data16_ = NULL;
#line 45 "../src/Widgets/JobRow.vala"
	return obj;
#line 1075 "JobRow.c"
}

static void
printers_job_row_class_init (PrintersJobRowClass * klass,
                             gpointer klass_data)
{
	GtkSizeGroup* _tmp0_;
#line 22 "../src/Widgets/JobRow.vala"
	printers_job_row_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/JobRow.vala"
	g_type_class_adjust_private_offset (klass, &PrintersJobRow_private_offset);
#line 22 "../src/Widgets/JobRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_printers_job_row_get_property;
#line 22 "../src/Widgets/JobRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_printers_job_row_set_property;
#line 22 "../src/Widgets/JobRow.vala"
	G_OBJECT_CLASS (klass)->constructor = printers_job_row_constructor;
#line 22 "../src/Widgets/JobRow.vala"
	G_OBJECT_CLASS (klass)->finalize = printers_job_row_finalize;
#line 22 "../src/Widgets/JobRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_ROW_JOB_PROPERTY, printers_job_row_properties[PRINTERS_JOB_ROW_JOB_PROPERTY] = g_param_spec_object ("job", "job", "job", PRINTERS_TYPE_JOB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "../src/Widgets/JobRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_JOB_ROW_PRINTER_PROPERTY, printers_job_row_properties[PRINTERS_JOB_ROW_PRINTER_PROPERTY] = g_param_spec_object ("printer", "printer", "printer", PRINTERS_TYPE_PRINTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 42 "../src/Widgets/JobRow.vala"
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
#line 42 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (printers_job_row_size_group);
#line 42 "../src/Widgets/JobRow.vala"
	printers_job_row_size_group = _tmp0_;
#line 1105 "JobRow.c"
}

static void
printers_job_row_instance_init (PrintersJobRow * self,
                                gpointer klass)
{
#line 22 "../src/Widgets/JobRow.vala"
	self->priv = printers_job_row_get_instance_private (self);
#line 1114 "JobRow.c"
}

static void
printers_job_row_finalize (GObject * obj)
{
	PrintersJobRow * self;
#line 22 "../src/Widgets/JobRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_JOB_ROW, PrintersJobRow);
#line 23 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->_job);
#line 24 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->_printer);
#line 26 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->start_pause_button);
#line 27 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->job_state_icon);
#line 28 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->action_revealer);
#line 29 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->date_label);
#line 30 "../src/Widgets/JobRow.vala"
	_g_object_unref0 (self->priv->state_label);
#line 22 "../src/Widgets/JobRow.vala"
	G_OBJECT_CLASS (printers_job_row_parent_class)->finalize (obj);
#line 1139 "JobRow.c"
}

static GType
printers_job_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersJobRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_job_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersJobRow), 0, (GInstanceInitFunc) printers_job_row_instance_init, NULL };
	GType printers_job_row_type_id;
	printers_job_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "PrintersJobRow", &g_define_type_info, 0);
	PrintersJobRow_private_offset = g_type_add_instance_private (printers_job_row_type_id, sizeof (PrintersJobRowPrivate));
	return printers_job_row_type_id;
}

GType
printers_job_row_get_type (void)
{
	static volatile gsize printers_job_row_type_id__once = 0;
	if (g_once_init_enter (&printers_job_row_type_id__once)) {
		GType printers_job_row_type_id;
		printers_job_row_type_id = printers_job_row_get_type_once ();
		g_once_init_leave (&printers_job_row_type_id__once, printers_job_row_type_id);
	}
	return printers_job_row_type_id__once;
}

static void
_vala_printers_job_row_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	PrintersJobRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_JOB_ROW, PrintersJobRow);
#line 22 "../src/Widgets/JobRow.vala"
	switch (property_id) {
#line 22 "../src/Widgets/JobRow.vala"
		case PRINTERS_JOB_ROW_JOB_PROPERTY:
#line 22 "../src/Widgets/JobRow.vala"
		g_value_set_object (value, printers_job_row_get_job (self));
#line 22 "../src/Widgets/JobRow.vala"
		break;
#line 22 "../src/Widgets/JobRow.vala"
		case PRINTERS_JOB_ROW_PRINTER_PROPERTY:
#line 22 "../src/Widgets/JobRow.vala"
		g_value_set_object (value, printers_job_row_get_printer (self));
#line 22 "../src/Widgets/JobRow.vala"
		break;
#line 1186 "JobRow.c"
		default:
#line 22 "../src/Widgets/JobRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/JobRow.vala"
		break;
#line 1192 "JobRow.c"
	}
}

static void
_vala_printers_job_row_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	PrintersJobRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_JOB_ROW, PrintersJobRow);
#line 22 "../src/Widgets/JobRow.vala"
	switch (property_id) {
#line 22 "../src/Widgets/JobRow.vala"
		case PRINTERS_JOB_ROW_JOB_PROPERTY:
#line 22 "../src/Widgets/JobRow.vala"
		printers_job_row_set_job (self, g_value_get_object (value));
#line 22 "../src/Widgets/JobRow.vala"
		break;
#line 22 "../src/Widgets/JobRow.vala"
		case PRINTERS_JOB_ROW_PRINTER_PROPERTY:
#line 22 "../src/Widgets/JobRow.vala"
		printers_job_row_set_printer (self, g_value_get_object (value));
#line 22 "../src/Widgets/JobRow.vala"
		break;
#line 1218 "JobRow.c"
		default:
#line 22 "../src/Widgets/JobRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/JobRow.vala"
		break;
#line 1224 "JobRow.c"
	}
}

