/* Printer.c generated by valac 0.56.13, the Vala compiler
 * generated from Printer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2015 - 2022 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include "cups/cups.h"
#include <gee.h>
#include "cups/ipp.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

enum  {
	PRINTERS_PRINTER_0_PROPERTY,
	PRINTERS_PRINTER_IS_ENABLED_PROPERTY,
	PRINTERS_PRINTER_IS_DEFAULT_PROPERTY,
	PRINTERS_PRINTER_AUTH_INFO_REQUIRED_PROPERTY,
	PRINTERS_PRINTER_INFO_PROPERTY,
	PRINTERS_PRINTER_IS_ACCEPTING_JOBS_PROPERTY,
	PRINTERS_PRINTER_STATE_PROPERTY,
	PRINTERS_PRINTER_IS_SHARED_PROPERTY,
	PRINTERS_PRINTER_LOCATION_PROPERTY,
	PRINTERS_PRINTER_MAKE_AND_MODEL_PROPERTY,
	PRINTERS_PRINTER_STATE_REASONS_RAW_PROPERTY,
	PRINTERS_PRINTER_STATE_REASONS_PROPERTY,
	PRINTERS_PRINTER_PRINTER_TYPE_PROPERTY,
	PRINTERS_PRINTER_IS_OFFLINE_PROPERTY,
	PRINTERS_PRINTER_NUM_PROPERTIES
};
static GParamSpec* printers_printer_properties[PRINTERS_PRINTER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _ippDelete0(var) ((var == NULL) ? NULL : (var = (ippDelete (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _printers_printer_color_level_unref0(var) ((var == NULL) ? NULL : (var = (printers_printer_color_level_unref (var), NULL)))
typedef struct _PrintersPrinterParamSpecColorLevel PrintersPrinterParamSpecColorLevel;
enum  {
	PRINTERS_PRINTER_ENABLED_CHANGED_SIGNAL,
	PRINTERS_PRINTER_DEFAULT_CHANGED_SIGNAL,
	PRINTERS_PRINTER_DELETED_SIGNAL,
	PRINTERS_PRINTER_NUM_SIGNALS
};
static guint printers_printer_signals[PRINTERS_PRINTER_NUM_SIGNALS] = {0};

struct _PrintersPrinterPrivate {
	gboolean _is_accepting_jobs;
	gchar* _state;
	gchar* _state_reasons_raw;
};

struct _PrintersPrinterParamSpecColorLevel {
	GParamSpec parent_instance;
};

static gint PrintersPrinter_private_offset;
static gpointer printers_printer_parent_class = NULL;
static gchar** printers_printer_reasons;
static gint printers_printer_reasons_length1;
static gchar** printers_printer_reasons = NULL;
static gint printers_printer_reasons_length1 = 0;
static gint _printers_printer_reasons_size_ = 0;
static gchar** printers_printer_statuses;
static gint printers_printer_statuses_length1;
static gchar** printers_printer_statuses = NULL;
static gint printers_printer_statuses_length1 = 0;
static gint _printers_printer_statuses_size_ = 0;
static gpointer printers_printer_color_level_parent_class = NULL;

static ipp_t* printers_printer_request_attributes (PrintersPrinter* self,
                                            gchar** attributes,
                                            gint attributes_length1,
                                            GError** error);
static gint __lambda5_ (PrintersPrinter* self,
                 PrintersPrinterColorLevel* a,
                 PrintersPrinterColorLevel* b);
static gint ___lambda5__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static void printers_printer_color_level_finalize (PrintersPrinterColorLevel * obj);
static GType printers_printer_color_level_get_type_once (void);
static void printers_printer_finalize (GObject * obj);
static GType printers_printer_get_type_once (void);
static void _vala_printers_printer_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_printers_printer_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
printers_printer_get_instance_private (PrintersPrinter* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersPrinter_private_offset);
}

/***********
     * Methods *
     ***********/
static gboolean
bool_parse (const gchar* str)
{
	gboolean result;
#line 44 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "glib-2.0.vapi"
	if (g_strcmp0 (str, "true") == 0) {
#line 46 "glib-2.0.vapi"
		result = TRUE;
#line 46 "glib-2.0.vapi"
		return result;
#line 149 "Printer.c"
	} else {
#line 48 "glib-2.0.vapi"
		result = FALSE;
#line 48 "glib-2.0.vapi"
		return result;
#line 155 "Printer.c"
	}
}

PrintersPrinter*
printers_printer_construct (GType object_type,
                            cups_dest_t* dest)
{
	PrintersPrinter * self = NULL;
	gchar* is_accepting_opt = NULL;
	cups_option_t* _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	cups_option_t* _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	cups_option_t* _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
#line 251 "../src/Objects/Printer.vala"
	self = (PrintersPrinter*) g_object_new (object_type, NULL);
#line 252 "../src/Objects/Printer.vala"
	self->dest = *dest;
#line 256 "../src/Objects/Printer.vala"
	_tmp0_ = (*dest).options;
#line 256 "../src/Objects/Printer.vala"
	_tmp0__length1 = (*dest).num_options;
#line 256 "../src/Objects/Printer.vala"
	_tmp1_ = cupsGetOption ("is-accepting-jobs", (gint) _tmp0__length1, _tmp0_);
#line 256 "../src/Objects/Printer.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 256 "../src/Objects/Printer.vala"
	is_accepting_opt = _tmp2_;
#line 257 "../src/Objects/Printer.vala"
	_tmp4_ = is_accepting_opt;
#line 257 "../src/Objects/Printer.vala"
	if (_tmp4_ != NULL) {
#line 195 "Printer.c"
		const gchar* _tmp5_;
#line 257 "../src/Objects/Printer.vala"
		_tmp5_ = is_accepting_opt;
#line 257 "../src/Objects/Printer.vala"
		_tmp3_ = bool_parse (_tmp5_);
#line 201 "Printer.c"
	} else {
#line 257 "../src/Objects/Printer.vala"
		_tmp3_ = FALSE;
#line 205 "Printer.c"
	}
#line 257 "../src/Objects/Printer.vala"
	printers_printer_set_is_accepting_jobs (self, _tmp3_);
#line 258 "../src/Objects/Printer.vala"
	_tmp6_ = (*dest).options;
#line 258 "../src/Objects/Printer.vala"
	_tmp6__length1 = (*dest).num_options;
#line 258 "../src/Objects/Printer.vala"
	_tmp7_ = cupsGetOption ("printer-state", (gint) _tmp6__length1, _tmp6_);
#line 258 "../src/Objects/Printer.vala"
	printers_printer_set_state (self, _tmp7_);
#line 259 "../src/Objects/Printer.vala"
	_tmp8_ = (*dest).options;
#line 259 "../src/Objects/Printer.vala"
	_tmp8__length1 = (*dest).num_options;
#line 259 "../src/Objects/Printer.vala"
	_tmp9_ = cupsGetOption ("printer-state-reasons", (gint) _tmp8__length1, _tmp8_);
#line 259 "../src/Objects/Printer.vala"
	printers_printer_set_state_reasons_raw (self, _tmp9_);
#line 251 "../src/Objects/Printer.vala"
	_g_free0 (is_accepting_opt);
#line 251 "../src/Objects/Printer.vala"
	return self;
#line 229 "Printer.c"
}

PrintersPrinter*
printers_printer_new (cups_dest_t* dest)
{
#line 251 "../src/Objects/Printer.vala"
	return printers_printer_construct (PRINTERS_TYPE_PRINTER, dest);
#line 237 "Printer.c"
}

static cups_job_t*
cups_get_jobs (const gchar* name,
               gboolean my_jobs,
               int whichjobs,
               gint* result_length1)
{
	cups_job_t* temp = NULL;
	gint temp_length1 = 0;
	gint _temp_size_ = 0;
	gint _tmp0_ = 0;
	gint len = 0;
	cups_job_t* _tmp1_ = NULL;
	gint _tmp2_;
	cups_job_t* _tmp3_;
	gint _tmp3__length1;
	cups_job_t* result;
#line 147 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	g_return_val_if_fail (name != NULL, NULL);
#line 149 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	if (my_jobs) {
#line 149 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
		_tmp0_ = 1;
#line 262 "Printer.c"
	} else {
#line 149 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
		_tmp0_ = 0;
#line 266 "Printer.c"
	}
#line 149 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_tmp2_ = cupsGetJobs (&_tmp1_, name, _tmp0_, whichjobs);
#line 149 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	temp = _tmp1_;
#line 149 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	temp_length1 = -1;
#line 149 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_temp_size_ = temp_length1;
#line 149 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	len = _tmp2_;
#line 150 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	temp_length1 = len;
#line 151 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_tmp3_ = temp;
#line 151 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_tmp3__length1 = temp_length1;
#line 151 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	if (result_length1) {
#line 151 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
		*result_length1 = _tmp3__length1;
#line 288 "Printer.c"
	}
#line 151 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	result = _tmp3_;
#line 151 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	return result;
#line 294 "Printer.c"
}

static cups_job_t*
cups_destination_get_jobs (cups_dest_t *self,
                           gboolean my_jobs,
                           int whichjobs,
                           gint* result_length1)
{
	const gchar* _tmp0_;
	gint _tmp1_ = 0;
	cups_job_t* _tmp2_;
	cups_job_t* _tmp3_;
	gint _tmp3__length1;
	cups_job_t* result;
#line 130 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_tmp0_ = (*self).name;
#line 130 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_tmp2_ = cups_get_jobs (_tmp0_, my_jobs, whichjobs, &_tmp1_);
#line 130 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_tmp3_ = _tmp2_;
#line 130 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_tmp3__length1 = _tmp1_;
#line 130 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	if (result_length1) {
#line 130 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
		*result_length1 = _tmp3__length1;
#line 321 "Printer.c"
	}
#line 130 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	result = _tmp3_;
#line 130 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	return result;
#line 327 "Printer.c"
}

GeeTreeSet*
printers_printer_get_jobs (PrintersPrinter* self,
                           gboolean my_jobs,
                           int whichjobs)
{
	GeeTreeSet* jobs = NULL;
	GeeTreeSet* _tmp0_;
	cups_job_t* cjobs = NULL;
	gint _tmp1_ = 0;
	cups_job_t* _tmp2_;
	gint cjobs_length1;
	gint _cjobs_size_;
	cups_job_t* _tmp3_;
	gint _tmp3__length1;
	GeeTreeSet* result;
#line 268 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "../src/Objects/Printer.vala"
	_tmp0_ = gee_tree_set_new (PRINTERS_TYPE_JOB, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 269 "../src/Objects/Printer.vala"
	jobs = _tmp0_;
#line 270 "../src/Objects/Printer.vala"
	_tmp2_ = cups_destination_get_jobs (&self->dest, my_jobs, whichjobs, &_tmp1_);
#line 270 "../src/Objects/Printer.vala"
	cjobs = _tmp2_;
#line 270 "../src/Objects/Printer.vala"
	cjobs_length1 = _tmp1_;
#line 270 "../src/Objects/Printer.vala"
	_cjobs_size_ = cjobs_length1;
#line 271 "../src/Objects/Printer.vala"
	_tmp3_ = cjobs;
#line 271 "../src/Objects/Printer.vala"
	_tmp3__length1 = cjobs_length1;
#line 363 "Printer.c"
	{
		cups_job_t* cjob_collection = NULL;
		gint cjob_collection_length1 = 0;
		gint _cjob_collection_size_ = 0;
		gint cjob_it = 0;
#line 271 "../src/Objects/Printer.vala"
		cjob_collection = _tmp3_;
#line 271 "../src/Objects/Printer.vala"
		cjob_collection_length1 = _tmp3__length1;
#line 271 "../src/Objects/Printer.vala"
		for (cjob_it = 0; cjob_it < cjob_collection_length1; cjob_it = cjob_it + 1) {
#line 375 "Printer.c"
			cups_job_t cjob = {0};
#line 271 "../src/Objects/Printer.vala"
			cjob = cjob_collection[cjob_it];
#line 379 "Printer.c"
			{
				PrintersJob* job = NULL;
				cups_job_t _tmp4_;
				PrintersJob* _tmp5_;
				GeeTreeSet* _tmp6_;
				PrintersJob* _tmp7_;
#line 272 "../src/Objects/Printer.vala"
				_tmp4_ = cjob;
#line 272 "../src/Objects/Printer.vala"
				_tmp5_ = printers_job_new (&_tmp4_, self);
#line 272 "../src/Objects/Printer.vala"
				job = _tmp5_;
#line 273 "../src/Objects/Printer.vala"
				_tmp6_ = jobs;
#line 273 "../src/Objects/Printer.vala"
				_tmp7_ = job;
#line 273 "../src/Objects/Printer.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 271 "../src/Objects/Printer.vala"
				_g_object_unref0 (job);
#line 400 "Printer.c"
			}
		}
	}
#line 276 "../src/Objects/Printer.vala"
	result = jobs;
#line 276 "../src/Objects/Printer.vala"
	return result;
#line 408 "Printer.c"
}

gint
printers_printer_get_pages_per_sheet (PrintersPrinter* self,
                                      GeeTreeSet* pages_per_sheet)
{
	gchar** attributes = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint attributes_length1;
	gint _attributes_size_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 279 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 279 "../src/Objects/Printer.vala"
	g_return_val_if_fail (pages_per_sheet != NULL, 0);
#line 280 "../src/Objects/Printer.vala"
	_tmp0_ = g_strdup (CUPS_NUMBER_UP_SUPPORTED);
#line 280 "../src/Objects/Printer.vala"
	_tmp1_ = g_strdup ("number-up-default");
#line 280 "../src/Objects/Printer.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 280 "../src/Objects/Printer.vala"
	_tmp2_[0] = _tmp0_;
#line 280 "../src/Objects/Printer.vala"
	_tmp2_[1] = _tmp1_;
#line 280 "../src/Objects/Printer.vala"
	attributes = _tmp2_;
#line 280 "../src/Objects/Printer.vala"
	attributes_length1 = 2;
#line 280 "../src/Objects/Printer.vala"
	_attributes_size_ = attributes_length1;
#line 443 "Printer.c"
	{
		ipp_t* request = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		ipp_t* _tmp4_;
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp5_;
		ipp_attribute_t* _tmp6_;
		ipp_t* _tmp11_;
		ipp_attribute_t* _tmp12_;
		ipp_attribute_t* _tmp13_;
#line 283 "../src/Objects/Printer.vala"
		_tmp3_ = attributes;
#line 283 "../src/Objects/Printer.vala"
		_tmp3__length1 = attributes_length1;
#line 283 "../src/Objects/Printer.vala"
		_tmp4_ = printers_printer_request_attributes (self, _tmp3_, (gint) _tmp3__length1, &_inner_error0_);
#line 283 "../src/Objects/Printer.vala"
		request = _tmp4_;
#line 283 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 465 "Printer.c"
			goto __catch0_g_error;
		}
#line 284 "../src/Objects/Printer.vala"
		_tmp5_ = request;
#line 284 "../src/Objects/Printer.vala"
		_tmp6_ = ippFindAttribute (_tmp5_, CUPS_NUMBER_UP_SUPPORTED, IPP_TAG_ZERO);
#line 284 "../src/Objects/Printer.vala"
		attr = _tmp6_;
#line 474 "Printer.c"
		{
			gint i = 0;
#line 285 "../src/Objects/Printer.vala"
			i = 0;
#line 479 "Printer.c"
			{
				gboolean _tmp7_ = FALSE;
#line 285 "../src/Objects/Printer.vala"
				_tmp7_ = TRUE;
#line 285 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 486 "Printer.c"
					ipp_attribute_t* _tmp9_;
					ipp_attribute_t* _tmp10_;
#line 285 "../src/Objects/Printer.vala"
					if (!_tmp7_) {
#line 491 "Printer.c"
						gint _tmp8_;
#line 285 "../src/Objects/Printer.vala"
						_tmp8_ = i;
#line 285 "../src/Objects/Printer.vala"
						i = _tmp8_ + 1;
#line 497 "Printer.c"
					}
#line 285 "../src/Objects/Printer.vala"
					_tmp7_ = FALSE;
#line 285 "../src/Objects/Printer.vala"
					_tmp9_ = attr;
#line 285 "../src/Objects/Printer.vala"
					if (!(i < ippGetCount (_tmp9_))) {
#line 285 "../src/Objects/Printer.vala"
						break;
#line 507 "Printer.c"
					}
#line 286 "../src/Objects/Printer.vala"
					_tmp10_ = attr;
#line 286 "../src/Objects/Printer.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) pages_per_sheet, (gpointer) ((gintptr) ippGetInteger (_tmp10_, i)));
#line 513 "Printer.c"
				}
			}
		}
#line 289 "../src/Objects/Printer.vala"
		_tmp11_ = request;
#line 289 "../src/Objects/Printer.vala"
		_tmp12_ = ippFindAttribute (_tmp11_, "number-up-default", IPP_TAG_ZERO);
#line 289 "../src/Objects/Printer.vala"
		attr = _tmp12_;
#line 290 "../src/Objects/Printer.vala"
		_tmp13_ = attr;
#line 290 "../src/Objects/Printer.vala"
		if (ippGetCount (_tmp13_) > 0) {
#line 527 "Printer.c"
			ipp_attribute_t* _tmp14_;
#line 291 "../src/Objects/Printer.vala"
			_tmp14_ = attr;
#line 291 "../src/Objects/Printer.vala"
			result = ippGetInteger (_tmp14_, 0);
#line 291 "../src/Objects/Printer.vala"
			_ippDelete0 (request);
#line 291 "../src/Objects/Printer.vala"
			attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 291 "../src/Objects/Printer.vala"
			return result;
#line 539 "Printer.c"
		}
#line 282 "../src/Objects/Printer.vala"
		_ippDelete0 (request);
#line 543 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 282 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 282 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 294 "../src/Objects/Printer.vala"
		_tmp15_ = e;
#line 294 "../src/Objects/Printer.vala"
		_tmp16_ = _tmp15_->message;
#line 294 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:294: Error: %s", _tmp16_);
#line 282 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 563 "Printer.c"
	}
	__finally0:
#line 282 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 568 "Printer.c"
		gint _tmp17_ = -1;
#line 282 "../src/Objects/Printer.vala"
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 282 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 282 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 282 "../src/Objects/Printer.vala"
		return _tmp17_;
#line 578 "Printer.c"
	}
#line 297 "../src/Objects/Printer.vala"
	result = 1;
#line 297 "../src/Objects/Printer.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 297 "../src/Objects/Printer.vala"
	return result;
#line 586 "Printer.c"
}

void
printers_printer_set_default_pages (PrintersPrinter* self,
                                    const gchar* new_default)
{
	CupsPkHelper* pk_helper = NULL;
	CupsPkHelper* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 300 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/Objects/Printer.vala"
	g_return_if_fail (new_default != NULL);
#line 301 "../src/Objects/Printer.vala"
	_tmp0_ = cups_get_pk_helper ();
#line 301 "../src/Objects/Printer.vala"
	pk_helper = _tmp0_;
#line 604 "Printer.c"
	{
		CupsPkHelper* _tmp1_;
		cups_dest_t _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		CupsPkHelper* _tmp6_;
		cups_dest_t _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 303 "../src/Objects/Printer.vala"
		_tmp1_ = pk_helper;
#line 303 "../src/Objects/Printer.vala"
		_tmp2_ = self->dest;
#line 303 "../src/Objects/Printer.vala"
		_tmp3_ = _tmp2_.name;
#line 303 "../src/Objects/Printer.vala"
		_tmp4_ = cups_pk_helper_printer_delete_option_default (_tmp1_, _tmp3_, "number-up", &_inner_error0_);
#line 303 "../src/Objects/Printer.vala"
		_tmp5_ = _tmp4_;
#line 303 "../src/Objects/Printer.vala"
		_g_free0 (_tmp5_);
#line 303 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 634 "Printer.c"
			goto __catch0_g_error;
		}
#line 304 "../src/Objects/Printer.vala"
		_tmp6_ = pk_helper;
#line 304 "../src/Objects/Printer.vala"
		_tmp7_ = self->dest;
#line 304 "../src/Objects/Printer.vala"
		_tmp8_ = _tmp7_.name;
#line 304 "../src/Objects/Printer.vala"
		_tmp9_ = g_strdup (new_default);
#line 304 "../src/Objects/Printer.vala"
		_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 304 "../src/Objects/Printer.vala"
		_tmp10_[0] = _tmp9_;
#line 304 "../src/Objects/Printer.vala"
		_tmp11_ = _tmp10_;
#line 304 "../src/Objects/Printer.vala"
		_tmp11__length1 = 1;
#line 304 "../src/Objects/Printer.vala"
		_tmp12_ = cups_pk_helper_printer_add_option_default (_tmp6_, _tmp8_, "number-up", _tmp11_, (gint) 1, &_inner_error0_);
#line 304 "../src/Objects/Printer.vala"
		_tmp13_ = _tmp12_;
#line 304 "../src/Objects/Printer.vala"
		_g_free0 (_tmp13_);
#line 304 "../src/Objects/Printer.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 304 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 663 "Printer.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 302 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 302 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 306 "../src/Objects/Printer.vala"
		_tmp14_ = e;
#line 306 "../src/Objects/Printer.vala"
		_tmp15_ = _tmp14_->message;
#line 306 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:306: %s", _tmp15_);
#line 302 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 685 "Printer.c"
	}
	__finally0:
#line 302 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 302 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 302 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 302 "../src/Objects/Printer.vala"
		return;
#line 696 "Printer.c"
	}
}

gchar*
printers_printer_get_sides (PrintersPrinter* self,
                            GeeTreeSet* sides)
{
	gchar** attributes = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint attributes_length1;
	gint _attributes_size_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 310 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 310 "../src/Objects/Printer.vala"
	g_return_val_if_fail (sides != NULL, NULL);
#line 311 "../src/Objects/Printer.vala"
	_tmp0_ = g_strdup (CUPS_SIDES_SUPPORTED);
#line 311 "../src/Objects/Printer.vala"
	_tmp1_ = g_strdup ("sides-default");
#line 311 "../src/Objects/Printer.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 311 "../src/Objects/Printer.vala"
	_tmp2_[0] = _tmp0_;
#line 311 "../src/Objects/Printer.vala"
	_tmp2_[1] = _tmp1_;
#line 311 "../src/Objects/Printer.vala"
	attributes = _tmp2_;
#line 311 "../src/Objects/Printer.vala"
	attributes_length1 = 2;
#line 311 "../src/Objects/Printer.vala"
	_attributes_size_ = attributes_length1;
#line 733 "Printer.c"
	{
		ipp_t* request = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		ipp_t* _tmp4_;
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp5_;
		ipp_attribute_t* _tmp6_;
		ipp_t* _tmp12_;
		ipp_attribute_t* _tmp13_;
		ipp_attribute_t* _tmp14_;
#line 314 "../src/Objects/Printer.vala"
		_tmp3_ = attributes;
#line 314 "../src/Objects/Printer.vala"
		_tmp3__length1 = attributes_length1;
#line 314 "../src/Objects/Printer.vala"
		_tmp4_ = printers_printer_request_attributes (self, _tmp3_, (gint) _tmp3__length1, &_inner_error0_);
#line 314 "../src/Objects/Printer.vala"
		request = _tmp4_;
#line 314 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 755 "Printer.c"
			goto __catch0_g_error;
		}
#line 315 "../src/Objects/Printer.vala"
		_tmp5_ = request;
#line 315 "../src/Objects/Printer.vala"
		_tmp6_ = ippFindAttribute (_tmp5_, CUPS_SIDES_SUPPORTED, IPP_TAG_ZERO);
#line 315 "../src/Objects/Printer.vala"
		attr = _tmp6_;
#line 764 "Printer.c"
		{
			gint i = 0;
#line 316 "../src/Objects/Printer.vala"
			i = 0;
#line 769 "Printer.c"
			{
				gboolean _tmp7_ = FALSE;
#line 316 "../src/Objects/Printer.vala"
				_tmp7_ = TRUE;
#line 316 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 776 "Printer.c"
					ipp_attribute_t* _tmp9_;
					ipp_attribute_t* _tmp10_;
					const gchar* _tmp11_;
#line 316 "../src/Objects/Printer.vala"
					if (!_tmp7_) {
#line 782 "Printer.c"
						gint _tmp8_;
#line 316 "../src/Objects/Printer.vala"
						_tmp8_ = i;
#line 316 "../src/Objects/Printer.vala"
						i = _tmp8_ + 1;
#line 788 "Printer.c"
					}
#line 316 "../src/Objects/Printer.vala"
					_tmp7_ = FALSE;
#line 316 "../src/Objects/Printer.vala"
					_tmp9_ = attr;
#line 316 "../src/Objects/Printer.vala"
					if (!(i < ippGetCount (_tmp9_))) {
#line 316 "../src/Objects/Printer.vala"
						break;
#line 798 "Printer.c"
					}
#line 317 "../src/Objects/Printer.vala"
					_tmp10_ = attr;
#line 317 "../src/Objects/Printer.vala"
					_tmp11_ = ippGetString (_tmp10_, i, NULL);
#line 317 "../src/Objects/Printer.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) sides, _tmp11_);
#line 806 "Printer.c"
				}
			}
		}
#line 320 "../src/Objects/Printer.vala"
		_tmp12_ = request;
#line 320 "../src/Objects/Printer.vala"
		_tmp13_ = ippFindAttribute (_tmp12_, "sides-default", IPP_TAG_ZERO);
#line 320 "../src/Objects/Printer.vala"
		attr = _tmp13_;
#line 321 "../src/Objects/Printer.vala"
		_tmp14_ = attr;
#line 321 "../src/Objects/Printer.vala"
		if (ippGetCount (_tmp14_) > 0) {
#line 820 "Printer.c"
			ipp_attribute_t* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 322 "../src/Objects/Printer.vala"
			_tmp15_ = attr;
#line 322 "../src/Objects/Printer.vala"
			_tmp16_ = ippGetString (_tmp15_, 0, NULL);
#line 322 "../src/Objects/Printer.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 322 "../src/Objects/Printer.vala"
			result = _tmp17_;
#line 322 "../src/Objects/Printer.vala"
			_ippDelete0 (request);
#line 322 "../src/Objects/Printer.vala"
			attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 322 "../src/Objects/Printer.vala"
			return result;
#line 838 "Printer.c"
		}
#line 313 "../src/Objects/Printer.vala"
		_ippDelete0 (request);
#line 842 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 313 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 313 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 325 "../src/Objects/Printer.vala"
		_tmp18_ = e;
#line 325 "../src/Objects/Printer.vala"
		_tmp19_ = _tmp18_->message;
#line 325 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:325: Error: %s", _tmp19_);
#line 313 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 862 "Printer.c"
	}
	__finally0:
#line 313 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "../src/Objects/Printer.vala"
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 313 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 313 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 313 "../src/Objects/Printer.vala"
		return NULL;
#line 875 "Printer.c"
	}
#line 328 "../src/Objects/Printer.vala"
	_tmp20_ = g_strdup (CUPS_SIDES_ONE_SIDED);
#line 328 "../src/Objects/Printer.vala"
	result = _tmp20_;
#line 328 "../src/Objects/Printer.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 328 "../src/Objects/Printer.vala"
	return result;
#line 885 "Printer.c"
}

void
printers_printer_set_default_side (PrintersPrinter* self,
                                   const gchar* new_default)
{
	CupsPkHelper* pk_helper = NULL;
	CupsPkHelper* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 331 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 331 "../src/Objects/Printer.vala"
	g_return_if_fail (new_default != NULL);
#line 332 "../src/Objects/Printer.vala"
	_tmp0_ = cups_get_pk_helper ();
#line 332 "../src/Objects/Printer.vala"
	pk_helper = _tmp0_;
#line 903 "Printer.c"
	{
		CupsPkHelper* _tmp1_;
		cups_dest_t _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		CupsPkHelper* _tmp6_;
		cups_dest_t _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 334 "../src/Objects/Printer.vala"
		_tmp1_ = pk_helper;
#line 334 "../src/Objects/Printer.vala"
		_tmp2_ = self->dest;
#line 334 "../src/Objects/Printer.vala"
		_tmp3_ = _tmp2_.name;
#line 334 "../src/Objects/Printer.vala"
		_tmp4_ = cups_pk_helper_printer_delete_option_default (_tmp1_, _tmp3_, "sides", &_inner_error0_);
#line 334 "../src/Objects/Printer.vala"
		_tmp5_ = _tmp4_;
#line 334 "../src/Objects/Printer.vala"
		_g_free0 (_tmp5_);
#line 334 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 933 "Printer.c"
			goto __catch0_g_error;
		}
#line 335 "../src/Objects/Printer.vala"
		_tmp6_ = pk_helper;
#line 335 "../src/Objects/Printer.vala"
		_tmp7_ = self->dest;
#line 335 "../src/Objects/Printer.vala"
		_tmp8_ = _tmp7_.name;
#line 335 "../src/Objects/Printer.vala"
		_tmp9_ = g_strdup (new_default);
#line 335 "../src/Objects/Printer.vala"
		_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 335 "../src/Objects/Printer.vala"
		_tmp10_[0] = _tmp9_;
#line 335 "../src/Objects/Printer.vala"
		_tmp11_ = _tmp10_;
#line 335 "../src/Objects/Printer.vala"
		_tmp11__length1 = 1;
#line 335 "../src/Objects/Printer.vala"
		_tmp12_ = cups_pk_helper_printer_add_option_default (_tmp6_, _tmp8_, "sides", _tmp11_, (gint) 1, &_inner_error0_);
#line 335 "../src/Objects/Printer.vala"
		_tmp13_ = _tmp12_;
#line 335 "../src/Objects/Printer.vala"
		_g_free0 (_tmp13_);
#line 335 "../src/Objects/Printer.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 335 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 962 "Printer.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 333 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 333 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 337 "../src/Objects/Printer.vala"
		_tmp14_ = e;
#line 337 "../src/Objects/Printer.vala"
		_tmp15_ = _tmp14_->message;
#line 337 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:337: %s", _tmp15_);
#line 333 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 984 "Printer.c"
	}
	__finally0:
#line 333 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 333 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 333 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 333 "../src/Objects/Printer.vala"
		return;
#line 995 "Printer.c"
	}
}

gint
printers_printer_get_orientations (PrintersPrinter* self,
                                   GeeTreeSet* orientations)
{
	gchar** attributes = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint attributes_length1;
	gint _attributes_size_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 341 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 341 "../src/Objects/Printer.vala"
	g_return_val_if_fail (orientations != NULL, 0);
#line 342 "../src/Objects/Printer.vala"
	_tmp0_ = g_strdup (CUPS_ORIENTATION_SUPPORTED);
#line 342 "../src/Objects/Printer.vala"
	_tmp1_ = g_strdup ("orientation-requested-default");
#line 342 "../src/Objects/Printer.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 342 "../src/Objects/Printer.vala"
	_tmp2_[0] = _tmp0_;
#line 342 "../src/Objects/Printer.vala"
	_tmp2_[1] = _tmp1_;
#line 342 "../src/Objects/Printer.vala"
	attributes = _tmp2_;
#line 342 "../src/Objects/Printer.vala"
	attributes_length1 = 2;
#line 342 "../src/Objects/Printer.vala"
	_attributes_size_ = attributes_length1;
#line 1031 "Printer.c"
	{
		ipp_t* request = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		ipp_t* _tmp4_;
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp5_;
		ipp_attribute_t* _tmp6_;
		ipp_t* _tmp11_;
		ipp_attribute_t* _tmp12_;
		ipp_attribute_t* _tmp13_;
#line 345 "../src/Objects/Printer.vala"
		_tmp3_ = attributes;
#line 345 "../src/Objects/Printer.vala"
		_tmp3__length1 = attributes_length1;
#line 345 "../src/Objects/Printer.vala"
		_tmp4_ = printers_printer_request_attributes (self, _tmp3_, (gint) _tmp3__length1, &_inner_error0_);
#line 345 "../src/Objects/Printer.vala"
		request = _tmp4_;
#line 345 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1053 "Printer.c"
			goto __catch0_g_error;
		}
#line 346 "../src/Objects/Printer.vala"
		_tmp5_ = request;
#line 346 "../src/Objects/Printer.vala"
		_tmp6_ = ippFindAttribute (_tmp5_, CUPS_ORIENTATION_SUPPORTED, IPP_TAG_ZERO);
#line 346 "../src/Objects/Printer.vala"
		attr = _tmp6_;
#line 1062 "Printer.c"
		{
			gint i = 0;
#line 347 "../src/Objects/Printer.vala"
			i = 0;
#line 1067 "Printer.c"
			{
				gboolean _tmp7_ = FALSE;
#line 347 "../src/Objects/Printer.vala"
				_tmp7_ = TRUE;
#line 347 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 1074 "Printer.c"
					ipp_attribute_t* _tmp9_;
					ipp_attribute_t* _tmp10_;
#line 347 "../src/Objects/Printer.vala"
					if (!_tmp7_) {
#line 1079 "Printer.c"
						gint _tmp8_;
#line 347 "../src/Objects/Printer.vala"
						_tmp8_ = i;
#line 347 "../src/Objects/Printer.vala"
						i = _tmp8_ + 1;
#line 1085 "Printer.c"
					}
#line 347 "../src/Objects/Printer.vala"
					_tmp7_ = FALSE;
#line 347 "../src/Objects/Printer.vala"
					_tmp9_ = attr;
#line 347 "../src/Objects/Printer.vala"
					if (!(i < ippGetCount (_tmp9_))) {
#line 347 "../src/Objects/Printer.vala"
						break;
#line 1095 "Printer.c"
					}
#line 348 "../src/Objects/Printer.vala"
					_tmp10_ = attr;
#line 348 "../src/Objects/Printer.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) orientations, (gpointer) ((gintptr) ippGetInteger (_tmp10_, i)));
#line 1101 "Printer.c"
				}
			}
		}
#line 351 "../src/Objects/Printer.vala"
		_tmp11_ = request;
#line 351 "../src/Objects/Printer.vala"
		_tmp12_ = ippFindAttribute (_tmp11_, "orientation-requested-default", IPP_TAG_ZERO);
#line 351 "../src/Objects/Printer.vala"
		attr = _tmp12_;
#line 352 "../src/Objects/Printer.vala"
		_tmp13_ = attr;
#line 352 "../src/Objects/Printer.vala"
		if (ippGetCount (_tmp13_) > 0) {
#line 1115 "Printer.c"
			gint page = 0;
			ipp_attribute_t* _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 353 "../src/Objects/Printer.vala"
			_tmp14_ = attr;
#line 353 "../src/Objects/Printer.vala"
			page = ippGetInteger (_tmp14_, 0);
#line 354 "../src/Objects/Printer.vala"
			if (page >= 3) {
#line 354 "../src/Objects/Printer.vala"
				_tmp15_ = page <= 6;
#line 1127 "Printer.c"
			} else {
#line 354 "../src/Objects/Printer.vala"
				_tmp15_ = FALSE;
#line 1131 "Printer.c"
			}
#line 354 "../src/Objects/Printer.vala"
			if (_tmp15_) {
#line 355 "../src/Objects/Printer.vala"
				result = page;
#line 355 "../src/Objects/Printer.vala"
				_ippDelete0 (request);
#line 355 "../src/Objects/Printer.vala"
				attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 355 "../src/Objects/Printer.vala"
				return result;
#line 1143 "Printer.c"
			}
		}
#line 344 "../src/Objects/Printer.vala"
		_ippDelete0 (request);
#line 1148 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 344 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 344 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 359 "../src/Objects/Printer.vala"
		_tmp16_ = e;
#line 359 "../src/Objects/Printer.vala"
		_tmp17_ = _tmp16_->message;
#line 359 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:359: Error: %s", _tmp17_);
#line 344 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 1168 "Printer.c"
	}
	__finally0:
#line 344 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1173 "Printer.c"
		gint _tmp18_ = -1;
#line 344 "../src/Objects/Printer.vala"
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 344 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 344 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 344 "../src/Objects/Printer.vala"
		return _tmp18_;
#line 1183 "Printer.c"
	}
#line 362 "../src/Objects/Printer.vala"
	result = 3;
#line 362 "../src/Objects/Printer.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 362 "../src/Objects/Printer.vala"
	return result;
#line 1191 "Printer.c"
}

void
printers_printer_set_default_orientation (PrintersPrinter* self,
                                          const gchar* new_default)
{
	CupsPkHelper* pk_helper = NULL;
	CupsPkHelper* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 365 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 365 "../src/Objects/Printer.vala"
	g_return_if_fail (new_default != NULL);
#line 366 "../src/Objects/Printer.vala"
	_tmp0_ = cups_get_pk_helper ();
#line 366 "../src/Objects/Printer.vala"
	pk_helper = _tmp0_;
#line 1209 "Printer.c"
	{
		CupsPkHelper* _tmp1_;
		cups_dest_t _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		CupsPkHelper* _tmp6_;
		cups_dest_t _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 368 "../src/Objects/Printer.vala"
		_tmp1_ = pk_helper;
#line 368 "../src/Objects/Printer.vala"
		_tmp2_ = self->dest;
#line 368 "../src/Objects/Printer.vala"
		_tmp3_ = _tmp2_.name;
#line 368 "../src/Objects/Printer.vala"
		_tmp4_ = cups_pk_helper_printer_delete_option_default (_tmp1_, _tmp3_, "orientation-requested", &_inner_error0_);
#line 368 "../src/Objects/Printer.vala"
		_tmp5_ = _tmp4_;
#line 368 "../src/Objects/Printer.vala"
		_g_free0 (_tmp5_);
#line 368 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1239 "Printer.c"
			goto __catch0_g_error;
		}
#line 369 "../src/Objects/Printer.vala"
		_tmp6_ = pk_helper;
#line 369 "../src/Objects/Printer.vala"
		_tmp7_ = self->dest;
#line 369 "../src/Objects/Printer.vala"
		_tmp8_ = _tmp7_.name;
#line 369 "../src/Objects/Printer.vala"
		_tmp9_ = g_strdup (new_default);
#line 369 "../src/Objects/Printer.vala"
		_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 369 "../src/Objects/Printer.vala"
		_tmp10_[0] = _tmp9_;
#line 369 "../src/Objects/Printer.vala"
		_tmp11_ = _tmp10_;
#line 369 "../src/Objects/Printer.vala"
		_tmp11__length1 = 1;
#line 369 "../src/Objects/Printer.vala"
		_tmp12_ = cups_pk_helper_printer_add_option_default (_tmp6_, _tmp8_, "orientation-requested", _tmp11_, (gint) 1, &_inner_error0_);
#line 369 "../src/Objects/Printer.vala"
		_tmp13_ = _tmp12_;
#line 369 "../src/Objects/Printer.vala"
		_g_free0 (_tmp13_);
#line 369 "../src/Objects/Printer.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 369 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1268 "Printer.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 367 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 367 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 371 "../src/Objects/Printer.vala"
		_tmp14_ = e;
#line 371 "../src/Objects/Printer.vala"
		_tmp15_ = _tmp14_->message;
#line 371 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:371: %s", _tmp15_);
#line 367 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 1290 "Printer.c"
	}
	__finally0:
#line 367 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 367 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 367 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 367 "../src/Objects/Printer.vala"
		return;
#line 1301 "Printer.c"
	}
}

gchar*
printers_printer_get_output_bins (PrintersPrinter* self,
                                  GeeTreeSet* output_bins)
{
	gchar** attributes = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint attributes_length1;
	gint _attributes_size_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 375 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 375 "../src/Objects/Printer.vala"
	g_return_val_if_fail (output_bins != NULL, NULL);
#line 376 "../src/Objects/Printer.vala"
	_tmp0_ = g_strdup ("output-bin-supported");
#line 376 "../src/Objects/Printer.vala"
	_tmp1_ = g_strdup ("output-bin-default");
#line 376 "../src/Objects/Printer.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 376 "../src/Objects/Printer.vala"
	_tmp2_[0] = _tmp0_;
#line 376 "../src/Objects/Printer.vala"
	_tmp2_[1] = _tmp1_;
#line 376 "../src/Objects/Printer.vala"
	attributes = _tmp2_;
#line 376 "../src/Objects/Printer.vala"
	attributes_length1 = 2;
#line 376 "../src/Objects/Printer.vala"
	_attributes_size_ = attributes_length1;
#line 1338 "Printer.c"
	{
		ipp_t* request = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		ipp_t* _tmp4_;
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp5_;
		ipp_attribute_t* _tmp6_;
		ipp_t* _tmp12_;
		ipp_attribute_t* _tmp13_;
		ipp_attribute_t* _tmp14_;
#line 379 "../src/Objects/Printer.vala"
		_tmp3_ = attributes;
#line 379 "../src/Objects/Printer.vala"
		_tmp3__length1 = attributes_length1;
#line 379 "../src/Objects/Printer.vala"
		_tmp4_ = printers_printer_request_attributes (self, _tmp3_, (gint) _tmp3__length1, &_inner_error0_);
#line 379 "../src/Objects/Printer.vala"
		request = _tmp4_;
#line 379 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1360 "Printer.c"
			goto __catch0_g_error;
		}
#line 380 "../src/Objects/Printer.vala"
		_tmp5_ = request;
#line 380 "../src/Objects/Printer.vala"
		_tmp6_ = ippFindAttribute (_tmp5_, "output-bin-supported", IPP_TAG_ZERO);
#line 380 "../src/Objects/Printer.vala"
		attr = _tmp6_;
#line 1369 "Printer.c"
		{
			gint i = 0;
#line 381 "../src/Objects/Printer.vala"
			i = 0;
#line 1374 "Printer.c"
			{
				gboolean _tmp7_ = FALSE;
#line 381 "../src/Objects/Printer.vala"
				_tmp7_ = TRUE;
#line 381 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 1381 "Printer.c"
					ipp_attribute_t* _tmp9_;
					ipp_attribute_t* _tmp10_;
					const gchar* _tmp11_;
#line 381 "../src/Objects/Printer.vala"
					if (!_tmp7_) {
#line 1387 "Printer.c"
						gint _tmp8_;
#line 381 "../src/Objects/Printer.vala"
						_tmp8_ = i;
#line 381 "../src/Objects/Printer.vala"
						i = _tmp8_ + 1;
#line 1393 "Printer.c"
					}
#line 381 "../src/Objects/Printer.vala"
					_tmp7_ = FALSE;
#line 381 "../src/Objects/Printer.vala"
					_tmp9_ = attr;
#line 381 "../src/Objects/Printer.vala"
					if (!(i < ippGetCount (_tmp9_))) {
#line 381 "../src/Objects/Printer.vala"
						break;
#line 1403 "Printer.c"
					}
#line 382 "../src/Objects/Printer.vala"
					_tmp10_ = attr;
#line 382 "../src/Objects/Printer.vala"
					_tmp11_ = ippGetString (_tmp10_, i, NULL);
#line 382 "../src/Objects/Printer.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) output_bins, _tmp11_);
#line 1411 "Printer.c"
				}
			}
		}
#line 385 "../src/Objects/Printer.vala"
		_tmp12_ = request;
#line 385 "../src/Objects/Printer.vala"
		_tmp13_ = ippFindAttribute (_tmp12_, "output-bin-default", IPP_TAG_ZERO);
#line 385 "../src/Objects/Printer.vala"
		attr = _tmp13_;
#line 386 "../src/Objects/Printer.vala"
		_tmp14_ = attr;
#line 386 "../src/Objects/Printer.vala"
		if (ippGetCount (_tmp14_) > 0) {
#line 1425 "Printer.c"
			ipp_attribute_t* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 387 "../src/Objects/Printer.vala"
			_tmp15_ = attr;
#line 387 "../src/Objects/Printer.vala"
			_tmp16_ = ippGetString (_tmp15_, 0, NULL);
#line 387 "../src/Objects/Printer.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 387 "../src/Objects/Printer.vala"
			result = _tmp17_;
#line 387 "../src/Objects/Printer.vala"
			_ippDelete0 (request);
#line 387 "../src/Objects/Printer.vala"
			attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 387 "../src/Objects/Printer.vala"
			return result;
#line 1443 "Printer.c"
		}
#line 378 "../src/Objects/Printer.vala"
		_ippDelete0 (request);
#line 1447 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 378 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 378 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 390 "../src/Objects/Printer.vala"
		_tmp18_ = e;
#line 390 "../src/Objects/Printer.vala"
		_tmp19_ = _tmp18_->message;
#line 390 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:390: Error: %s", _tmp19_);
#line 378 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 1467 "Printer.c"
	}
	__finally0:
#line 378 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 378 "../src/Objects/Printer.vala"
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 378 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 378 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 378 "../src/Objects/Printer.vala"
		return NULL;
#line 1480 "Printer.c"
	}
#line 393 "../src/Objects/Printer.vala"
	_tmp20_ = g_strdup ("rear");
#line 393 "../src/Objects/Printer.vala"
	result = _tmp20_;
#line 393 "../src/Objects/Printer.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 393 "../src/Objects/Printer.vala"
	return result;
#line 1490 "Printer.c"
}

void
printers_printer_set_default_output_bin (PrintersPrinter* self,
                                         const gchar* new_default)
{
	CupsPkHelper* pk_helper = NULL;
	CupsPkHelper* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 396 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 396 "../src/Objects/Printer.vala"
	g_return_if_fail (new_default != NULL);
#line 397 "../src/Objects/Printer.vala"
	_tmp0_ = cups_get_pk_helper ();
#line 397 "../src/Objects/Printer.vala"
	pk_helper = _tmp0_;
#line 1508 "Printer.c"
	{
		CupsPkHelper* _tmp1_;
		cups_dest_t _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		CupsPkHelper* _tmp6_;
		cups_dest_t _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 399 "../src/Objects/Printer.vala"
		_tmp1_ = pk_helper;
#line 399 "../src/Objects/Printer.vala"
		_tmp2_ = self->dest;
#line 399 "../src/Objects/Printer.vala"
		_tmp3_ = _tmp2_.name;
#line 399 "../src/Objects/Printer.vala"
		_tmp4_ = cups_pk_helper_printer_delete_option_default (_tmp1_, _tmp3_, "output-bin", &_inner_error0_);
#line 399 "../src/Objects/Printer.vala"
		_tmp5_ = _tmp4_;
#line 399 "../src/Objects/Printer.vala"
		_g_free0 (_tmp5_);
#line 399 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1538 "Printer.c"
			goto __catch0_g_error;
		}
#line 400 "../src/Objects/Printer.vala"
		_tmp6_ = pk_helper;
#line 400 "../src/Objects/Printer.vala"
		_tmp7_ = self->dest;
#line 400 "../src/Objects/Printer.vala"
		_tmp8_ = _tmp7_.name;
#line 400 "../src/Objects/Printer.vala"
		_tmp9_ = g_strdup (new_default);
#line 400 "../src/Objects/Printer.vala"
		_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 400 "../src/Objects/Printer.vala"
		_tmp10_[0] = _tmp9_;
#line 400 "../src/Objects/Printer.vala"
		_tmp11_ = _tmp10_;
#line 400 "../src/Objects/Printer.vala"
		_tmp11__length1 = 1;
#line 400 "../src/Objects/Printer.vala"
		_tmp12_ = cups_pk_helper_printer_add_option_default (_tmp6_, _tmp8_, "output-bin", _tmp11_, (gint) 1, &_inner_error0_);
#line 400 "../src/Objects/Printer.vala"
		_tmp13_ = _tmp12_;
#line 400 "../src/Objects/Printer.vala"
		_g_free0 (_tmp13_);
#line 400 "../src/Objects/Printer.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 400 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1567 "Printer.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 398 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 398 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 402 "../src/Objects/Printer.vala"
		_tmp14_ = e;
#line 402 "../src/Objects/Printer.vala"
		_tmp15_ = _tmp14_->message;
#line 402 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:402: %s", _tmp15_);
#line 398 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 1589 "Printer.c"
	}
	__finally0:
#line 398 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 398 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 398 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 398 "../src/Objects/Printer.vala"
		return;
#line 1600 "Printer.c"
	}
}

gchar*
printers_printer_get_print_color_modes (PrintersPrinter* self,
                                        GeeTreeSet* print_color_modes)
{
	gchar** attributes = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint attributes_length1;
	gint _attributes_size_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 406 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 406 "../src/Objects/Printer.vala"
	g_return_val_if_fail (print_color_modes != NULL, NULL);
#line 407 "../src/Objects/Printer.vala"
	_tmp0_ = g_strdup ("print-color-mode-supported");
#line 407 "../src/Objects/Printer.vala"
	_tmp1_ = g_strdup ("print-color-mode-default");
#line 407 "../src/Objects/Printer.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 407 "../src/Objects/Printer.vala"
	_tmp2_[0] = _tmp0_;
#line 407 "../src/Objects/Printer.vala"
	_tmp2_[1] = _tmp1_;
#line 407 "../src/Objects/Printer.vala"
	attributes = _tmp2_;
#line 407 "../src/Objects/Printer.vala"
	attributes_length1 = 2;
#line 407 "../src/Objects/Printer.vala"
	_attributes_size_ = attributes_length1;
#line 1637 "Printer.c"
	{
		ipp_t* request = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		ipp_t* _tmp4_;
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp5_;
		ipp_attribute_t* _tmp6_;
		ipp_t* _tmp12_;
		ipp_attribute_t* _tmp13_;
		ipp_attribute_t* _tmp14_;
#line 410 "../src/Objects/Printer.vala"
		_tmp3_ = attributes;
#line 410 "../src/Objects/Printer.vala"
		_tmp3__length1 = attributes_length1;
#line 410 "../src/Objects/Printer.vala"
		_tmp4_ = printers_printer_request_attributes (self, _tmp3_, (gint) _tmp3__length1, &_inner_error0_);
#line 410 "../src/Objects/Printer.vala"
		request = _tmp4_;
#line 410 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1659 "Printer.c"
			goto __catch0_g_error;
		}
#line 411 "../src/Objects/Printer.vala"
		_tmp5_ = request;
#line 411 "../src/Objects/Printer.vala"
		_tmp6_ = ippFindAttribute (_tmp5_, "print-color-mode-supported", IPP_TAG_ZERO);
#line 411 "../src/Objects/Printer.vala"
		attr = _tmp6_;
#line 1668 "Printer.c"
		{
			gint i = 0;
#line 412 "../src/Objects/Printer.vala"
			i = 0;
#line 1673 "Printer.c"
			{
				gboolean _tmp7_ = FALSE;
#line 412 "../src/Objects/Printer.vala"
				_tmp7_ = TRUE;
#line 412 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 1680 "Printer.c"
					ipp_attribute_t* _tmp9_;
					ipp_attribute_t* _tmp10_;
					const gchar* _tmp11_;
#line 412 "../src/Objects/Printer.vala"
					if (!_tmp7_) {
#line 1686 "Printer.c"
						gint _tmp8_;
#line 412 "../src/Objects/Printer.vala"
						_tmp8_ = i;
#line 412 "../src/Objects/Printer.vala"
						i = _tmp8_ + 1;
#line 1692 "Printer.c"
					}
#line 412 "../src/Objects/Printer.vala"
					_tmp7_ = FALSE;
#line 412 "../src/Objects/Printer.vala"
					_tmp9_ = attr;
#line 412 "../src/Objects/Printer.vala"
					if (!(i < ippGetCount (_tmp9_))) {
#line 412 "../src/Objects/Printer.vala"
						break;
#line 1702 "Printer.c"
					}
#line 413 "../src/Objects/Printer.vala"
					_tmp10_ = attr;
#line 413 "../src/Objects/Printer.vala"
					_tmp11_ = ippGetString (_tmp10_, i, NULL);
#line 413 "../src/Objects/Printer.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) print_color_modes, _tmp11_);
#line 1710 "Printer.c"
				}
			}
		}
#line 416 "../src/Objects/Printer.vala"
		_tmp12_ = request;
#line 416 "../src/Objects/Printer.vala"
		_tmp13_ = ippFindAttribute (_tmp12_, "print-color-mode-default", IPP_TAG_ZERO);
#line 416 "../src/Objects/Printer.vala"
		attr = _tmp13_;
#line 417 "../src/Objects/Printer.vala"
		_tmp14_ = attr;
#line 417 "../src/Objects/Printer.vala"
		if (ippGetCount (_tmp14_) > 0) {
#line 1724 "Printer.c"
			ipp_attribute_t* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 418 "../src/Objects/Printer.vala"
			_tmp15_ = attr;
#line 418 "../src/Objects/Printer.vala"
			_tmp16_ = ippGetString (_tmp15_, 0, NULL);
#line 418 "../src/Objects/Printer.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 418 "../src/Objects/Printer.vala"
			result = _tmp17_;
#line 418 "../src/Objects/Printer.vala"
			_ippDelete0 (request);
#line 418 "../src/Objects/Printer.vala"
			attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 418 "../src/Objects/Printer.vala"
			return result;
#line 1742 "Printer.c"
		}
#line 409 "../src/Objects/Printer.vala"
		_ippDelete0 (request);
#line 1746 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 409 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 409 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 421 "../src/Objects/Printer.vala"
		_tmp18_ = e;
#line 421 "../src/Objects/Printer.vala"
		_tmp19_ = _tmp18_->message;
#line 421 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:421: Error: %s", _tmp19_);
#line 409 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 1766 "Printer.c"
	}
	__finally0:
#line 409 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 409 "../src/Objects/Printer.vala"
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 409 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 409 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 409 "../src/Objects/Printer.vala"
		return NULL;
#line 1779 "Printer.c"
	}
#line 424 "../src/Objects/Printer.vala"
	_tmp20_ = g_strdup ("auto");
#line 424 "../src/Objects/Printer.vala"
	result = _tmp20_;
#line 424 "../src/Objects/Printer.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 424 "../src/Objects/Printer.vala"
	return result;
#line 1789 "Printer.c"
}

void
printers_printer_set_default_print_color_mode (PrintersPrinter* self,
                                               const gchar* new_default)
{
	CupsPkHelper* pk_helper = NULL;
	CupsPkHelper* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 427 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 427 "../src/Objects/Printer.vala"
	g_return_if_fail (new_default != NULL);
#line 428 "../src/Objects/Printer.vala"
	_tmp0_ = cups_get_pk_helper ();
#line 428 "../src/Objects/Printer.vala"
	pk_helper = _tmp0_;
#line 1807 "Printer.c"
	{
		CupsPkHelper* _tmp1_;
		cups_dest_t _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		CupsPkHelper* _tmp6_;
		cups_dest_t _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 430 "../src/Objects/Printer.vala"
		_tmp1_ = pk_helper;
#line 430 "../src/Objects/Printer.vala"
		_tmp2_ = self->dest;
#line 430 "../src/Objects/Printer.vala"
		_tmp3_ = _tmp2_.name;
#line 430 "../src/Objects/Printer.vala"
		_tmp4_ = cups_pk_helper_printer_delete_option_default (_tmp1_, _tmp3_, "print-color-mode", &_inner_error0_);
#line 430 "../src/Objects/Printer.vala"
		_tmp5_ = _tmp4_;
#line 430 "../src/Objects/Printer.vala"
		_g_free0 (_tmp5_);
#line 430 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1837 "Printer.c"
			goto __catch0_g_error;
		}
#line 431 "../src/Objects/Printer.vala"
		_tmp6_ = pk_helper;
#line 431 "../src/Objects/Printer.vala"
		_tmp7_ = self->dest;
#line 431 "../src/Objects/Printer.vala"
		_tmp8_ = _tmp7_.name;
#line 431 "../src/Objects/Printer.vala"
		_tmp9_ = g_strdup (new_default);
#line 431 "../src/Objects/Printer.vala"
		_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 431 "../src/Objects/Printer.vala"
		_tmp10_[0] = _tmp9_;
#line 431 "../src/Objects/Printer.vala"
		_tmp11_ = _tmp10_;
#line 431 "../src/Objects/Printer.vala"
		_tmp11__length1 = 1;
#line 431 "../src/Objects/Printer.vala"
		_tmp12_ = cups_pk_helper_printer_add_option_default (_tmp6_, _tmp8_, "print-color-mode", _tmp11_, (gint) 1, &_inner_error0_);
#line 431 "../src/Objects/Printer.vala"
		_tmp13_ = _tmp12_;
#line 431 "../src/Objects/Printer.vala"
		_g_free0 (_tmp13_);
#line 431 "../src/Objects/Printer.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 431 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1866 "Printer.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 429 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 429 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 433 "../src/Objects/Printer.vala"
		_tmp14_ = e;
#line 433 "../src/Objects/Printer.vala"
		_tmp15_ = _tmp14_->message;
#line 433 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:433: %s", _tmp15_);
#line 429 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 1888 "Printer.c"
	}
	__finally0:
#line 429 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 429 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 429 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 429 "../src/Objects/Printer.vala"
		return;
#line 1899 "Printer.c"
	}
}

gchar*
printers_printer_get_media_sources (PrintersPrinter* self,
                                    GeeTreeSet* media_sources)
{
	gchar** attributes = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint attributes_length1;
	gint _attributes_size_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 437 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 437 "../src/Objects/Printer.vala"
	g_return_val_if_fail (media_sources != NULL, NULL);
#line 438 "../src/Objects/Printer.vala"
	_tmp0_ = g_strdup ("media-source-supported");
#line 438 "../src/Objects/Printer.vala"
	_tmp1_ = g_strdup ("media-source-default-default");
#line 438 "../src/Objects/Printer.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 438 "../src/Objects/Printer.vala"
	_tmp2_[0] = _tmp0_;
#line 438 "../src/Objects/Printer.vala"
	_tmp2_[1] = _tmp1_;
#line 438 "../src/Objects/Printer.vala"
	attributes = _tmp2_;
#line 438 "../src/Objects/Printer.vala"
	attributes_length1 = 2;
#line 438 "../src/Objects/Printer.vala"
	_attributes_size_ = attributes_length1;
#line 1936 "Printer.c"
	{
		ipp_t* request = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		ipp_t* _tmp4_;
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp5_;
		ipp_attribute_t* _tmp6_;
		ipp_t* _tmp12_;
		ipp_attribute_t* _tmp13_;
		ipp_attribute_t* _tmp14_;
#line 441 "../src/Objects/Printer.vala"
		_tmp3_ = attributes;
#line 441 "../src/Objects/Printer.vala"
		_tmp3__length1 = attributes_length1;
#line 441 "../src/Objects/Printer.vala"
		_tmp4_ = printers_printer_request_attributes (self, _tmp3_, (gint) _tmp3__length1, &_inner_error0_);
#line 441 "../src/Objects/Printer.vala"
		request = _tmp4_;
#line 441 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1958 "Printer.c"
			goto __catch0_g_error;
		}
#line 442 "../src/Objects/Printer.vala"
		_tmp5_ = request;
#line 442 "../src/Objects/Printer.vala"
		_tmp6_ = ippFindAttribute (_tmp5_, "media-source-supported", IPP_TAG_ZERO);
#line 442 "../src/Objects/Printer.vala"
		attr = _tmp6_;
#line 1967 "Printer.c"
		{
			gint i = 0;
#line 443 "../src/Objects/Printer.vala"
			i = 0;
#line 1972 "Printer.c"
			{
				gboolean _tmp7_ = FALSE;
#line 443 "../src/Objects/Printer.vala"
				_tmp7_ = TRUE;
#line 443 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 1979 "Printer.c"
					ipp_attribute_t* _tmp9_;
					ipp_attribute_t* _tmp10_;
					const gchar* _tmp11_;
#line 443 "../src/Objects/Printer.vala"
					if (!_tmp7_) {
#line 1985 "Printer.c"
						gint _tmp8_;
#line 443 "../src/Objects/Printer.vala"
						_tmp8_ = i;
#line 443 "../src/Objects/Printer.vala"
						i = _tmp8_ + 1;
#line 1991 "Printer.c"
					}
#line 443 "../src/Objects/Printer.vala"
					_tmp7_ = FALSE;
#line 443 "../src/Objects/Printer.vala"
					_tmp9_ = attr;
#line 443 "../src/Objects/Printer.vala"
					if (!(i < ippGetCount (_tmp9_))) {
#line 443 "../src/Objects/Printer.vala"
						break;
#line 2001 "Printer.c"
					}
#line 444 "../src/Objects/Printer.vala"
					_tmp10_ = attr;
#line 444 "../src/Objects/Printer.vala"
					_tmp11_ = ippGetString (_tmp10_, i, NULL);
#line 444 "../src/Objects/Printer.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) media_sources, _tmp11_);
#line 2009 "Printer.c"
				}
			}
		}
#line 447 "../src/Objects/Printer.vala"
		_tmp12_ = request;
#line 447 "../src/Objects/Printer.vala"
		_tmp13_ = ippFindAttribute (_tmp12_, "media-source-default-default", IPP_TAG_ZERO);
#line 447 "../src/Objects/Printer.vala"
		attr = _tmp13_;
#line 448 "../src/Objects/Printer.vala"
		_tmp14_ = attr;
#line 448 "../src/Objects/Printer.vala"
		if (ippGetCount (_tmp14_) > 0) {
#line 2023 "Printer.c"
			ipp_attribute_t* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 449 "../src/Objects/Printer.vala"
			_tmp15_ = attr;
#line 449 "../src/Objects/Printer.vala"
			_tmp16_ = ippGetString (_tmp15_, 0, NULL);
#line 449 "../src/Objects/Printer.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 449 "../src/Objects/Printer.vala"
			result = _tmp17_;
#line 449 "../src/Objects/Printer.vala"
			_ippDelete0 (request);
#line 449 "../src/Objects/Printer.vala"
			attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 449 "../src/Objects/Printer.vala"
			return result;
#line 2041 "Printer.c"
		}
#line 440 "../src/Objects/Printer.vala"
		_ippDelete0 (request);
#line 2045 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 440 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 440 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 452 "../src/Objects/Printer.vala"
		_tmp18_ = e;
#line 452 "../src/Objects/Printer.vala"
		_tmp19_ = _tmp18_->message;
#line 452 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:452: Error: %s", _tmp19_);
#line 440 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 2065 "Printer.c"
	}
	__finally0:
#line 440 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 440 "../src/Objects/Printer.vala"
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 440 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 440 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 440 "../src/Objects/Printer.vala"
		return NULL;
#line 2078 "Printer.c"
	}
#line 455 "../src/Objects/Printer.vala"
	_tmp20_ = g_strdup ("auto");
#line 455 "../src/Objects/Printer.vala"
	result = _tmp20_;
#line 455 "../src/Objects/Printer.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 455 "../src/Objects/Printer.vala"
	return result;
#line 2088 "Printer.c"
}

gchar*
printers_printer_get_media_sizes (PrintersPrinter* self,
                                  GeeTreeSet* media_sizes)
{
	gchar** attributes = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint attributes_length1;
	gint _attributes_size_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 458 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 458 "../src/Objects/Printer.vala"
	g_return_val_if_fail (media_sizes != NULL, NULL);
#line 459 "../src/Objects/Printer.vala"
	_tmp0_ = g_strdup (CUPS_MEDIA_SUPPORTED);
#line 459 "../src/Objects/Printer.vala"
	_tmp1_ = g_strdup ("media-supported-default");
#line 459 "../src/Objects/Printer.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 459 "../src/Objects/Printer.vala"
	_tmp2_[0] = _tmp0_;
#line 459 "../src/Objects/Printer.vala"
	_tmp2_[1] = _tmp1_;
#line 459 "../src/Objects/Printer.vala"
	attributes = _tmp2_;
#line 459 "../src/Objects/Printer.vala"
	attributes_length1 = 2;
#line 459 "../src/Objects/Printer.vala"
	_attributes_size_ = attributes_length1;
#line 2125 "Printer.c"
	{
		ipp_t* request = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		ipp_t* _tmp4_;
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp5_;
		ipp_attribute_t* _tmp6_;
		ipp_t* _tmp12_;
		ipp_attribute_t* _tmp13_;
		ipp_attribute_t* _tmp14_;
#line 462 "../src/Objects/Printer.vala"
		_tmp3_ = attributes;
#line 462 "../src/Objects/Printer.vala"
		_tmp3__length1 = attributes_length1;
#line 462 "../src/Objects/Printer.vala"
		_tmp4_ = printers_printer_request_attributes (self, _tmp3_, (gint) _tmp3__length1, &_inner_error0_);
#line 462 "../src/Objects/Printer.vala"
		request = _tmp4_;
#line 462 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2147 "Printer.c"
			goto __catch0_g_error;
		}
#line 463 "../src/Objects/Printer.vala"
		_tmp5_ = request;
#line 463 "../src/Objects/Printer.vala"
		_tmp6_ = ippFindAttribute (_tmp5_, CUPS_MEDIA_SUPPORTED, IPP_TAG_ZERO);
#line 463 "../src/Objects/Printer.vala"
		attr = _tmp6_;
#line 2156 "Printer.c"
		{
			gint i = 0;
#line 464 "../src/Objects/Printer.vala"
			i = 0;
#line 2161 "Printer.c"
			{
				gboolean _tmp7_ = FALSE;
#line 464 "../src/Objects/Printer.vala"
				_tmp7_ = TRUE;
#line 464 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 2168 "Printer.c"
					ipp_attribute_t* _tmp9_;
					ipp_attribute_t* _tmp10_;
					const gchar* _tmp11_;
#line 464 "../src/Objects/Printer.vala"
					if (!_tmp7_) {
#line 2174 "Printer.c"
						gint _tmp8_;
#line 464 "../src/Objects/Printer.vala"
						_tmp8_ = i;
#line 464 "../src/Objects/Printer.vala"
						i = _tmp8_ + 1;
#line 2180 "Printer.c"
					}
#line 464 "../src/Objects/Printer.vala"
					_tmp7_ = FALSE;
#line 464 "../src/Objects/Printer.vala"
					_tmp9_ = attr;
#line 464 "../src/Objects/Printer.vala"
					if (!(i < ippGetCount (_tmp9_))) {
#line 464 "../src/Objects/Printer.vala"
						break;
#line 2190 "Printer.c"
					}
#line 465 "../src/Objects/Printer.vala"
					_tmp10_ = attr;
#line 465 "../src/Objects/Printer.vala"
					_tmp11_ = ippGetString (_tmp10_, i, NULL);
#line 465 "../src/Objects/Printer.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) media_sizes, _tmp11_);
#line 2198 "Printer.c"
				}
			}
		}
#line 468 "../src/Objects/Printer.vala"
		_tmp12_ = request;
#line 468 "../src/Objects/Printer.vala"
		_tmp13_ = ippFindAttribute (_tmp12_, "media-supported-default", IPP_TAG_ZERO);
#line 468 "../src/Objects/Printer.vala"
		attr = _tmp13_;
#line 469 "../src/Objects/Printer.vala"
		_tmp14_ = attr;
#line 469 "../src/Objects/Printer.vala"
		if (ippGetCount (_tmp14_) > 0) {
#line 2212 "Printer.c"
			ipp_attribute_t* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 470 "../src/Objects/Printer.vala"
			_tmp15_ = attr;
#line 470 "../src/Objects/Printer.vala"
			_tmp16_ = ippGetString (_tmp15_, 0, NULL);
#line 470 "../src/Objects/Printer.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 470 "../src/Objects/Printer.vala"
			result = _tmp17_;
#line 470 "../src/Objects/Printer.vala"
			_ippDelete0 (request);
#line 470 "../src/Objects/Printer.vala"
			attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 470 "../src/Objects/Printer.vala"
			return result;
#line 2230 "Printer.c"
		}
#line 461 "../src/Objects/Printer.vala"
		_ippDelete0 (request);
#line 2234 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 461 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 461 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 473 "../src/Objects/Printer.vala"
		_tmp18_ = e;
#line 473 "../src/Objects/Printer.vala"
		_tmp19_ = _tmp18_->message;
#line 473 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:473: Error: %s", _tmp19_);
#line 461 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 2254 "Printer.c"
	}
	__finally0:
#line 461 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 461 "../src/Objects/Printer.vala"
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 461 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 461 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 461 "../src/Objects/Printer.vala"
		return NULL;
#line 2267 "Printer.c"
	}
#line 476 "../src/Objects/Printer.vala"
	_tmp20_ = gtk_paper_size_get_default ();
#line 476 "../src/Objects/Printer.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 476 "../src/Objects/Printer.vala"
	result = _tmp21_;
#line 476 "../src/Objects/Printer.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 476 "../src/Objects/Printer.vala"
	return result;
#line 2279 "Printer.c"
}

void
printers_printer_set_default_media_size (PrintersPrinter* self,
                                         const gchar* new_default)
{
	CupsPkHelper* pk_helper = NULL;
	CupsPkHelper* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 479 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 479 "../src/Objects/Printer.vala"
	g_return_if_fail (new_default != NULL);
#line 480 "../src/Objects/Printer.vala"
	_tmp0_ = cups_get_pk_helper ();
#line 480 "../src/Objects/Printer.vala"
	pk_helper = _tmp0_;
#line 2297 "Printer.c"
	{
		CupsPkHelper* _tmp1_;
		cups_dest_t _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		CupsPkHelper* _tmp6_;
		cups_dest_t _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 482 "../src/Objects/Printer.vala"
		_tmp1_ = pk_helper;
#line 482 "../src/Objects/Printer.vala"
		_tmp2_ = self->dest;
#line 482 "../src/Objects/Printer.vala"
		_tmp3_ = _tmp2_.name;
#line 482 "../src/Objects/Printer.vala"
		_tmp4_ = cups_pk_helper_printer_delete_option_default (_tmp1_, _tmp3_, "media-supported-default", &_inner_error0_);
#line 482 "../src/Objects/Printer.vala"
		_tmp5_ = _tmp4_;
#line 482 "../src/Objects/Printer.vala"
		_g_free0 (_tmp5_);
#line 482 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2327 "Printer.c"
			goto __catch0_g_error;
		}
#line 483 "../src/Objects/Printer.vala"
		_tmp6_ = pk_helper;
#line 483 "../src/Objects/Printer.vala"
		_tmp7_ = self->dest;
#line 483 "../src/Objects/Printer.vala"
		_tmp8_ = _tmp7_.name;
#line 483 "../src/Objects/Printer.vala"
		_tmp9_ = g_strdup (new_default);
#line 483 "../src/Objects/Printer.vala"
		_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 483 "../src/Objects/Printer.vala"
		_tmp10_[0] = _tmp9_;
#line 483 "../src/Objects/Printer.vala"
		_tmp11_ = _tmp10_;
#line 483 "../src/Objects/Printer.vala"
		_tmp11__length1 = 1;
#line 483 "../src/Objects/Printer.vala"
		_tmp12_ = cups_pk_helper_printer_add_option_default (_tmp6_, _tmp8_, "media-supported-default", _tmp11_, (gint) 1, &_inner_error0_);
#line 483 "../src/Objects/Printer.vala"
		_tmp13_ = _tmp12_;
#line 483 "../src/Objects/Printer.vala"
		_g_free0 (_tmp13_);
#line 483 "../src/Objects/Printer.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 483 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2356 "Printer.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 481 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 481 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 485 "../src/Objects/Printer.vala"
		_tmp14_ = e;
#line 485 "../src/Objects/Printer.vala"
		_tmp15_ = _tmp14_->message;
#line 485 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:485: %s", _tmp15_);
#line 481 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 2378 "Printer.c"
	}
	__finally0:
#line 481 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 481 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 481 "../src/Objects/Printer.vala"
		return;
#line 2389 "Printer.c"
	}
}

void
printers_printer_set_default_media_source (PrintersPrinter* self,
                                           const gchar* new_default)
{
	CupsPkHelper* pk_helper = NULL;
	CupsPkHelper* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 489 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 489 "../src/Objects/Printer.vala"
	g_return_if_fail (new_default != NULL);
#line 490 "../src/Objects/Printer.vala"
	_tmp0_ = cups_get_pk_helper ();
#line 490 "../src/Objects/Printer.vala"
	pk_helper = _tmp0_;
#line 2408 "Printer.c"
	{
		CupsPkHelper* _tmp1_;
		cups_dest_t _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		CupsPkHelper* _tmp6_;
		cups_dest_t _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 492 "../src/Objects/Printer.vala"
		_tmp1_ = pk_helper;
#line 492 "../src/Objects/Printer.vala"
		_tmp2_ = self->dest;
#line 492 "../src/Objects/Printer.vala"
		_tmp3_ = _tmp2_.name;
#line 492 "../src/Objects/Printer.vala"
		_tmp4_ = cups_pk_helper_printer_delete_option_default (_tmp1_, _tmp3_, "media-source-default-default", &_inner_error0_);
#line 492 "../src/Objects/Printer.vala"
		_tmp5_ = _tmp4_;
#line 492 "../src/Objects/Printer.vala"
		_g_free0 (_tmp5_);
#line 492 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2438 "Printer.c"
			goto __catch0_g_error;
		}
#line 493 "../src/Objects/Printer.vala"
		_tmp6_ = pk_helper;
#line 493 "../src/Objects/Printer.vala"
		_tmp7_ = self->dest;
#line 493 "../src/Objects/Printer.vala"
		_tmp8_ = _tmp7_.name;
#line 493 "../src/Objects/Printer.vala"
		_tmp9_ = g_strdup (new_default);
#line 493 "../src/Objects/Printer.vala"
		_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 493 "../src/Objects/Printer.vala"
		_tmp10_[0] = _tmp9_;
#line 493 "../src/Objects/Printer.vala"
		_tmp11_ = _tmp10_;
#line 493 "../src/Objects/Printer.vala"
		_tmp11__length1 = 1;
#line 493 "../src/Objects/Printer.vala"
		_tmp12_ = cups_pk_helper_printer_add_option_default (_tmp6_, _tmp8_, "media-source-default-default", _tmp11_, (gint) 1, &_inner_error0_);
#line 493 "../src/Objects/Printer.vala"
		_tmp13_ = _tmp12_;
#line 493 "../src/Objects/Printer.vala"
		_g_free0 (_tmp13_);
#line 493 "../src/Objects/Printer.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 493 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2467 "Printer.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 491 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 491 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 495 "../src/Objects/Printer.vala"
		_tmp14_ = e;
#line 495 "../src/Objects/Printer.vala"
		_tmp15_ = _tmp14_->message;
#line 495 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:495: %s", _tmp15_);
#line 491 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 2489 "Printer.c"
	}
	__finally0:
#line 491 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 491 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 491 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 491 "../src/Objects/Printer.vala"
		return;
#line 2500 "Printer.c"
	}
}

gint
printers_printer_get_print_qualities (PrintersPrinter* self,
                                      GeeTreeSet* print_qualities)
{
	gchar** attributes = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint attributes_length1;
	gint _attributes_size_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 499 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 499 "../src/Objects/Printer.vala"
	g_return_val_if_fail (print_qualities != NULL, 0);
#line 500 "../src/Objects/Printer.vala"
	_tmp0_ = g_strdup ("print-quality-supported");
#line 500 "../src/Objects/Printer.vala"
	_tmp1_ = g_strdup ("print-quality-default");
#line 500 "../src/Objects/Printer.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 500 "../src/Objects/Printer.vala"
	_tmp2_[0] = _tmp0_;
#line 500 "../src/Objects/Printer.vala"
	_tmp2_[1] = _tmp1_;
#line 500 "../src/Objects/Printer.vala"
	attributes = _tmp2_;
#line 500 "../src/Objects/Printer.vala"
	attributes_length1 = 2;
#line 500 "../src/Objects/Printer.vala"
	_attributes_size_ = attributes_length1;
#line 2536 "Printer.c"
	{
		ipp_t* request = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		ipp_t* _tmp4_;
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp5_;
		ipp_attribute_t* _tmp6_;
		ipp_t* _tmp11_;
		ipp_attribute_t* _tmp12_;
		ipp_attribute_t* _tmp13_;
#line 503 "../src/Objects/Printer.vala"
		_tmp3_ = attributes;
#line 503 "../src/Objects/Printer.vala"
		_tmp3__length1 = attributes_length1;
#line 503 "../src/Objects/Printer.vala"
		_tmp4_ = printers_printer_request_attributes (self, _tmp3_, (gint) _tmp3__length1, &_inner_error0_);
#line 503 "../src/Objects/Printer.vala"
		request = _tmp4_;
#line 503 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2558 "Printer.c"
			goto __catch0_g_error;
		}
#line 504 "../src/Objects/Printer.vala"
		_tmp5_ = request;
#line 504 "../src/Objects/Printer.vala"
		_tmp6_ = ippFindAttribute (_tmp5_, "print-quality-supported", IPP_TAG_ZERO);
#line 504 "../src/Objects/Printer.vala"
		attr = _tmp6_;
#line 2567 "Printer.c"
		{
			gint i = 0;
#line 505 "../src/Objects/Printer.vala"
			i = 0;
#line 2572 "Printer.c"
			{
				gboolean _tmp7_ = FALSE;
#line 505 "../src/Objects/Printer.vala"
				_tmp7_ = TRUE;
#line 505 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 2579 "Printer.c"
					ipp_attribute_t* _tmp9_;
					ipp_attribute_t* _tmp10_;
#line 505 "../src/Objects/Printer.vala"
					if (!_tmp7_) {
#line 2584 "Printer.c"
						gint _tmp8_;
#line 505 "../src/Objects/Printer.vala"
						_tmp8_ = i;
#line 505 "../src/Objects/Printer.vala"
						i = _tmp8_ + 1;
#line 2590 "Printer.c"
					}
#line 505 "../src/Objects/Printer.vala"
					_tmp7_ = FALSE;
#line 505 "../src/Objects/Printer.vala"
					_tmp9_ = attr;
#line 505 "../src/Objects/Printer.vala"
					if (!(i < ippGetCount (_tmp9_))) {
#line 505 "../src/Objects/Printer.vala"
						break;
#line 2600 "Printer.c"
					}
#line 506 "../src/Objects/Printer.vala"
					_tmp10_ = attr;
#line 506 "../src/Objects/Printer.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) print_qualities, (gpointer) ((gintptr) ippGetInteger (_tmp10_, i)));
#line 2606 "Printer.c"
				}
			}
		}
#line 509 "../src/Objects/Printer.vala"
		_tmp11_ = request;
#line 509 "../src/Objects/Printer.vala"
		_tmp12_ = ippFindAttribute (_tmp11_, "print-quality-default", IPP_TAG_ZERO);
#line 509 "../src/Objects/Printer.vala"
		attr = _tmp12_;
#line 510 "../src/Objects/Printer.vala"
		_tmp13_ = attr;
#line 510 "../src/Objects/Printer.vala"
		if (ippGetCount (_tmp13_) > 0) {
#line 2620 "Printer.c"
			gint quality = 0;
			ipp_attribute_t* _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 511 "../src/Objects/Printer.vala"
			_tmp14_ = attr;
#line 511 "../src/Objects/Printer.vala"
			quality = ippGetInteger (_tmp14_, 0);
#line 512 "../src/Objects/Printer.vala"
			if (quality >= 3) {
#line 512 "../src/Objects/Printer.vala"
				_tmp15_ = quality <= 5;
#line 2632 "Printer.c"
			} else {
#line 512 "../src/Objects/Printer.vala"
				_tmp15_ = FALSE;
#line 2636 "Printer.c"
			}
#line 512 "../src/Objects/Printer.vala"
			if (_tmp15_) {
#line 513 "../src/Objects/Printer.vala"
				result = quality;
#line 513 "../src/Objects/Printer.vala"
				_ippDelete0 (request);
#line 513 "../src/Objects/Printer.vala"
				attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 513 "../src/Objects/Printer.vala"
				return result;
#line 2648 "Printer.c"
			}
		}
#line 502 "../src/Objects/Printer.vala"
		_ippDelete0 (request);
#line 2653 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 502 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 502 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 517 "../src/Objects/Printer.vala"
		_tmp16_ = e;
#line 517 "../src/Objects/Printer.vala"
		_tmp17_ = _tmp16_->message;
#line 517 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:517: Error: %s", _tmp17_);
#line 502 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 2673 "Printer.c"
	}
	__finally0:
#line 502 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2678 "Printer.c"
		gint _tmp18_ = -1;
#line 502 "../src/Objects/Printer.vala"
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 502 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 502 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 502 "../src/Objects/Printer.vala"
		return _tmp18_;
#line 2688 "Printer.c"
	}
#line 520 "../src/Objects/Printer.vala"
	result = 4;
#line 520 "../src/Objects/Printer.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 520 "../src/Objects/Printer.vala"
	return result;
#line 2696 "Printer.c"
}

void
printers_printer_get_all (PrintersPrinter* self)
{
	gchar** attributes = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint attributes_length1;
	gint _attributes_size_;
	GError* _inner_error0_ = NULL;
#line 523 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 524 "../src/Objects/Printer.vala"
	_tmp0_ = g_strdup ("all");
#line 524 "../src/Objects/Printer.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 524 "../src/Objects/Printer.vala"
	_tmp1_[0] = _tmp0_;
#line 524 "../src/Objects/Printer.vala"
	attributes = _tmp1_;
#line 524 "../src/Objects/Printer.vala"
	attributes_length1 = 1;
#line 524 "../src/Objects/Printer.vala"
	_attributes_size_ = attributes_length1;
#line 2722 "Printer.c"
	{
		ipp_t* request = NULL;
		gchar** _tmp2_;
		gint _tmp2__length1;
		ipp_t* _tmp3_;
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp4_;
		ipp_attribute_t* _tmp5_;
#line 526 "../src/Objects/Printer.vala"
		_tmp2_ = attributes;
#line 526 "../src/Objects/Printer.vala"
		_tmp2__length1 = attributes_length1;
#line 526 "../src/Objects/Printer.vala"
		_tmp3_ = printers_printer_request_attributes (self, _tmp2_, (gint) _tmp2__length1, &_inner_error0_);
#line 526 "../src/Objects/Printer.vala"
		request = _tmp3_;
#line 526 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2741 "Printer.c"
			goto __catch0_g_error;
		}
#line 527 "../src/Objects/Printer.vala"
		_tmp4_ = request;
#line 527 "../src/Objects/Printer.vala"
		_tmp5_ = ippFirstAttribute (_tmp4_);
#line 527 "../src/Objects/Printer.vala"
		attr = _tmp5_;
#line 528 "../src/Objects/Printer.vala"
		while (TRUE) {
#line 2752 "Printer.c"
			ipp_attribute_t* _tmp6_;
			ipp_attribute_t* _tmp7_;
			const gchar* _tmp8_;
			ipp_t* _tmp9_;
			ipp_attribute_t* _tmp10_;
#line 528 "../src/Objects/Printer.vala"
			_tmp6_ = attr;
#line 528 "../src/Objects/Printer.vala"
			if (!(_tmp6_ != NULL)) {
#line 528 "../src/Objects/Printer.vala"
				break;
#line 2764 "Printer.c"
			}
#line 529 "../src/Objects/Printer.vala"
			_tmp7_ = attr;
#line 529 "../src/Objects/Printer.vala"
			_tmp8_ = ippGetName (_tmp7_);
#line 529 "../src/Objects/Printer.vala"
			g_debug ("Printer.vala:529: %s", _tmp8_);
#line 530 "../src/Objects/Printer.vala"
			_tmp9_ = request;
#line 530 "../src/Objects/Printer.vala"
			_tmp10_ = ippNextAttribute (_tmp9_);
#line 530 "../src/Objects/Printer.vala"
			attr = _tmp10_;
#line 2778 "Printer.c"
		}
#line 525 "../src/Objects/Printer.vala"
		_ippDelete0 (request);
#line 2782 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 525 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 525 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 533 "../src/Objects/Printer.vala"
		_tmp11_ = e;
#line 533 "../src/Objects/Printer.vala"
		_tmp12_ = _tmp11_->message;
#line 533 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:533: Error: %s", _tmp12_);
#line 525 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 2802 "Printer.c"
	}
	__finally0:
#line 525 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 525 "../src/Objects/Printer.vala"
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 525 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 525 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 525 "../src/Objects/Printer.vala"
		return;
#line 2815 "Printer.c"
	}
#line 523 "../src/Objects/Printer.vala"
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
#line 2819 "Printer.c"
}

static ipp_t*
printers_printer_request_attributes (PrintersPrinter* self,
                                     gchar** attributes,
                                     gint attributes_length1,
                                     GError** error)
{
	gchar* printer_uri = NULL;
	gchar* _tmp0_;
	gint printer_uri_length1;
	gint _printer_uri_size_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	cups_dest_t _tmp2_;
	const gchar* _tmp3_;
	ipp_t* request = NULL;
	ipp_t* _tmp4_;
	ipp_t* _tmp5_;
	gchar* _tmp6_;
	gint _tmp6__length1;
	ipp_t* _tmp7_;
	http_t* _tmp8_;
	ipp_status_t status_code = 0;
	ipp_t* _tmp9_;
	GError* _inner_error0_ = NULL;
	ipp_t* result;
#line 537 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 538 "../src/Objects/Printer.vala"
	_tmp0_ = g_new0 (gchar, HTTP_MAX_URI);
#line 538 "../src/Objects/Printer.vala"
	printer_uri = _tmp0_;
#line 538 "../src/Objects/Printer.vala"
	printer_uri_length1 = HTTP_MAX_URI;
#line 538 "../src/Objects/Printer.vala"
	_printer_uri_size_ = printer_uri_length1;
#line 539 "../src/Objects/Printer.vala"
	_tmp1_ = printer_uri;
#line 539 "../src/Objects/Printer.vala"
	_tmp1__length1 = printer_uri_length1;
#line 539 "../src/Objects/Printer.vala"
	_tmp2_ = self->dest;
#line 539 "../src/Objects/Printer.vala"
	_tmp3_ = _tmp2_.name;
#line 539 "../src/Objects/Printer.vala"
	httpAssembleURIf (HTTP_URI_CODING_QUERY, _tmp1_, (gint) _tmp1__length1, "ipp", NULL, "localhost", 0, "/printers/%s", _tmp3_);
#line 540 "../src/Objects/Printer.vala"
	_tmp4_ = ippNewRequest (IPP_GET_PRINTER_ATTRIBUTES);
#line 540 "../src/Objects/Printer.vala"
	request = _tmp4_;
#line 541 "../src/Objects/Printer.vala"
	_tmp5_ = request;
#line 541 "../src/Objects/Printer.vala"
	_tmp6_ = printer_uri;
#line 541 "../src/Objects/Printer.vala"
	_tmp6__length1 = printer_uri_length1;
#line 541 "../src/Objects/Printer.vala"
	ippAddString (_tmp5_, IPP_TAG_OPERATION, IPP_TAG_URI, "printer-uri", NULL, (const gchar*) _tmp6_);
#line 543 "../src/Objects/Printer.vala"
	_tmp7_ = request;
#line 543 "../src/Objects/Printer.vala"
	ippAddStrings (_tmp7_, IPP_TAG_OPERATION, IPP_TAG_KEYWORD, "requested-attributes", (gint) attributes_length1, NULL, attributes);
#line 544 "../src/Objects/Printer.vala"
	_tmp8_ = CUPS_HTTP_DEFAULT;
#line 544 "../src/Objects/Printer.vala"
	request = cupsDoRequest (_tmp8_, request, "/");
#line 546 "../src/Objects/Printer.vala"
	_tmp9_ = request;
#line 546 "../src/Objects/Printer.vala"
	status_code = ippGetStatusCode (_tmp9_);
#line 547 "../src/Objects/Printer.vala"
	if (status_code <= IPP_OK_CONFLICT) {
#line 548 "../src/Objects/Printer.vala"
		result = request;
#line 548 "../src/Objects/Printer.vala"
		printer_uri = (g_free (printer_uri), NULL);
#line 548 "../src/Objects/Printer.vala"
		return result;
#line 2899 "Printer.c"
	} else {
		const gchar* _tmp10_;
		GError* _tmp11_;
#line 550 "../src/Objects/Printer.vala"
		_tmp10_ = ippErrorString (status_code);
#line 550 "../src/Objects/Printer.vala"
		_tmp11_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp10_);
#line 550 "../src/Objects/Printer.vala"
		_inner_error0_ = _tmp11_;
#line 550 "../src/Objects/Printer.vala"
		g_propagate_error (error, _inner_error0_);
#line 550 "../src/Objects/Printer.vala"
		_ippDelete0 (request);
#line 550 "../src/Objects/Printer.vala"
		printer_uri = (g_free (printer_uri), NULL);
#line 550 "../src/Objects/Printer.vala"
		return NULL;
#line 2917 "Printer.c"
	}
}

static gint
__lambda5_ (PrintersPrinter* self,
            PrintersPrinterColorLevel* a,
            PrintersPrinterColorLevel* b)
{
	GdkRGBA col_a = {0};
	GdkRGBA _tmp0_ = {0};
	GdkRGBA col_b = {0};
	GdkRGBA _tmp1_ = {0};
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	GdkRGBA _tmp6_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	GdkRGBA _tmp11_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GdkRGBA _tmp16_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	GdkRGBA _tmp21_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	GdkRGBA _tmp26_;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	GdkRGBA _tmp31_;
	gdouble a_tot = 0.0;
	GdkRGBA _tmp34_;
	GdkRGBA _tmp35_;
	GdkRGBA _tmp36_;
	gdouble b_tot = 0.0;
	GdkRGBA _tmp37_;
	GdkRGBA _tmp38_;
	GdkRGBA _tmp39_;
	gint result;
#line 609 "../src/Objects/Printer.vala"
	col_a = _tmp0_;
#line 609 "../src/Objects/Printer.vala"
	col_b = _tmp1_;
#line 610 "../src/Objects/Printer.vala"
	_tmp2_ = a->color;
#line 610 "../src/Objects/Printer.vala"
	gdk_rgba_parse (&col_a, _tmp2_);
#line 611 "../src/Objects/Printer.vala"
	_tmp3_ = b->color;
#line 611 "../src/Objects/Printer.vala"
	gdk_rgba_parse (&col_b, _tmp3_);
#line 613 "../src/Objects/Printer.vala"
	_tmp6_ = col_a;
#line 613 "../src/Objects/Printer.vala"
	if (_tmp6_.green > 0.8) {
#line 2975 "Printer.c"
		GdkRGBA _tmp7_;
#line 613 "../src/Objects/Printer.vala"
		_tmp7_ = col_a;
#line 613 "../src/Objects/Printer.vala"
		_tmp5_ = _tmp7_.blue > 0.8;
#line 2981 "Printer.c"
	} else {
#line 613 "../src/Objects/Printer.vala"
		_tmp5_ = FALSE;
#line 2985 "Printer.c"
	}
#line 613 "../src/Objects/Printer.vala"
	if (_tmp5_) {
#line 2989 "Printer.c"
		GdkRGBA _tmp8_;
#line 613 "../src/Objects/Printer.vala"
		_tmp8_ = col_a;
#line 613 "../src/Objects/Printer.vala"
		_tmp4_ = _tmp8_.red < 0.3;
#line 2995 "Printer.c"
	} else {
#line 613 "../src/Objects/Printer.vala"
		_tmp4_ = FALSE;
#line 2999 "Printer.c"
	}
#line 613 "../src/Objects/Printer.vala"
	if (_tmp4_) {
#line 614 "../src/Objects/Printer.vala"
		result = -1;
#line 614 "../src/Objects/Printer.vala"
		return result;
#line 3007 "Printer.c"
	}
#line 616 "../src/Objects/Printer.vala"
	_tmp11_ = col_b;
#line 616 "../src/Objects/Printer.vala"
	if (_tmp11_.green > 0.8) {
#line 3013 "Printer.c"
		GdkRGBA _tmp12_;
#line 616 "../src/Objects/Printer.vala"
		_tmp12_ = col_b;
#line 616 "../src/Objects/Printer.vala"
		_tmp10_ = _tmp12_.blue > 0.8;
#line 3019 "Printer.c"
	} else {
#line 616 "../src/Objects/Printer.vala"
		_tmp10_ = FALSE;
#line 3023 "Printer.c"
	}
#line 616 "../src/Objects/Printer.vala"
	if (_tmp10_) {
#line 3027 "Printer.c"
		GdkRGBA _tmp13_;
#line 616 "../src/Objects/Printer.vala"
		_tmp13_ = col_b;
#line 616 "../src/Objects/Printer.vala"
		_tmp9_ = _tmp13_.red < 0.3;
#line 3033 "Printer.c"
	} else {
#line 616 "../src/Objects/Printer.vala"
		_tmp9_ = FALSE;
#line 3037 "Printer.c"
	}
#line 616 "../src/Objects/Printer.vala"
	if (_tmp9_) {
#line 617 "../src/Objects/Printer.vala"
		result = 1;
#line 617 "../src/Objects/Printer.vala"
		return result;
#line 3045 "Printer.c"
	}
#line 619 "../src/Objects/Printer.vala"
	_tmp16_ = col_a;
#line 619 "../src/Objects/Printer.vala"
	if (_tmp16_.green < 0.3) {
#line 3051 "Printer.c"
		GdkRGBA _tmp17_;
#line 619 "../src/Objects/Printer.vala"
		_tmp17_ = col_a;
#line 619 "../src/Objects/Printer.vala"
		_tmp15_ = _tmp17_.blue > 0.8;
#line 3057 "Printer.c"
	} else {
#line 619 "../src/Objects/Printer.vala"
		_tmp15_ = FALSE;
#line 3061 "Printer.c"
	}
#line 619 "../src/Objects/Printer.vala"
	if (_tmp15_) {
#line 3065 "Printer.c"
		GdkRGBA _tmp18_;
#line 619 "../src/Objects/Printer.vala"
		_tmp18_ = col_a;
#line 619 "../src/Objects/Printer.vala"
		_tmp14_ = _tmp18_.red > 0.8;
#line 3071 "Printer.c"
	} else {
#line 619 "../src/Objects/Printer.vala"
		_tmp14_ = FALSE;
#line 3075 "Printer.c"
	}
#line 619 "../src/Objects/Printer.vala"
	if (_tmp14_) {
#line 620 "../src/Objects/Printer.vala"
		result = -1;
#line 620 "../src/Objects/Printer.vala"
		return result;
#line 3083 "Printer.c"
	}
#line 622 "../src/Objects/Printer.vala"
	_tmp21_ = col_b;
#line 622 "../src/Objects/Printer.vala"
	if (_tmp21_.green < 0.3) {
#line 3089 "Printer.c"
		GdkRGBA _tmp22_;
#line 622 "../src/Objects/Printer.vala"
		_tmp22_ = col_b;
#line 622 "../src/Objects/Printer.vala"
		_tmp20_ = _tmp22_.blue > 0.8;
#line 3095 "Printer.c"
	} else {
#line 622 "../src/Objects/Printer.vala"
		_tmp20_ = FALSE;
#line 3099 "Printer.c"
	}
#line 622 "../src/Objects/Printer.vala"
	if (_tmp20_) {
#line 3103 "Printer.c"
		GdkRGBA _tmp23_;
#line 622 "../src/Objects/Printer.vala"
		_tmp23_ = col_b;
#line 622 "../src/Objects/Printer.vala"
		_tmp19_ = _tmp23_.red > 0.8;
#line 3109 "Printer.c"
	} else {
#line 622 "../src/Objects/Printer.vala"
		_tmp19_ = FALSE;
#line 3113 "Printer.c"
	}
#line 622 "../src/Objects/Printer.vala"
	if (_tmp19_) {
#line 623 "../src/Objects/Printer.vala"
		result = 1;
#line 623 "../src/Objects/Printer.vala"
		return result;
#line 3121 "Printer.c"
	}
#line 625 "../src/Objects/Printer.vala"
	_tmp26_ = col_a;
#line 625 "../src/Objects/Printer.vala"
	if (_tmp26_.green > 0.8) {
#line 3127 "Printer.c"
		GdkRGBA _tmp27_;
#line 625 "../src/Objects/Printer.vala"
		_tmp27_ = col_a;
#line 625 "../src/Objects/Printer.vala"
		_tmp25_ = _tmp27_.blue < 0.3;
#line 3133 "Printer.c"
	} else {
#line 625 "../src/Objects/Printer.vala"
		_tmp25_ = FALSE;
#line 3137 "Printer.c"
	}
#line 625 "../src/Objects/Printer.vala"
	if (_tmp25_) {
#line 3141 "Printer.c"
		GdkRGBA _tmp28_;
#line 625 "../src/Objects/Printer.vala"
		_tmp28_ = col_a;
#line 625 "../src/Objects/Printer.vala"
		_tmp24_ = _tmp28_.red > 0.8;
#line 3147 "Printer.c"
	} else {
#line 625 "../src/Objects/Printer.vala"
		_tmp24_ = FALSE;
#line 3151 "Printer.c"
	}
#line 625 "../src/Objects/Printer.vala"
	if (_tmp24_) {
#line 626 "../src/Objects/Printer.vala"
		result = -1;
#line 626 "../src/Objects/Printer.vala"
		return result;
#line 3159 "Printer.c"
	}
#line 628 "../src/Objects/Printer.vala"
	_tmp31_ = col_b;
#line 628 "../src/Objects/Printer.vala"
	if (_tmp31_.green > 0.8) {
#line 3165 "Printer.c"
		GdkRGBA _tmp32_;
#line 628 "../src/Objects/Printer.vala"
		_tmp32_ = col_b;
#line 628 "../src/Objects/Printer.vala"
		_tmp30_ = _tmp32_.blue < 0.3;
#line 3171 "Printer.c"
	} else {
#line 628 "../src/Objects/Printer.vala"
		_tmp30_ = FALSE;
#line 3175 "Printer.c"
	}
#line 628 "../src/Objects/Printer.vala"
	if (_tmp30_) {
#line 3179 "Printer.c"
		GdkRGBA _tmp33_;
#line 628 "../src/Objects/Printer.vala"
		_tmp33_ = col_b;
#line 628 "../src/Objects/Printer.vala"
		_tmp29_ = _tmp33_.red > 0.8;
#line 3185 "Printer.c"
	} else {
#line 628 "../src/Objects/Printer.vala"
		_tmp29_ = FALSE;
#line 3189 "Printer.c"
	}
#line 628 "../src/Objects/Printer.vala"
	if (_tmp29_) {
#line 629 "../src/Objects/Printer.vala"
		result = 1;
#line 629 "../src/Objects/Printer.vala"
		return result;
#line 3197 "Printer.c"
	}
#line 631 "../src/Objects/Printer.vala"
	_tmp34_ = col_a;
#line 631 "../src/Objects/Printer.vala"
	_tmp35_ = col_a;
#line 631 "../src/Objects/Printer.vala"
	_tmp36_ = col_a;
#line 631 "../src/Objects/Printer.vala"
	a_tot = (_tmp34_.green + _tmp35_.blue) + _tmp36_.red;
#line 632 "../src/Objects/Printer.vala"
	_tmp37_ = col_b;
#line 632 "../src/Objects/Printer.vala"
	_tmp38_ = col_b;
#line 632 "../src/Objects/Printer.vala"
	_tmp39_ = col_b;
#line 632 "../src/Objects/Printer.vala"
	b_tot = (_tmp37_.green + _tmp38_.blue) + _tmp39_.red;
#line 633 "../src/Objects/Printer.vala"
	if (a_tot > b_tot) {
#line 634 "../src/Objects/Printer.vala"
		result = 1;
#line 634 "../src/Objects/Printer.vala"
		return result;
#line 3221 "Printer.c"
	} else {
#line 635 "../src/Objects/Printer.vala"
		if (a_tot == b_tot) {
#line 636 "../src/Objects/Printer.vala"
			result = 0;
#line 636 "../src/Objects/Printer.vala"
			return result;
#line 3229 "Printer.c"
		} else {
#line 638 "../src/Objects/Printer.vala"
			result = -1;
#line 638 "../src/Objects/Printer.vala"
			return result;
#line 3235 "Printer.c"
		}
	}
}

static gint
___lambda5__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda5_ ((PrintersPrinter*) self, (PrintersPrinterColorLevel*) a, (PrintersPrinterColorLevel*) b);
#line 608 "../src/Objects/Printer.vala"
	return result;
#line 3249 "Printer.c"
}

GeeArrayList*
printers_printer_get_color_levels (PrintersPrinter* self)
{
	gchar* printer_uri = NULL;
	gchar* _tmp0_;
	gint printer_uri_length1;
	gint _printer_uri_size_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	cups_dest_t _tmp2_;
	const gchar* _tmp3_;
	ipp_t* request = NULL;
	ipp_t* _tmp4_;
	ipp_t* _tmp5_;
	gchar* _tmp6_;
	gint _tmp6__length1;
#line 560 "../src/Objects/Printer.vala"
	static const gchar* ATTRIBUTES[5] = {"marker-colors", "marker-levels", "marker-names", "marker-high-levels", "marker-low-levels"};
#line 3270 "Printer.c"
	ipp_t* _tmp7_;
	http_t* _tmp8_;
	GeeArrayList* found_colors = NULL;
	GeeArrayList* _tmp9_;
	ipp_status_t status_code = 0;
	ipp_t* _tmp10_;
	GeeArrayList* _tmp65_;
	GeeArrayList* result;
#line 554 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 555 "../src/Objects/Printer.vala"
	_tmp0_ = g_new0 (gchar, HTTP_MAX_URI);
#line 555 "../src/Objects/Printer.vala"
	printer_uri = _tmp0_;
#line 555 "../src/Objects/Printer.vala"
	printer_uri_length1 = HTTP_MAX_URI;
#line 555 "../src/Objects/Printer.vala"
	_printer_uri_size_ = printer_uri_length1;
#line 556 "../src/Objects/Printer.vala"
	_tmp1_ = printer_uri;
#line 556 "../src/Objects/Printer.vala"
	_tmp1__length1 = printer_uri_length1;
#line 556 "../src/Objects/Printer.vala"
	_tmp2_ = self->dest;
#line 556 "../src/Objects/Printer.vala"
	_tmp3_ = _tmp2_.name;
#line 556 "../src/Objects/Printer.vala"
	httpAssembleURIf (HTTP_URI_CODING_QUERY, _tmp1_, (gint) _tmp1__length1, "ipp", NULL, "localhost", 0, "/printers/%s", _tmp3_);
#line 557 "../src/Objects/Printer.vala"
	_tmp4_ = ippNewRequest (IPP_GET_PRINTER_ATTRIBUTES);
#line 557 "../src/Objects/Printer.vala"
	request = _tmp4_;
#line 558 "../src/Objects/Printer.vala"
	_tmp5_ = request;
#line 558 "../src/Objects/Printer.vala"
	_tmp6_ = printer_uri;
#line 558 "../src/Objects/Printer.vala"
	_tmp6__length1 = printer_uri_length1;
#line 558 "../src/Objects/Printer.vala"
	ippAddString (_tmp5_, IPP_TAG_OPERATION, IPP_TAG_URI, "printer-uri", NULL, (const gchar*) _tmp6_);
#line 566 "../src/Objects/Printer.vala"
	_tmp7_ = request;
#line 566 "../src/Objects/Printer.vala"
	ippAddStrings (_tmp7_, IPP_TAG_OPERATION, IPP_TAG_KEYWORD, "requested-attributes", (gint) G_N_ELEMENTS (ATTRIBUTES), NULL, ATTRIBUTES);
#line 567 "../src/Objects/Printer.vala"
	_tmp8_ = CUPS_HTTP_DEFAULT;
#line 567 "../src/Objects/Printer.vala"
	request = cupsDoRequest (_tmp8_, request, "/");
#line 569 "../src/Objects/Printer.vala"
	_tmp9_ = gee_array_list_new (PRINTERS_PRINTER_TYPE_COLOR_LEVEL, (GBoxedCopyFunc) printers_printer_color_level_ref, (GDestroyNotify) printers_printer_color_level_unref, NULL, NULL, NULL);
#line 569 "../src/Objects/Printer.vala"
	found_colors = _tmp9_;
#line 570 "../src/Objects/Printer.vala"
	_tmp10_ = request;
#line 570 "../src/Objects/Printer.vala"
	status_code = ippGetStatusCode (_tmp10_);
#line 571 "../src/Objects/Printer.vala"
	if (status_code <= IPP_OK_CONFLICT) {
#line 3329 "Printer.c"
		ipp_attribute_t* attr = NULL;
		ipp_t* _tmp11_;
		ipp_attribute_t* _tmp12_;
		gint color_size = 0;
		GeeArrayList* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		ipp_t* _tmp26_;
		ipp_attribute_t* _tmp27_;
		gint bound = 0;
		ipp_attribute_t* _tmp28_;
		ipp_t* _tmp35_;
		ipp_attribute_t* _tmp36_;
		ipp_attribute_t* _tmp37_;
		ipp_t* _tmp44_;
		ipp_attribute_t* _tmp45_;
		ipp_attribute_t* _tmp46_;
		ipp_t* _tmp53_;
		ipp_attribute_t* _tmp54_;
		ipp_attribute_t* _tmp55_;
#line 572 "../src/Objects/Printer.vala"
		_tmp11_ = request;
#line 572 "../src/Objects/Printer.vala"
		_tmp12_ = ippFindAttribute (_tmp11_, "marker-colors", IPP_TAG_ZERO);
#line 572 "../src/Objects/Printer.vala"
		attr = _tmp12_;
#line 3356 "Printer.c"
		{
			gint i = 0;
#line 573 "../src/Objects/Printer.vala"
			i = 0;
#line 3361 "Printer.c"
			{
				gboolean _tmp13_ = FALSE;
#line 573 "../src/Objects/Printer.vala"
				_tmp13_ = TRUE;
#line 573 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 3368 "Printer.c"
					ipp_attribute_t* _tmp15_;
					PrintersPrinterColorLevel* color = NULL;
					PrintersPrinterColorLevel* _tmp16_;
					PrintersPrinterColorLevel* _tmp17_;
					ipp_attribute_t* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
					GeeArrayList* _tmp21_;
					PrintersPrinterColorLevel* _tmp22_;
#line 573 "../src/Objects/Printer.vala"
					if (!_tmp13_) {
#line 3380 "Printer.c"
						gint _tmp14_;
#line 573 "../src/Objects/Printer.vala"
						_tmp14_ = i;
#line 573 "../src/Objects/Printer.vala"
						i = _tmp14_ + 1;
#line 3386 "Printer.c"
					}
#line 573 "../src/Objects/Printer.vala"
					_tmp13_ = FALSE;
#line 573 "../src/Objects/Printer.vala"
					_tmp15_ = attr;
#line 573 "../src/Objects/Printer.vala"
					if (!(i < ippGetCount (_tmp15_))) {
#line 573 "../src/Objects/Printer.vala"
						break;
#line 3396 "Printer.c"
					}
#line 574 "../src/Objects/Printer.vala"
					_tmp16_ = printers_printer_color_level_new ();
#line 574 "../src/Objects/Printer.vala"
					color = _tmp16_;
#line 575 "../src/Objects/Printer.vala"
					_tmp17_ = color;
#line 575 "../src/Objects/Printer.vala"
					_tmp18_ = attr;
#line 575 "../src/Objects/Printer.vala"
					_tmp19_ = ippGetString (_tmp18_, i, NULL);
#line 575 "../src/Objects/Printer.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 575 "../src/Objects/Printer.vala"
					_g_free0 (_tmp17_->color);
#line 575 "../src/Objects/Printer.vala"
					_tmp17_->color = _tmp20_;
#line 576 "../src/Objects/Printer.vala"
					_tmp21_ = found_colors;
#line 576 "../src/Objects/Printer.vala"
					_tmp22_ = color;
#line 576 "../src/Objects/Printer.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
#line 573 "../src/Objects/Printer.vala"
					_printers_printer_color_level_unref0 (color);
#line 3422 "Printer.c"
				}
			}
		}
#line 579 "../src/Objects/Printer.vala"
		_tmp23_ = found_colors;
#line 579 "../src/Objects/Printer.vala"
		_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
#line 579 "../src/Objects/Printer.vala"
		_tmp25_ = _tmp24_;
#line 579 "../src/Objects/Printer.vala"
		color_size = _tmp25_;
#line 581 "../src/Objects/Printer.vala"
		_tmp26_ = request;
#line 581 "../src/Objects/Printer.vala"
		_tmp27_ = ippFindAttribute (_tmp26_, "marker-levels", IPP_TAG_ZERO);
#line 581 "../src/Objects/Printer.vala"
		attr = _tmp27_;
#line 582 "../src/Objects/Printer.vala"
		_tmp28_ = attr;
#line 582 "../src/Objects/Printer.vala"
		bound = MIN (ippGetCount (_tmp28_), color_size);
#line 3444 "Printer.c"
		{
			gint i = 0;
#line 583 "../src/Objects/Printer.vala"
			i = 0;
#line 3449 "Printer.c"
			{
				gboolean _tmp29_ = FALSE;
#line 583 "../src/Objects/Printer.vala"
				_tmp29_ = TRUE;
#line 583 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 3456 "Printer.c"
					GeeArrayList* _tmp31_;
					gpointer _tmp32_;
					PrintersPrinterColorLevel* _tmp33_;
					ipp_attribute_t* _tmp34_;
#line 583 "../src/Objects/Printer.vala"
					if (!_tmp29_) {
#line 3463 "Printer.c"
						gint _tmp30_;
#line 583 "../src/Objects/Printer.vala"
						_tmp30_ = i;
#line 583 "../src/Objects/Printer.vala"
						i = _tmp30_ + 1;
#line 3469 "Printer.c"
					}
#line 583 "../src/Objects/Printer.vala"
					_tmp29_ = FALSE;
#line 583 "../src/Objects/Printer.vala"
					if (!(i < bound)) {
#line 583 "../src/Objects/Printer.vala"
						break;
#line 3477 "Printer.c"
					}
#line 584 "../src/Objects/Printer.vala"
					_tmp31_ = found_colors;
#line 584 "../src/Objects/Printer.vala"
					_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, i);
#line 584 "../src/Objects/Printer.vala"
					_tmp33_ = (PrintersPrinterColorLevel*) _tmp32_;
#line 584 "../src/Objects/Printer.vala"
					_tmp34_ = attr;
#line 584 "../src/Objects/Printer.vala"
					_tmp33_->level = ippGetInteger (_tmp34_, i);
#line 584 "../src/Objects/Printer.vala"
					_printers_printer_color_level_unref0 (_tmp33_);
#line 3491 "Printer.c"
				}
			}
		}
#line 587 "../src/Objects/Printer.vala"
		_tmp35_ = request;
#line 587 "../src/Objects/Printer.vala"
		_tmp36_ = ippFindAttribute (_tmp35_, "marker-high-levels", IPP_TAG_ZERO);
#line 587 "../src/Objects/Printer.vala"
		attr = _tmp36_;
#line 588 "../src/Objects/Printer.vala"
		_tmp37_ = attr;
#line 588 "../src/Objects/Printer.vala"
		bound = MIN (ippGetCount (_tmp37_), color_size);
#line 3505 "Printer.c"
		{
			gint i = 0;
#line 589 "../src/Objects/Printer.vala"
			i = 0;
#line 3510 "Printer.c"
			{
				gboolean _tmp38_ = FALSE;
#line 589 "../src/Objects/Printer.vala"
				_tmp38_ = TRUE;
#line 589 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 3517 "Printer.c"
					GeeArrayList* _tmp40_;
					gpointer _tmp41_;
					PrintersPrinterColorLevel* _tmp42_;
					ipp_attribute_t* _tmp43_;
#line 589 "../src/Objects/Printer.vala"
					if (!_tmp38_) {
#line 3524 "Printer.c"
						gint _tmp39_;
#line 589 "../src/Objects/Printer.vala"
						_tmp39_ = i;
#line 589 "../src/Objects/Printer.vala"
						i = _tmp39_ + 1;
#line 3530 "Printer.c"
					}
#line 589 "../src/Objects/Printer.vala"
					_tmp38_ = FALSE;
#line 589 "../src/Objects/Printer.vala"
					if (!(i < bound)) {
#line 589 "../src/Objects/Printer.vala"
						break;
#line 3538 "Printer.c"
					}
#line 590 "../src/Objects/Printer.vala"
					_tmp40_ = found_colors;
#line 590 "../src/Objects/Printer.vala"
					_tmp41_ = gee_abstract_list_get ((GeeAbstractList*) _tmp40_, i);
#line 590 "../src/Objects/Printer.vala"
					_tmp42_ = (PrintersPrinterColorLevel*) _tmp41_;
#line 590 "../src/Objects/Printer.vala"
					_tmp43_ = attr;
#line 590 "../src/Objects/Printer.vala"
					_tmp42_->level_max = ippGetInteger (_tmp43_, i);
#line 590 "../src/Objects/Printer.vala"
					_printers_printer_color_level_unref0 (_tmp42_);
#line 3552 "Printer.c"
				}
			}
		}
#line 593 "../src/Objects/Printer.vala"
		_tmp44_ = request;
#line 593 "../src/Objects/Printer.vala"
		_tmp45_ = ippFindAttribute (_tmp44_, "marker-low-levels", IPP_TAG_ZERO);
#line 593 "../src/Objects/Printer.vala"
		attr = _tmp45_;
#line 594 "../src/Objects/Printer.vala"
		_tmp46_ = attr;
#line 594 "../src/Objects/Printer.vala"
		bound = MIN (ippGetCount (_tmp46_), color_size);
#line 3566 "Printer.c"
		{
			gint i = 0;
#line 595 "../src/Objects/Printer.vala"
			i = 0;
#line 3571 "Printer.c"
			{
				gboolean _tmp47_ = FALSE;
#line 595 "../src/Objects/Printer.vala"
				_tmp47_ = TRUE;
#line 595 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 3578 "Printer.c"
					GeeArrayList* _tmp49_;
					gpointer _tmp50_;
					PrintersPrinterColorLevel* _tmp51_;
					ipp_attribute_t* _tmp52_;
#line 595 "../src/Objects/Printer.vala"
					if (!_tmp47_) {
#line 3585 "Printer.c"
						gint _tmp48_;
#line 595 "../src/Objects/Printer.vala"
						_tmp48_ = i;
#line 595 "../src/Objects/Printer.vala"
						i = _tmp48_ + 1;
#line 3591 "Printer.c"
					}
#line 595 "../src/Objects/Printer.vala"
					_tmp47_ = FALSE;
#line 595 "../src/Objects/Printer.vala"
					if (!(i < bound)) {
#line 595 "../src/Objects/Printer.vala"
						break;
#line 3599 "Printer.c"
					}
#line 596 "../src/Objects/Printer.vala"
					_tmp49_ = found_colors;
#line 596 "../src/Objects/Printer.vala"
					_tmp50_ = gee_abstract_list_get ((GeeAbstractList*) _tmp49_, i);
#line 596 "../src/Objects/Printer.vala"
					_tmp51_ = (PrintersPrinterColorLevel*) _tmp50_;
#line 596 "../src/Objects/Printer.vala"
					_tmp52_ = attr;
#line 596 "../src/Objects/Printer.vala"
					_tmp51_->level_min = ippGetInteger (_tmp52_, i);
#line 596 "../src/Objects/Printer.vala"
					_printers_printer_color_level_unref0 (_tmp51_);
#line 3613 "Printer.c"
				}
			}
		}
#line 599 "../src/Objects/Printer.vala"
		_tmp53_ = request;
#line 599 "../src/Objects/Printer.vala"
		_tmp54_ = ippFindAttribute (_tmp53_, "marker-names", IPP_TAG_ZERO);
#line 599 "../src/Objects/Printer.vala"
		attr = _tmp54_;
#line 600 "../src/Objects/Printer.vala"
		_tmp55_ = attr;
#line 600 "../src/Objects/Printer.vala"
		bound = MIN (ippGetCount (_tmp55_), color_size);
#line 3627 "Printer.c"
		{
			gint i = 0;
#line 601 "../src/Objects/Printer.vala"
			i = 0;
#line 3632 "Printer.c"
			{
				gboolean _tmp56_ = FALSE;
#line 601 "../src/Objects/Printer.vala"
				_tmp56_ = TRUE;
#line 601 "../src/Objects/Printer.vala"
				while (TRUE) {
#line 3639 "Printer.c"
					GeeArrayList* _tmp58_;
					gpointer _tmp59_;
					PrintersPrinterColorLevel* _tmp60_;
					ipp_attribute_t* _tmp61_;
					const gchar* _tmp62_;
					gchar* _tmp63_;
#line 601 "../src/Objects/Printer.vala"
					if (!_tmp56_) {
#line 3648 "Printer.c"
						gint _tmp57_;
#line 601 "../src/Objects/Printer.vala"
						_tmp57_ = i;
#line 601 "../src/Objects/Printer.vala"
						i = _tmp57_ + 1;
#line 3654 "Printer.c"
					}
#line 601 "../src/Objects/Printer.vala"
					_tmp56_ = FALSE;
#line 601 "../src/Objects/Printer.vala"
					if (!(i < bound)) {
#line 601 "../src/Objects/Printer.vala"
						break;
#line 3662 "Printer.c"
					}
#line 602 "../src/Objects/Printer.vala"
					_tmp58_ = found_colors;
#line 602 "../src/Objects/Printer.vala"
					_tmp59_ = gee_abstract_list_get ((GeeAbstractList*) _tmp58_, i);
#line 602 "../src/Objects/Printer.vala"
					_tmp60_ = (PrintersPrinterColorLevel*) _tmp59_;
#line 602 "../src/Objects/Printer.vala"
					_tmp61_ = attr;
#line 602 "../src/Objects/Printer.vala"
					_tmp62_ = ippGetString (_tmp61_, i, NULL);
#line 602 "../src/Objects/Printer.vala"
					_tmp63_ = g_strdup (_tmp62_);
#line 602 "../src/Objects/Printer.vala"
					_g_free0 (_tmp60_->name);
#line 602 "../src/Objects/Printer.vala"
					_tmp60_->name = _tmp63_;
#line 602 "../src/Objects/Printer.vala"
					_printers_printer_color_level_unref0 (_tmp60_);
#line 3682 "Printer.c"
				}
			}
		}
	} else {
		const gchar* _tmp64_;
#line 605 "../src/Objects/Printer.vala"
		_tmp64_ = ippErrorString (status_code);
#line 605 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:605: Error: %s", _tmp64_);
#line 3692 "Printer.c"
	}
#line 608 "../src/Objects/Printer.vala"
	_tmp65_ = found_colors;
#line 608 "../src/Objects/Printer.vala"
	gee_list_sort ((GeeList*) _tmp65_, ___lambda5__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 642 "../src/Objects/Printer.vala"
	result = found_colors;
#line 642 "../src/Objects/Printer.vala"
	_ippDelete0 (request);
#line 642 "../src/Objects/Printer.vala"
	printer_uri = (g_free (printer_uri), NULL);
#line 642 "../src/Objects/Printer.vala"
	return result;
#line 3706 "Printer.c"
}

gboolean
printers_printer_get_is_enabled (PrintersPrinter* self)
{
	gboolean result;
	const gchar* _tmp0_;
#line 97 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "../src/Objects/Printer.vala"
	_tmp0_ = self->priv->_state;
#line 98 "../src/Objects/Printer.vala"
	result = g_strcmp0 (_tmp0_, "5") != 0;
#line 98 "../src/Objects/Printer.vala"
	return result;
#line 3722 "Printer.c"
}

void
printers_printer_set_is_enabled (PrintersPrinter* self,
                                 gboolean value)
{
	const gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 101 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/Objects/Printer.vala"
	_tmp0_ = self->priv->_state;
#line 102 "../src/Objects/Printer.vala"
	if (value == (g_strcmp0 (_tmp0_, "5") == 0)) {
#line 3737 "Printer.c"
		{
			CupsPkHelper* _tmp1_;
			cups_dest_t _tmp2_;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 104 "../src/Objects/Printer.vala"
			_tmp1_ = cups_get_pk_helper ();
#line 104 "../src/Objects/Printer.vala"
			_tmp2_ = self->dest;
#line 104 "../src/Objects/Printer.vala"
			_tmp3_ = _tmp2_.name;
#line 104 "../src/Objects/Printer.vala"
			_tmp4_ = cups_pk_helper_printer_set_enabled (_tmp1_, _tmp3_, value, &_inner_error0_);
#line 104 "../src/Objects/Printer.vala"
			_tmp5_ = _tmp4_;
#line 104 "../src/Objects/Printer.vala"
			_g_free0 (_tmp5_);
#line 104 "../src/Objects/Printer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3758 "Printer.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 103 "../src/Objects/Printer.vala"
			e = _inner_error0_;
#line 103 "../src/Objects/Printer.vala"
			_inner_error0_ = NULL;
#line 107 "../src/Objects/Printer.vala"
			_tmp6_ = e;
#line 107 "../src/Objects/Printer.vala"
			_tmp7_ = _tmp6_->message;
#line 107 "../src/Objects/Printer.vala"
			g_critical ("Printer.vala:107: %s", _tmp7_);
#line 103 "../src/Objects/Printer.vala"
			_g_error_free0 (e);
#line 3780 "Printer.c"
		}
		__finally0:
#line 103 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 103 "../src/Objects/Printer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 103 "../src/Objects/Printer.vala"
			g_clear_error (&_inner_error0_);
#line 103 "../src/Objects/Printer.vala"
			return;
#line 3791 "Printer.c"
		}
		{
			CupsPkHelper* _tmp8_;
			cups_dest_t _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 111 "../src/Objects/Printer.vala"
			_tmp8_ = cups_get_pk_helper ();
#line 111 "../src/Objects/Printer.vala"
			_tmp9_ = self->dest;
#line 111 "../src/Objects/Printer.vala"
			_tmp10_ = _tmp9_.name;
#line 111 "../src/Objects/Printer.vala"
			_tmp11_ = cups_pk_helper_printer_set_accept_jobs (_tmp8_, _tmp10_, value, "", &_inner_error0_);
#line 111 "../src/Objects/Printer.vala"
			_tmp12_ = _tmp11_;
#line 111 "../src/Objects/Printer.vala"
			_g_free0 (_tmp12_);
#line 111 "../src/Objects/Printer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3813 "Printer.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 110 "../src/Objects/Printer.vala"
			e = _inner_error0_;
#line 110 "../src/Objects/Printer.vala"
			_inner_error0_ = NULL;
#line 113 "../src/Objects/Printer.vala"
			_tmp13_ = e;
#line 113 "../src/Objects/Printer.vala"
			_tmp14_ = _tmp13_->message;
#line 113 "../src/Objects/Printer.vala"
			g_critical ("Printer.vala:113: %s", _tmp14_);
#line 110 "../src/Objects/Printer.vala"
			_g_error_free0 (e);
#line 3835 "Printer.c"
		}
		__finally1:
#line 110 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 110 "../src/Objects/Printer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 110 "../src/Objects/Printer.vala"
			g_clear_error (&_inner_error0_);
#line 110 "../src/Objects/Printer.vala"
			return;
#line 3846 "Printer.c"
		}
	}
#line 101 "../src/Objects/Printer.vala"
	g_object_notify_by_pspec ((GObject *) self, printers_printer_properties[PRINTERS_PRINTER_IS_ENABLED_PROPERTY]);
#line 3851 "Printer.c"
}

static gboolean
cups_destination_get_is_default (cups_dest_t* self)
{
	gboolean result;
#line 112 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 113 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	result = (*self).is_default == 1;
#line 113 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	return result;
#line 3864 "Printer.c"
}

static void
cups_destination_set_is_default (cups_dest_t* self,
                                 gboolean value)
{
	gint _tmp0_ = 0;
#line 115 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	g_return_if_fail (self != NULL);
#line 116 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	if (value) {
#line 116 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
		_tmp0_ = 1;
#line 3878 "Printer.c"
	} else {
#line 116 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
		_tmp0_ = 0;
#line 3882 "Printer.c"
	}
#line 116 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	(*self).is_default = _tmp0_;
#line 3886 "Printer.c"
}

gboolean
printers_printer_get_is_default (PrintersPrinter* self)
{
	gboolean result;
	cups_dest_t _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 120 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 121 "../src/Objects/Printer.vala"
	_tmp0_ = self->dest;
#line 121 "../src/Objects/Printer.vala"
	_tmp1_ = cups_destination_get_is_default (&_tmp0_);
#line 121 "../src/Objects/Printer.vala"
	_tmp2_ = _tmp1_;
#line 121 "../src/Objects/Printer.vala"
	result = _tmp2_;
#line 121 "../src/Objects/Printer.vala"
	return result;
#line 3908 "Printer.c"
}

void
printers_printer_set_is_default (PrintersPrinter* self,
                                 gboolean value)
{
	GError* _inner_error0_ = NULL;
#line 124 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/Objects/Printer.vala"
	if (value == TRUE) {
#line 3920 "Printer.c"
		{
			CupsPkHelper* _tmp0_;
			cups_dest_t _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 127 "../src/Objects/Printer.vala"
			_tmp0_ = cups_get_pk_helper ();
#line 127 "../src/Objects/Printer.vala"
			_tmp1_ = self->dest;
#line 127 "../src/Objects/Printer.vala"
			_tmp2_ = _tmp1_.name;
#line 127 "../src/Objects/Printer.vala"
			_tmp3_ = cups_pk_helper_printer_set_default (_tmp0_, _tmp2_, &_inner_error0_);
#line 127 "../src/Objects/Printer.vala"
			_tmp4_ = _tmp3_;
#line 127 "../src/Objects/Printer.vala"
			_g_free0 (_tmp4_);
#line 127 "../src/Objects/Printer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3941 "Printer.c"
				goto __catch0_g_error;
			}
#line 128 "../src/Objects/Printer.vala"
			g_signal_emit (self, printers_printer_signals[PRINTERS_PRINTER_DEFAULT_CHANGED_SIGNAL], 0);
#line 3946 "Printer.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp5_;
			const gchar* _tmp6_;
#line 126 "../src/Objects/Printer.vala"
			e = _inner_error0_;
#line 126 "../src/Objects/Printer.vala"
			_inner_error0_ = NULL;
#line 130 "../src/Objects/Printer.vala"
			_tmp5_ = e;
#line 130 "../src/Objects/Printer.vala"
			_tmp6_ = _tmp5_->message;
#line 130 "../src/Objects/Printer.vala"
			g_critical ("Printer.vala:130: %s", _tmp6_);
#line 126 "../src/Objects/Printer.vala"
			_g_error_free0 (e);
#line 3966 "Printer.c"
		}
		__finally0:
#line 126 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 126 "../src/Objects/Printer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 126 "../src/Objects/Printer.vala"
			g_clear_error (&_inner_error0_);
#line 126 "../src/Objects/Printer.vala"
			return;
#line 3977 "Printer.c"
		}
	}
#line 124 "../src/Objects/Printer.vala"
	g_object_notify_by_pspec ((GObject *) self, printers_printer_properties[PRINTERS_PRINTER_IS_DEFAULT_PROPERTY]);
#line 3982 "Printer.c"
}

const gchar*
printers_printer_get_auth_info_required (PrintersPrinter* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	cups_dest_t _tmp1_;
	cups_option_t* _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
#line 141 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../src/Objects/Printer.vala"
	_tmp1_ = self->dest;
#line 142 "../src/Objects/Printer.vala"
	_tmp2_ = _tmp1_.options;
#line 142 "../src/Objects/Printer.vala"
	_tmp2__length1 = _tmp1_.num_options;
#line 142 "../src/Objects/Printer.vala"
	_tmp3_ = cupsGetOption ("auth-info-required", (gint) _tmp2__length1, _tmp2_);
#line 142 "../src/Objects/Printer.vala"
	_tmp0_ = _tmp3_;
#line 142 "../src/Objects/Printer.vala"
	if (_tmp0_ == NULL) {
#line 142 "../src/Objects/Printer.vala"
		_tmp0_ = "none";
#line 4010 "Printer.c"
	}
#line 142 "../src/Objects/Printer.vala"
	result = _tmp0_;
#line 142 "../src/Objects/Printer.vala"
	return result;
#line 4016 "Printer.c"
}

const gchar*
printers_printer_get_info (PrintersPrinter* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	cups_dest_t _tmp1_;
	cups_option_t* _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
#line 150 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "../src/Objects/Printer.vala"
	_tmp1_ = self->dest;
#line 151 "../src/Objects/Printer.vala"
	_tmp2_ = _tmp1_.options;
#line 151 "../src/Objects/Printer.vala"
	_tmp2__length1 = _tmp1_.num_options;
#line 151 "../src/Objects/Printer.vala"
	_tmp3_ = cupsGetOption ("printer-info", (gint) _tmp2__length1, _tmp2_);
#line 151 "../src/Objects/Printer.vala"
	_tmp0_ = _tmp3_;
#line 151 "../src/Objects/Printer.vala"
	if (_tmp0_ == NULL) {
#line 151 "../src/Objects/Printer.vala"
		_tmp0_ = _ ("Unnamed Printer");
#line 4044 "Printer.c"
	}
#line 151 "../src/Objects/Printer.vala"
	result = _tmp0_;
#line 151 "../src/Objects/Printer.vala"
	return result;
#line 4050 "Printer.c"
}

void
printers_printer_set_info (PrintersPrinter* self,
                           const gchar* value)
{
	GError* _inner_error0_ = NULL;
#line 153 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 4060 "Printer.c"
	{
		CupsPkHelper* _tmp0_;
		cups_dest_t _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		cups_dest_t _tmp5_;
		cups_option_t* _tmp6_;
		gint _tmp6__length1;
		gint _tmp7_;
#line 155 "../src/Objects/Printer.vala"
		_tmp0_ = cups_get_pk_helper ();
#line 155 "../src/Objects/Printer.vala"
		_tmp1_ = self->dest;
#line 155 "../src/Objects/Printer.vala"
		_tmp2_ = _tmp1_.name;
#line 155 "../src/Objects/Printer.vala"
		_tmp3_ = cups_pk_helper_printer_set_info (_tmp0_, _tmp2_, value, &_inner_error0_);
#line 155 "../src/Objects/Printer.vala"
		_tmp4_ = _tmp3_;
#line 155 "../src/Objects/Printer.vala"
		_g_free0 (_tmp4_);
#line 155 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4085 "Printer.c"
			goto __catch0_g_error;
		}
#line 156 "../src/Objects/Printer.vala"
		_tmp5_ = self->dest;
#line 156 "../src/Objects/Printer.vala"
		_tmp6_ = _tmp5_.options;
#line 156 "../src/Objects/Printer.vala"
		_tmp6__length1 = _tmp5_.num_options;
#line 156 "../src/Objects/Printer.vala"
		_tmp7_ = cupsAddOption ("printer-info", value, _tmp6__length1, &self->dest.options);
#line 156 "../src/Objects/Printer.vala"
		self->dest.num_options = _tmp7_;
#line 4098 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 154 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 154 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 158 "../src/Objects/Printer.vala"
		_tmp8_ = e;
#line 158 "../src/Objects/Printer.vala"
		_tmp9_ = _tmp8_->message;
#line 158 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:158: %s", _tmp9_);
#line 154 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 4118 "Printer.c"
	}
	__finally0:
#line 154 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 154 "../src/Objects/Printer.vala"
		return;
#line 4129 "Printer.c"
	}
#line 153 "../src/Objects/Printer.vala"
	g_object_notify_by_pspec ((GObject *) self, printers_printer_properties[PRINTERS_PRINTER_INFO_PROPERTY]);
#line 4133 "Printer.c"
}

gboolean
printers_printer_get_is_accepting_jobs (PrintersPrinter* self)
{
	gboolean result;
#line 164 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 164 "../src/Objects/Printer.vala"
	result = self->priv->_is_accepting_jobs;
#line 164 "../src/Objects/Printer.vala"
	return result;
#line 4146 "Printer.c"
}

void
printers_printer_set_is_accepting_jobs (PrintersPrinter* self,
                                        gboolean value)
{
	gboolean old_value;
#line 164 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/Objects/Printer.vala"
	old_value = printers_printer_get_is_accepting_jobs (self);
#line 164 "../src/Objects/Printer.vala"
	if (old_value != value) {
#line 164 "../src/Objects/Printer.vala"
		self->priv->_is_accepting_jobs = value;
#line 164 "../src/Objects/Printer.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_printer_properties[PRINTERS_PRINTER_IS_ACCEPTING_JOBS_PROPERTY]);
#line 4164 "Printer.c"
	}
}

const gchar*
printers_printer_get_state (PrintersPrinter* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 167 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 167 "../src/Objects/Printer.vala"
	_tmp0_ = self->priv->_state;
#line 167 "../src/Objects/Printer.vala"
	result = _tmp0_;
#line 167 "../src/Objects/Printer.vala"
	return result;
#line 4181 "Printer.c"
}

void
printers_printer_set_state (PrintersPrinter* self,
                            const gchar* value)
{
	gchar* old_value;
#line 167 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/Objects/Printer.vala"
	old_value = printers_printer_get_state (self);
#line 167 "../src/Objects/Printer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4195 "Printer.c"
		gchar* _tmp0_;
#line 167 "../src/Objects/Printer.vala"
		_tmp0_ = g_strdup (value);
#line 167 "../src/Objects/Printer.vala"
		_g_free0 (self->priv->_state);
#line 167 "../src/Objects/Printer.vala"
		self->priv->_state = _tmp0_;
#line 167 "../src/Objects/Printer.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_printer_properties[PRINTERS_PRINTER_STATE_PROPERTY]);
#line 4205 "Printer.c"
	}
}

gboolean
printers_printer_get_is_shared (PrintersPrinter* self)
{
	gboolean result;
	const gchar* cups_result = NULL;
	cups_dest_t _tmp0_;
	cups_option_t* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 170 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/Objects/Printer.vala"
	_tmp0_ = self->dest;
#line 171 "../src/Objects/Printer.vala"
	_tmp1_ = _tmp0_.options;
#line 171 "../src/Objects/Printer.vala"
	_tmp1__length1 = _tmp0_.num_options;
#line 171 "../src/Objects/Printer.vala"
	_tmp2_ = cupsGetOption ("printer-is-shared", (gint) _tmp1__length1, _tmp1_);
#line 171 "../src/Objects/Printer.vala"
	cups_result = _tmp2_;
#line 172 "../src/Objects/Printer.vala"
	_tmp3_ = cups_result;
#line 172 "../src/Objects/Printer.vala"
	if (_tmp3_ == NULL) {
#line 173 "../src/Objects/Printer.vala"
		result = FALSE;
#line 173 "../src/Objects/Printer.vala"
		return result;
#line 4240 "Printer.c"
	}
#line 176 "../src/Objects/Printer.vala"
	_tmp4_ = cups_result;
#line 176 "../src/Objects/Printer.vala"
	result = bool_parse (_tmp4_);
#line 176 "../src/Objects/Printer.vala"
	return result;
#line 4248 "Printer.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 4257 "Printer.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 4265 "Printer.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 4274 "Printer.c"
	}
}

void
printers_printer_set_is_shared (PrintersPrinter* self,
                                gboolean value)
{
	GError* _inner_error0_ = NULL;
#line 178 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 4285 "Printer.c"
	{
		CupsPkHelper* _tmp0_;
		cups_dest_t _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		cups_dest_t _tmp7_;
		cups_option_t* _tmp8_;
		gint _tmp8__length1;
		gint _tmp9_;
#line 180 "../src/Objects/Printer.vala"
		_tmp0_ = cups_get_pk_helper ();
#line 180 "../src/Objects/Printer.vala"
		_tmp1_ = self->dest;
#line 180 "../src/Objects/Printer.vala"
		_tmp2_ = _tmp1_.name;
#line 180 "../src/Objects/Printer.vala"
		_tmp3_ = cups_pk_helper_printer_set_shared (_tmp0_, _tmp2_, value, &_inner_error0_);
#line 180 "../src/Objects/Printer.vala"
		_tmp4_ = _tmp3_;
#line 180 "../src/Objects/Printer.vala"
		_g_free0 (_tmp4_);
#line 180 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4312 "Printer.c"
			goto __catch0_g_error;
		}
#line 181 "../src/Objects/Printer.vala"
		_tmp5_ = bool_to_string (value);
#line 181 "../src/Objects/Printer.vala"
		_tmp6_ = _tmp5_;
#line 181 "../src/Objects/Printer.vala"
		_tmp7_ = self->dest;
#line 181 "../src/Objects/Printer.vala"
		_tmp8_ = _tmp7_.options;
#line 181 "../src/Objects/Printer.vala"
		_tmp8__length1 = _tmp7_.num_options;
#line 181 "../src/Objects/Printer.vala"
		_tmp9_ = cupsAddOption ("printer-is-shared", _tmp6_, _tmp8__length1, &self->dest.options);
#line 181 "../src/Objects/Printer.vala"
		self->dest.num_options = _tmp9_;
#line 181 "../src/Objects/Printer.vala"
		_g_free0 (_tmp6_);
#line 4331 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 179 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 179 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 183 "../src/Objects/Printer.vala"
		_tmp10_ = e;
#line 183 "../src/Objects/Printer.vala"
		_tmp11_ = _tmp10_->message;
#line 183 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:183: %s", _tmp11_);
#line 179 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 4351 "Printer.c"
	}
	__finally0:
#line 179 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 179 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 179 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 179 "../src/Objects/Printer.vala"
		return;
#line 4362 "Printer.c"
	}
#line 178 "../src/Objects/Printer.vala"
	g_object_notify_by_pspec ((GObject *) self, printers_printer_properties[PRINTERS_PRINTER_IS_SHARED_PROPERTY]);
#line 4366 "Printer.c"
}

const gchar*
printers_printer_get_location (PrintersPrinter* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	cups_dest_t _tmp1_;
	cups_option_t* _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
#line 192 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 193 "../src/Objects/Printer.vala"
	_tmp1_ = self->dest;
#line 193 "../src/Objects/Printer.vala"
	_tmp2_ = _tmp1_.options;
#line 193 "../src/Objects/Printer.vala"
	_tmp2__length1 = _tmp1_.num_options;
#line 193 "../src/Objects/Printer.vala"
	_tmp3_ = cupsGetOption ("printer-location", (gint) _tmp2__length1, _tmp2_);
#line 193 "../src/Objects/Printer.vala"
	_tmp0_ = _tmp3_;
#line 193 "../src/Objects/Printer.vala"
	if (_tmp0_ == NULL) {
#line 193 "../src/Objects/Printer.vala"
		_tmp0_ = "";
#line 4394 "Printer.c"
	}
#line 193 "../src/Objects/Printer.vala"
	result = _tmp0_;
#line 193 "../src/Objects/Printer.vala"
	return result;
#line 4400 "Printer.c"
}

void
printers_printer_set_location (PrintersPrinter* self,
                               const gchar* value)
{
	GError* _inner_error0_ = NULL;
#line 195 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 4410 "Printer.c"
	{
		CupsPkHelper* _tmp0_;
		cups_dest_t _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		cups_dest_t _tmp5_;
		cups_option_t* _tmp6_;
		gint _tmp6__length1;
		gint _tmp7_;
#line 197 "../src/Objects/Printer.vala"
		_tmp0_ = cups_get_pk_helper ();
#line 197 "../src/Objects/Printer.vala"
		_tmp1_ = self->dest;
#line 197 "../src/Objects/Printer.vala"
		_tmp2_ = _tmp1_.name;
#line 197 "../src/Objects/Printer.vala"
		_tmp3_ = cups_pk_helper_printer_set_location (_tmp0_, _tmp2_, value, &_inner_error0_);
#line 197 "../src/Objects/Printer.vala"
		_tmp4_ = _tmp3_;
#line 197 "../src/Objects/Printer.vala"
		_g_free0 (_tmp4_);
#line 197 "../src/Objects/Printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4435 "Printer.c"
			goto __catch0_g_error;
		}
#line 198 "../src/Objects/Printer.vala"
		_tmp5_ = self->dest;
#line 198 "../src/Objects/Printer.vala"
		_tmp6_ = _tmp5_.options;
#line 198 "../src/Objects/Printer.vala"
		_tmp6__length1 = _tmp5_.num_options;
#line 198 "../src/Objects/Printer.vala"
		_tmp7_ = cupsAddOption ("printer-location", value, _tmp6__length1, &self->dest.options);
#line 198 "../src/Objects/Printer.vala"
		self->dest.num_options = _tmp7_;
#line 4448 "Printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 196 "../src/Objects/Printer.vala"
		e = _inner_error0_;
#line 196 "../src/Objects/Printer.vala"
		_inner_error0_ = NULL;
#line 200 "../src/Objects/Printer.vala"
		_tmp8_ = e;
#line 200 "../src/Objects/Printer.vala"
		_tmp9_ = _tmp8_->message;
#line 200 "../src/Objects/Printer.vala"
		g_critical ("Printer.vala:200: %s", _tmp9_);
#line 196 "../src/Objects/Printer.vala"
		_g_error_free0 (e);
#line 4468 "Printer.c"
	}
	__finally0:
#line 196 "../src/Objects/Printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/Objects/Printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 196 "../src/Objects/Printer.vala"
		g_clear_error (&_inner_error0_);
#line 196 "../src/Objects/Printer.vala"
		return;
#line 4479 "Printer.c"
	}
#line 195 "../src/Objects/Printer.vala"
	g_object_notify_by_pspec ((GObject *) self, printers_printer_properties[PRINTERS_PRINTER_LOCATION_PROPERTY]);
#line 4483 "Printer.c"
}

const gchar*
printers_printer_get_make_and_model (PrintersPrinter* self)
{
	const gchar* result;
	cups_dest_t _tmp0_;
	cups_option_t* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
#line 209 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 210 "../src/Objects/Printer.vala"
	_tmp0_ = self->dest;
#line 210 "../src/Objects/Printer.vala"
	_tmp1_ = _tmp0_.options;
#line 210 "../src/Objects/Printer.vala"
	_tmp1__length1 = _tmp0_.num_options;
#line 210 "../src/Objects/Printer.vala"
	_tmp2_ = cupsGetOption ("printer-make-and-model", (gint) _tmp1__length1, _tmp1_);
#line 210 "../src/Objects/Printer.vala"
	result = _tmp2_;
#line 210 "../src/Objects/Printer.vala"
	return result;
#line 4508 "Printer.c"
}

const gchar*
printers_printer_get_state_reasons_raw (PrintersPrinter* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 217 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 217 "../src/Objects/Printer.vala"
	_tmp0_ = self->priv->_state_reasons_raw;
#line 217 "../src/Objects/Printer.vala"
	result = _tmp0_;
#line 217 "../src/Objects/Printer.vala"
	return result;
#line 4524 "Printer.c"
}

void
printers_printer_set_state_reasons_raw (PrintersPrinter* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 217 "../src/Objects/Printer.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/Objects/Printer.vala"
	old_value = printers_printer_get_state_reasons_raw (self);
#line 217 "../src/Objects/Printer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4538 "Printer.c"
		gchar* _tmp0_;
#line 217 "../src/Objects/Printer.vala"
		_tmp0_ = g_strdup (value);
#line 217 "../src/Objects/Printer.vala"
		_g_free0 (self->priv->_state_reasons_raw);
#line 217 "../src/Objects/Printer.vala"
		self->priv->_state_reasons_raw = _tmp0_;
#line 217 "../src/Objects/Printer.vala"
		g_object_notify_by_pspec ((GObject *) self, printers_printer_properties[PRINTERS_PRINTER_STATE_REASONS_RAW_PROPERTY]);
#line 4548 "Printer.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 4568 "Printer.c"
}

const gchar*
printers_printer_get_state_reasons (PrintersPrinter* self)
{
	const gchar* result;
	const gchar* reason = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp14_;
#line 221 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 222 "../src/Objects/Printer.vala"
	_tmp0_ = self->priv->_state_reasons_raw;
#line 222 "../src/Objects/Printer.vala"
	reason = _tmp0_;
#line 223 "../src/Objects/Printer.vala"
	_tmp2_ = reason;
#line 223 "../src/Objects/Printer.vala"
	if (_tmp2_ == NULL) {
#line 223 "../src/Objects/Printer.vala"
		_tmp1_ = TRUE;
#line 4592 "Printer.c"
	} else {
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 223 "../src/Objects/Printer.vala"
		_tmp3_ = reason;
#line 223 "../src/Objects/Printer.vala"
		_tmp4_ = g_utf8_strup (_tmp3_, (gssize) -1);
#line 223 "../src/Objects/Printer.vala"
		_tmp5_ = _tmp4_;
#line 223 "../src/Objects/Printer.vala"
		_tmp1_ = string_contains (_tmp5_, "NONE");
#line 223 "../src/Objects/Printer.vala"
		_g_free0 (_tmp5_);
#line 4607 "Printer.c"
	}
#line 223 "../src/Objects/Printer.vala"
	if (_tmp1_) {
#line 224 "../src/Objects/Printer.vala"
		result = _ ("Ready");
#line 224 "../src/Objects/Printer.vala"
		return result;
#line 4615 "Printer.c"
	}
	{
		gint i = 0;
#line 227 "../src/Objects/Printer.vala"
		i = 0;
#line 4621 "Printer.c"
		{
			gboolean _tmp6_ = FALSE;
#line 227 "../src/Objects/Printer.vala"
			_tmp6_ = TRUE;
#line 227 "../src/Objects/Printer.vala"
			while (TRUE) {
#line 4628 "Printer.c"
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
#line 227 "../src/Objects/Printer.vala"
				if (!_tmp6_) {
#line 4637 "Printer.c"
					gint _tmp7_;
#line 227 "../src/Objects/Printer.vala"
					_tmp7_ = i;
#line 227 "../src/Objects/Printer.vala"
					i = _tmp7_ + 1;
#line 4643 "Printer.c"
				}
#line 227 "../src/Objects/Printer.vala"
				_tmp6_ = FALSE;
#line 227 "../src/Objects/Printer.vala"
				_tmp8_ = printers_printer_reasons;
#line 227 "../src/Objects/Printer.vala"
				_tmp8__length1 = printers_printer_reasons_length1;
#line 227 "../src/Objects/Printer.vala"
				if (!(i < _tmp8__length1)) {
#line 227 "../src/Objects/Printer.vala"
					break;
#line 4655 "Printer.c"
				}
#line 228 "../src/Objects/Printer.vala"
				_tmp9_ = reason;
#line 228 "../src/Objects/Printer.vala"
				_tmp10_ = printers_printer_reasons;
#line 228 "../src/Objects/Printer.vala"
				_tmp10__length1 = printers_printer_reasons_length1;
#line 228 "../src/Objects/Printer.vala"
				_tmp11_ = _tmp10_[i];
#line 228 "../src/Objects/Printer.vala"
				if (string_contains (_tmp9_, _tmp11_)) {
#line 4667 "Printer.c"
					gchar** _tmp12_;
					gint _tmp12__length1;
					const gchar* _tmp13_;
#line 229 "../src/Objects/Printer.vala"
					_tmp12_ = printers_printer_statuses;
#line 229 "../src/Objects/Printer.vala"
					_tmp12__length1 = printers_printer_statuses_length1;
#line 229 "../src/Objects/Printer.vala"
					_tmp13_ = _tmp12_[i];
#line 229 "../src/Objects/Printer.vala"
					result = g_dpgettext2 (BUILD_GETTEXT_PACKAGE, "printer state", _tmp13_);
#line 229 "../src/Objects/Printer.vala"
					return result;
#line 4681 "Printer.c"
				}
			}
		}
	}
#line 233 "../src/Objects/Printer.vala"
	_tmp14_ = reason;
#line 233 "../src/Objects/Printer.vala"
	result = _tmp14_;
#line 233 "../src/Objects/Printer.vala"
	return result;
#line 4692 "Printer.c"
}

const gchar*
printers_printer_get_printer_type (PrintersPrinter* self)
{
	const gchar* result;
	cups_dest_t _tmp0_;
	cups_option_t* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
#line 241 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 242 "../src/Objects/Printer.vala"
	_tmp0_ = self->dest;
#line 242 "../src/Objects/Printer.vala"
	_tmp1_ = _tmp0_.options;
#line 242 "../src/Objects/Printer.vala"
	_tmp1__length1 = _tmp0_.num_options;
#line 242 "../src/Objects/Printer.vala"
	_tmp2_ = cupsGetOption ("printer-type", (gint) _tmp1__length1, _tmp1_);
#line 242 "../src/Objects/Printer.vala"
	result = _tmp2_;
#line 242 "../src/Objects/Printer.vala"
	return result;
#line 4717 "Printer.c"
}

gboolean
printers_printer_get_is_offline (PrintersPrinter* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 263 "../src/Objects/Printer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 264 "../src/Objects/Printer.vala"
	_tmp1_ = self->priv->_state_reasons_raw;
#line 264 "../src/Objects/Printer.vala"
	if (_tmp1_ != NULL) {
#line 4732 "Printer.c"
		const gchar* _tmp2_;
#line 264 "../src/Objects/Printer.vala"
		_tmp2_ = self->priv->_state_reasons_raw;
#line 264 "../src/Objects/Printer.vala"
		_tmp0_ = string_contains (_tmp2_, "offline");
#line 4738 "Printer.c"
	} else {
#line 264 "../src/Objects/Printer.vala"
		_tmp0_ = FALSE;
#line 4742 "Printer.c"
	}
#line 264 "../src/Objects/Printer.vala"
	result = _tmp0_;
#line 264 "../src/Objects/Printer.vala"
	return result;
#line 4748 "Printer.c"
}

PrintersPrinterColorLevel*
printers_printer_color_level_construct (GType object_type)
{
	PrintersPrinterColorLevel* self = NULL;
#line 78 "../src/Objects/Printer.vala"
	self = (PrintersPrinterColorLevel*) g_type_create_instance (object_type);
#line 78 "../src/Objects/Printer.vala"
	return self;
#line 4759 "Printer.c"
}

PrintersPrinterColorLevel*
printers_printer_color_level_new (void)
{
#line 78 "../src/Objects/Printer.vala"
	return printers_printer_color_level_construct (PRINTERS_PRINTER_TYPE_COLOR_LEVEL);
#line 4767 "Printer.c"
}

static void
printers_printer_value_color_level_init (GValue* value)
{
#line 78 "../src/Objects/Printer.vala"
	value->data[0].v_pointer = NULL;
#line 4775 "Printer.c"
}

static void
printers_printer_value_color_level_free_value (GValue* value)
{
#line 78 "../src/Objects/Printer.vala"
	if (value->data[0].v_pointer) {
#line 78 "../src/Objects/Printer.vala"
		printers_printer_color_level_unref (value->data[0].v_pointer);
#line 4785 "Printer.c"
	}
}

static void
printers_printer_value_color_level_copy_value (const GValue* src_value,
                                               GValue* dest_value)
{
#line 78 "../src/Objects/Printer.vala"
	if (src_value->data[0].v_pointer) {
#line 78 "../src/Objects/Printer.vala"
		dest_value->data[0].v_pointer = printers_printer_color_level_ref (src_value->data[0].v_pointer);
#line 4797 "Printer.c"
	} else {
#line 78 "../src/Objects/Printer.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4801 "Printer.c"
	}
}

static gpointer
printers_printer_value_color_level_peek_pointer (const GValue* value)
{
#line 78 "../src/Objects/Printer.vala"
	return value->data[0].v_pointer;
#line 4810 "Printer.c"
}

static gchar*
printers_printer_value_color_level_collect_value (GValue* value,
                                                  guint n_collect_values,
                                                  GTypeCValue* collect_values,
                                                  guint collect_flags)
{
#line 78 "../src/Objects/Printer.vala"
	if (collect_values[0].v_pointer) {
#line 4821 "Printer.c"
		PrintersPrinterColorLevel * object;
		object = collect_values[0].v_pointer;
#line 78 "../src/Objects/Printer.vala"
		if (object->parent_instance.g_class == NULL) {
#line 78 "../src/Objects/Printer.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4828 "Printer.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 78 "../src/Objects/Printer.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4832 "Printer.c"
		}
#line 78 "../src/Objects/Printer.vala"
		value->data[0].v_pointer = printers_printer_color_level_ref (object);
#line 4836 "Printer.c"
	} else {
#line 78 "../src/Objects/Printer.vala"
		value->data[0].v_pointer = NULL;
#line 4840 "Printer.c"
	}
#line 78 "../src/Objects/Printer.vala"
	return NULL;
#line 4844 "Printer.c"
}

static gchar*
printers_printer_value_color_level_lcopy_value (const GValue* value,
                                                guint n_collect_values,
                                                GTypeCValue* collect_values,
                                                guint collect_flags)
{
	PrintersPrinterColorLevel ** object_p;
	object_p = collect_values[0].v_pointer;
#line 78 "../src/Objects/Printer.vala"
	if (!object_p) {
#line 78 "../src/Objects/Printer.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4859 "Printer.c"
	}
#line 78 "../src/Objects/Printer.vala"
	if (!value->data[0].v_pointer) {
#line 78 "../src/Objects/Printer.vala"
		*object_p = NULL;
#line 4865 "Printer.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 78 "../src/Objects/Printer.vala"
		*object_p = value->data[0].v_pointer;
#line 4869 "Printer.c"
	} else {
#line 78 "../src/Objects/Printer.vala"
		*object_p = printers_printer_color_level_ref (value->data[0].v_pointer);
#line 4873 "Printer.c"
	}
#line 78 "../src/Objects/Printer.vala"
	return NULL;
#line 4877 "Printer.c"
}

GParamSpec*
printers_printer_param_spec_color_level (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags)
{
	PrintersPrinterParamSpecColorLevel* spec;
#line 78 "../src/Objects/Printer.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PRINTERS_PRINTER_TYPE_COLOR_LEVEL), NULL);
#line 78 "../src/Objects/Printer.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 78 "../src/Objects/Printer.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 78 "../src/Objects/Printer.vala"
	return G_PARAM_SPEC (spec);
#line 4896 "Printer.c"
}

gpointer
printers_printer_value_get_color_level (const GValue* value)
{
#line 78 "../src/Objects/Printer.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PRINTERS_PRINTER_TYPE_COLOR_LEVEL), NULL);
#line 78 "../src/Objects/Printer.vala"
	return value->data[0].v_pointer;
#line 4906 "Printer.c"
}

void
printers_printer_value_set_color_level (GValue* value,
                                        gpointer v_object)
{
	PrintersPrinterColorLevel * old;
#line 78 "../src/Objects/Printer.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PRINTERS_PRINTER_TYPE_COLOR_LEVEL));
#line 78 "../src/Objects/Printer.vala"
	old = value->data[0].v_pointer;
#line 78 "../src/Objects/Printer.vala"
	if (v_object) {
#line 78 "../src/Objects/Printer.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PRINTERS_PRINTER_TYPE_COLOR_LEVEL));
#line 78 "../src/Objects/Printer.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 78 "../src/Objects/Printer.vala"
		value->data[0].v_pointer = v_object;
#line 78 "../src/Objects/Printer.vala"
		printers_printer_color_level_ref (value->data[0].v_pointer);
#line 4928 "Printer.c"
	} else {
#line 78 "../src/Objects/Printer.vala"
		value->data[0].v_pointer = NULL;
#line 4932 "Printer.c"
	}
#line 78 "../src/Objects/Printer.vala"
	if (old) {
#line 78 "../src/Objects/Printer.vala"
		printers_printer_color_level_unref (old);
#line 4938 "Printer.c"
	}
}

void
printers_printer_value_take_color_level (GValue* value,
                                         gpointer v_object)
{
	PrintersPrinterColorLevel * old;
#line 78 "../src/Objects/Printer.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PRINTERS_PRINTER_TYPE_COLOR_LEVEL));
#line 78 "../src/Objects/Printer.vala"
	old = value->data[0].v_pointer;
#line 78 "../src/Objects/Printer.vala"
	if (v_object) {
#line 78 "../src/Objects/Printer.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PRINTERS_PRINTER_TYPE_COLOR_LEVEL));
#line 78 "../src/Objects/Printer.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 78 "../src/Objects/Printer.vala"
		value->data[0].v_pointer = v_object;
#line 4959 "Printer.c"
	} else {
#line 78 "../src/Objects/Printer.vala"
		value->data[0].v_pointer = NULL;
#line 4963 "Printer.c"
	}
#line 78 "../src/Objects/Printer.vala"
	if (old) {
#line 78 "../src/Objects/Printer.vala"
		printers_printer_color_level_unref (old);
#line 4969 "Printer.c"
	}
}

static void
printers_printer_color_level_class_init (PrintersPrinterColorLevelClass * klass,
                                         gpointer klass_data)
{
#line 78 "../src/Objects/Printer.vala"
	printers_printer_color_level_parent_class = g_type_class_peek_parent (klass);
#line 78 "../src/Objects/Printer.vala"
	((PrintersPrinterColorLevelClass *) klass)->finalize = printers_printer_color_level_finalize;
#line 4981 "Printer.c"
}

static void
printers_printer_color_level_instance_init (PrintersPrinterColorLevel * self,
                                            gpointer klass)
{
#line 78 "../src/Objects/Printer.vala"
	self->ref_count = 1;
#line 4990 "Printer.c"
}

static void
printers_printer_color_level_finalize (PrintersPrinterColorLevel * obj)
{
	PrintersPrinterColorLevel * self;
#line 78 "../src/Objects/Printer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_PRINTER_TYPE_COLOR_LEVEL, PrintersPrinterColorLevel);
#line 78 "../src/Objects/Printer.vala"
	g_signal_handlers_destroy (self);
#line 82 "../src/Objects/Printer.vala"
	_g_free0 (self->color);
#line 83 "../src/Objects/Printer.vala"
	_g_free0 (self->name);
#line 5005 "Printer.c"
}

static GType
printers_printer_color_level_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { printers_printer_value_color_level_init, printers_printer_value_color_level_free_value, printers_printer_value_color_level_copy_value, printers_printer_value_color_level_peek_pointer, "p", printers_printer_value_color_level_collect_value, "p", printers_printer_value_color_level_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PrintersPrinterColorLevelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_printer_color_level_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersPrinterColorLevel), 0, (GInstanceInitFunc) printers_printer_color_level_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType printers_printer_color_level_type_id;
	printers_printer_color_level_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PrintersPrinterColorLevel", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return printers_printer_color_level_type_id;
}

GType
printers_printer_color_level_get_type (void)
{
	static volatile gsize printers_printer_color_level_type_id__once = 0;
	if (g_once_init_enter (&printers_printer_color_level_type_id__once)) {
		GType printers_printer_color_level_type_id;
		printers_printer_color_level_type_id = printers_printer_color_level_get_type_once ();
		g_once_init_leave (&printers_printer_color_level_type_id__once, printers_printer_color_level_type_id);
	}
	return printers_printer_color_level_type_id__once;
}

gpointer
printers_printer_color_level_ref (gpointer instance)
{
	PrintersPrinterColorLevel * self;
	self = instance;
#line 78 "../src/Objects/Printer.vala"
	g_atomic_int_inc (&self->ref_count);
#line 78 "../src/Objects/Printer.vala"
	return instance;
#line 5040 "Printer.c"
}

void
printers_printer_color_level_unref (gpointer instance)
{
	PrintersPrinterColorLevel * self;
	self = instance;
#line 78 "../src/Objects/Printer.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 78 "../src/Objects/Printer.vala"
		PRINTERS_PRINTER_COLOR_LEVEL_GET_CLASS (self)->finalize (self);
#line 78 "../src/Objects/Printer.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 5054 "Printer.c"
	}
}

static void
printers_printer_class_init (PrintersPrinterClass * klass,
                             gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar** _tmp33_;
#line 23 "../src/Objects/Printer.vala"
	printers_printer_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Objects/Printer.vala"
	g_type_class_adjust_private_offset (klass, &PrintersPrinter_private_offset);
#line 23 "../src/Objects/Printer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_printers_printer_get_property;
#line 23 "../src/Objects/Printer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_printers_printer_set_property;
#line 23 "../src/Objects/Printer.vala"
	G_OBJECT_CLASS (klass)->finalize = printers_printer_finalize;
#line 5106 "Printer.c"
	/**************
	     * Properties *
	     **************/
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_IS_ENABLED_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_IS_ENABLED_PROPERTY] = g_param_spec_boolean ("is-enabled", "is-enabled", "is-enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_IS_DEFAULT_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_IS_DEFAULT_PROPERTY] = g_param_spec_boolean ("is-default", "is-default", "is-default", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5114 "Printer.c"
	/**
	     * The type of authentication required for printing to this destination:
	     * "none", "username,password", "domain,username,password", or "negotiate" (Kerberos)
	     */
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_AUTH_INFO_REQUIRED_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_AUTH_INFO_REQUIRED_PROPERTY] = g_param_spec_string ("auth-info-required", "auth-info-required", "auth-info-required", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5121 "Printer.c"
	/**
	     * The human-readable description of the destination such as "My Laser Printer".
	     */
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_INFO_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_INFO_PROPERTY] = g_param_spec_string ("info", "info", "info", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_IS_ACCEPTING_JOBS_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_IS_ACCEPTING_JOBS_PROPERTY] = g_param_spec_boolean ("is-accepting-jobs", "is-accepting-jobs", "is-accepting-jobs", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_STATE_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_STATE_PROPERTY] = g_param_spec_string ("state", "state", "state", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_IS_SHARED_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_IS_SHARED_PROPERTY] = g_param_spec_boolean ("is-shared", "is-shared", "is-shared", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5133 "Printer.c"
	/**
	     * The human-readable location of the destination such as "Lab 4".
	     */
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_LOCATION_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_LOCATION_PROPERTY] = g_param_spec_string ("location", "location", "location", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5139 "Printer.c"
	/**
	     * The human-readable make and model of the destination such as "HP LaserJet 4000 Series".
	     */
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_MAKE_AND_MODEL_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_MAKE_AND_MODEL_PROPERTY] = g_param_spec_string ("make-and-model", "make-and-model", "make-and-model", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5145 "Printer.c"
	/**
	     * Additional comma-delimited state keywords for the destination such as "media-tray-empty-error" and "toner-low-warning".
	     */
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_STATE_REASONS_RAW_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_STATE_REASONS_RAW_PROPERTY] = g_param_spec_string ("state-reasons-raw", "state-reasons-raw", "state-reasons-raw", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_STATE_REASONS_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_STATE_REASONS_PROPERTY] = g_param_spec_string ("state-reasons", "state-reasons", "state-reasons", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5153 "Printer.c"
	/**
	     * The cups_printer_t value associated with the destination.
	     */
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_PRINTER_TYPE_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_PRINTER_TYPE_PROPERTY] = g_param_spec_string ("printer-type", "printer-type", "printer-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/Objects/Printer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PRINTERS_PRINTER_IS_OFFLINE_PROPERTY, printers_printer_properties[PRINTERS_PRINTER_IS_OFFLINE_PROPERTY] = g_param_spec_boolean ("is-offline", "is-offline", "is-offline", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5161 "Printer.c"
	/***********
	     * Signals *
	     ***********/
#line 23 "../src/Objects/Printer.vala"
	printers_printer_signals[PRINTERS_PRINTER_ENABLED_CHANGED_SIGNAL] = g_signal_new ("enabled-changed", PRINTERS_TYPE_PRINTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../src/Objects/Printer.vala"
	printers_printer_signals[PRINTERS_PRINTER_DEFAULT_CHANGED_SIGNAL] = g_signal_new ("default-changed", PRINTERS_TYPE_PRINTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../src/Objects/Printer.vala"
	printers_printer_signals[PRINTERS_PRINTER_DELETED_SIGNAL] = g_signal_new ("deleted", PRINTERS_TYPE_PRINTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../src/Objects/Printer.vala"
	_tmp0_ = g_strdup ("toner-low");
#line 24 "../src/Objects/Printer.vala"
	_tmp1_ = g_strdup ("toner-empty");
#line 24 "../src/Objects/Printer.vala"
	_tmp2_ = g_strdup ("developer-low");
#line 24 "../src/Objects/Printer.vala"
	_tmp3_ = g_strdup ("developer-empty");
#line 24 "../src/Objects/Printer.vala"
	_tmp4_ = g_strdup ("marker-supply-low");
#line 24 "../src/Objects/Printer.vala"
	_tmp5_ = g_strdup ("marker-supply-empty");
#line 24 "../src/Objects/Printer.vala"
	_tmp6_ = g_strdup ("cover-open");
#line 24 "../src/Objects/Printer.vala"
	_tmp7_ = g_strdup ("door-open");
#line 24 "../src/Objects/Printer.vala"
	_tmp8_ = g_strdup ("media-low");
#line 24 "../src/Objects/Printer.vala"
	_tmp9_ = g_strdup ("media-empty");
#line 24 "../src/Objects/Printer.vala"
	_tmp10_ = g_strdup ("offline");
#line 24 "../src/Objects/Printer.vala"
	_tmp11_ = g_strdup ("paused");
#line 24 "../src/Objects/Printer.vala"
	_tmp12_ = g_strdup ("marker-waste-almost-full");
#line 24 "../src/Objects/Printer.vala"
	_tmp13_ = g_strdup ("marker-waste-full");
#line 24 "../src/Objects/Printer.vala"
	_tmp14_ = g_strdup ("opc-near-eol");
#line 24 "../src/Objects/Printer.vala"
	_tmp15_ = g_strdup ("opc-life-over");
#line 24 "../src/Objects/Printer.vala"
	_tmp16_ = g_new0 (gchar*, 16 + 1);
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[0] = _tmp0_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[1] = _tmp1_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[2] = _tmp2_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[3] = _tmp3_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[4] = _tmp4_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[5] = _tmp5_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[6] = _tmp6_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[7] = _tmp7_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[8] = _tmp8_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[9] = _tmp9_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[10] = _tmp10_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[11] = _tmp11_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[12] = _tmp12_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[13] = _tmp13_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[14] = _tmp14_;
#line 24 "../src/Objects/Printer.vala"
	_tmp16_[15] = _tmp15_;
#line 24 "../src/Objects/Printer.vala"
	printers_printer_reasons = _tmp16_;
#line 24 "../src/Objects/Printer.vala"
	printers_printer_reasons_length1 = 16;
#line 24 "../src/Objects/Printer.vala"
	_printers_printer_reasons_size_ = printers_printer_reasons_length1;
#line 43 "../src/Objects/Printer.vala"
	_tmp17_ = g_strdup (NC_ ("printer state", "Low on toner"));
#line 43 "../src/Objects/Printer.vala"
	_tmp18_ = g_strdup (NC_ ("printer state", "Out of toner"));
#line 43 "../src/Objects/Printer.vala"
	_tmp19_ = g_strdup (NC_ ("printer state", "Low on developer"));
#line 43 "../src/Objects/Printer.vala"
	_tmp20_ = g_strdup (NC_ ("printer state", "Out of developer"));
#line 43 "../src/Objects/Printer.vala"
	_tmp21_ = g_strdup (NC_ ("printer state", "Low on a marker supply"));
#line 43 "../src/Objects/Printer.vala"
	_tmp22_ = g_strdup (NC_ ("printer state", "Out of a marker supply"));
#line 43 "../src/Objects/Printer.vala"
	_tmp23_ = g_strdup (NC_ ("printer state", "Open cover"));
#line 43 "../src/Objects/Printer.vala"
	_tmp24_ = g_strdup (NC_ ("printer state", "Open door"));
#line 43 "../src/Objects/Printer.vala"
	_tmp25_ = g_strdup (NC_ ("printer state", "Low on paper"));
#line 43 "../src/Objects/Printer.vala"
	_tmp26_ = g_strdup (NC_ ("printer state", "Out of paper"));
#line 43 "../src/Objects/Printer.vala"
	_tmp27_ = g_strdup (NC_ ("printer state", "Offline"));
#line 43 "../src/Objects/Printer.vala"
	_tmp28_ = g_strdup (NC_ ("printer state", "Stopped"));
#line 43 "../src/Objects/Printer.vala"
	_tmp29_ = g_strdup (NC_ ("printer state", "Waste receptacle almost full"));
#line 43 "../src/Objects/Printer.vala"
	_tmp30_ = g_strdup (NC_ ("printer state", "Waste receptacle full"));
#line 43 "../src/Objects/Printer.vala"
	_tmp31_ = g_strdup (NC_ ("printer state", "The optical photo conductor is near end of life"));
#line 43 "../src/Objects/Printer.vala"
	_tmp32_ = g_strdup (NC_ ("printer state", "The optical photo conductor is no longer functioning"));
#line 43 "../src/Objects/Printer.vala"
	_tmp33_ = g_new0 (gchar*, 16 + 1);
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[0] = _tmp17_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[1] = _tmp18_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[2] = _tmp19_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[3] = _tmp20_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[4] = _tmp21_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[5] = _tmp22_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[6] = _tmp23_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[7] = _tmp24_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[8] = _tmp25_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[9] = _tmp26_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[10] = _tmp27_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[11] = _tmp28_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[12] = _tmp29_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[13] = _tmp30_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[14] = _tmp31_;
#line 43 "../src/Objects/Printer.vala"
	_tmp33_[15] = _tmp32_;
#line 43 "../src/Objects/Printer.vala"
	printers_printer_statuses = _tmp33_;
#line 43 "../src/Objects/Printer.vala"
	printers_printer_statuses_length1 = 16;
#line 43 "../src/Objects/Printer.vala"
	_printers_printer_statuses_size_ = printers_printer_statuses_length1;
#line 5315 "Printer.c"
}

static void
printers_printer_instance_init (PrintersPrinter * self,
                                gpointer klass)
{
#line 23 "../src/Objects/Printer.vala"
	self->priv = printers_printer_get_instance_private (self);
#line 5324 "Printer.c"
}

static void
printers_printer_finalize (GObject * obj)
{
	PrintersPrinter * self;
#line 23 "../src/Objects/Printer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_PRINTER, PrintersPrinter);
#line 167 "../src/Objects/Printer.vala"
	_g_free0 (self->priv->_state);
#line 217 "../src/Objects/Printer.vala"
	_g_free0 (self->priv->_state_reasons_raw);
#line 23 "../src/Objects/Printer.vala"
	G_OBJECT_CLASS (printers_printer_parent_class)->finalize (obj);
#line 5339 "Printer.c"
}

static GType
printers_printer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersPrinterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_printer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersPrinter), 0, (GInstanceInitFunc) printers_printer_instance_init, NULL };
	GType printers_printer_type_id;
	printers_printer_type_id = g_type_register_static (G_TYPE_OBJECT, "PrintersPrinter", &g_define_type_info, 0);
	PrintersPrinter_private_offset = g_type_add_instance_private (printers_printer_type_id, sizeof (PrintersPrinterPrivate));
	return printers_printer_type_id;
}

GType
printers_printer_get_type (void)
{
	static volatile gsize printers_printer_type_id__once = 0;
	if (g_once_init_enter (&printers_printer_type_id__once)) {
		GType printers_printer_type_id;
		printers_printer_type_id = printers_printer_get_type_once ();
		g_once_init_leave (&printers_printer_type_id__once, printers_printer_type_id);
	}
	return printers_printer_type_id__once;
}

static void
_vala_printers_printer_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	PrintersPrinter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_PRINTER, PrintersPrinter);
#line 23 "../src/Objects/Printer.vala"
	switch (property_id) {
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_IS_ENABLED_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_boolean (value, printers_printer_get_is_enabled (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_IS_DEFAULT_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_boolean (value, printers_printer_get_is_default (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_AUTH_INFO_REQUIRED_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_string (value, printers_printer_get_auth_info_required (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_INFO_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_string (value, printers_printer_get_info (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_IS_ACCEPTING_JOBS_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_boolean (value, printers_printer_get_is_accepting_jobs (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_STATE_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_string (value, printers_printer_get_state (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_IS_SHARED_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_boolean (value, printers_printer_get_is_shared (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_LOCATION_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_string (value, printers_printer_get_location (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_MAKE_AND_MODEL_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_string (value, printers_printer_get_make_and_model (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_STATE_REASONS_RAW_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_string (value, printers_printer_get_state_reasons_raw (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_STATE_REASONS_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_string (value, printers_printer_get_state_reasons (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_PRINTER_TYPE_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_string (value, printers_printer_get_printer_type (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_IS_OFFLINE_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		g_value_set_boolean (value, printers_printer_get_is_offline (self));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 5452 "Printer.c"
		default:
#line 23 "../src/Objects/Printer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Objects/Printer.vala"
		break;
#line 5458 "Printer.c"
	}
}

static void
_vala_printers_printer_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	PrintersPrinter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PRINTERS_TYPE_PRINTER, PrintersPrinter);
#line 23 "../src/Objects/Printer.vala"
	switch (property_id) {
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_IS_ENABLED_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		printers_printer_set_is_enabled (self, g_value_get_boolean (value));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_IS_DEFAULT_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		printers_printer_set_is_default (self, g_value_get_boolean (value));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_INFO_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		printers_printer_set_info (self, g_value_get_string (value));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_IS_ACCEPTING_JOBS_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		printers_printer_set_is_accepting_jobs (self, g_value_get_boolean (value));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_STATE_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		printers_printer_set_state (self, g_value_get_string (value));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_IS_SHARED_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		printers_printer_set_is_shared (self, g_value_get_boolean (value));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_LOCATION_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		printers_printer_set_location (self, g_value_get_string (value));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 23 "../src/Objects/Printer.vala"
		case PRINTERS_PRINTER_STATE_REASONS_RAW_PROPERTY:
#line 23 "../src/Objects/Printer.vala"
		printers_printer_set_state_reasons_raw (self, g_value_get_string (value));
#line 23 "../src/Objects/Printer.vala"
		break;
#line 5520 "Printer.c"
		default:
#line 23 "../src/Objects/Printer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Objects/Printer.vala"
		break;
#line 5526 "Printer.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

